{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)

}

Unit Inst_HDD;

{$I SETTINGS.INI}

INTERFACE

{$IFDEF OS2}
Uses CRT_OS2, DOS, PKTX_SCR, PKTX_KEY, PKTX_LFN, VPUTILS;
{$ELSE}
Uses CRT,     DOS, PKTX_SCR, PKTX_KEY, PKTX_LFN;
{$ENDIF}

CONST MaxPath    = 50;
      MaxRecurse = 32;

Var InstPath, OldPath, OwnPath : String;

VAR HDSeekDone : Boolean;
    PKTXPathC  : Byte;
    PKTXPathA  : Array[1..MaxPath] Of String;
    XPPathC    : Byte;
    XPPathA    : Array[1..MaxPath] Of String;

PROCEDURE InitHDDSeek;
PROCEDURE NextHDDSeek;
PROCEDURE CloseHDDSeek;

FUNCTION sReadKey: Char;
PROCEDURE sGetKey(Var Key: tKey);
PROCEDURE sDelay(MS: Word);

{***************************************************************************}
{***************************************************************************}

IMPLEMENTATION

TYPE SType = Record
               SR   : lfnSearchRec;
               Path : String;
               Found: Byte;
             End;

CONST fnothing = 0;
      fXP      = 1;
      fPKEXE   = 2;
      fPKINI   = 4;

VAR RecurseC     : Byte;
    RecurseA     : Array[1..MaxRecurse] Of SType;
    RecurseD     : Char; { #0 -> Ende }
    RecurseError : Byte;

PROCEDURE InitHDDSeek;
BEGIN
  HDSeekDone:=False;
  PKTXPathC:=0;
  XPPathC:=0;
  RecurseC:=0;
  RecurseD:='C';
  RecurseError:=0;
END;

{***************************************************************************}

{$IFDEF OS2}
PROCEDURE CheckDrive;
VAR Drives: DriveSet;
BEGIN
  GetValidDrives(Drives);
  While (Not (RecurseD In Drives)) And (RecurseD<='Z') Do
    Inc(RecurseD);
END;
{$ENDIF}

{***************************************************************************}

PROCEDURE NextHDDSeek;
VAR dofn : Boolean;
    Name : fnStr;
BEGIN
  If HDSeekDone Then Exit
  Else Begin
    If RecurseC=0 Then Begin { neues LW }
      Inc(RecurseC);
      RecurseA[1].Path:=RecurseD+':\';
      RecurseA[1].Found:=fnothing;
      lfnFindFirst(RecurseA[1].Path+'*.*', AnyFile, RecurseA[1].SR);
      RecurseError:=DosError;
    End Else Begin { LW fortsetzen }
      If RecurseError=0 Then Begin { hier weitersuchen }
        dofn:=True;
        If (RecurseA[RecurseC].SR.Attr And Directory<>0) Then Begin
          If (RecurseA[RecurseC].SR.Name.Name[1]<>'.') And (RecurseC<MaxRecurse) Then Begin
            Inc(RecurseC);
            RecurseA[RecurseC].Path:=RecurseA[RecurseC-1].Path+
                                     RecurseA[RecurseC-1].SR.Name.Name+'\';
            RecurseA[RecurseC].Found:=fnothing;
            lfnFindFirst(RecurseA[RecurseC].Path+'*.*', AnyFile,
              RecurseA[RecurseC].SR);
            dofn:=False;

            WriteXYabs(0,24,fLightGray,RecurseA[RecurseC].Path
             +S(80-Length(RecurseA[RecurseC].Path)));
          End;
        End Else Begin { Dateien auswerten }
          Name:=UpcaseStr(RecurseA[RecurseC].SR.Name.Name);

          If Name='PKTXCODE.EXE' Then
            RecurseA[RecurseC].Found:=RecurseA[RecurseC].Found Or fPKEXE
          Else If Name='PKTXCODE.INI' Then
            RecurseA[RecurseC].Found:=RecurseA[RecurseC].Found Or fPKINI
          Else If Name='XP.EXE' Then
            RecurseA[RecurseC].Found:=RecurseA[RecurseC].Found Or fXP;
        End;
        If dofn Then lfnFindNext(RecurseA[RecurseC].SR);
        RecurseError:=DosError;
      End Else Begin {dieses Verz beenden}
        lfnFindClose(RecurseA[RecurseC].SR);

        If (RecurseA[RecurseC].Found And fXP)=fXP Then
          If XPPathC<MaxPath Then Begin
            Inc(XPPathC);
            XPPathA[XPPathC]:=RecurseA[RecurseC].Path;
          End;
        If (RecurseA[RecurseC].Found And (fPKEXE Or fPKINI))=(fPKEXE Or fPKINI) Then
          If (PKTXPathC<MaxPath) And
           (OwnPath<>fnFull(RecurseA[RecurseC].Path)) Then Begin
            Inc(PKTXPathC);
            PKTXPathA[PKTXPathC]:=RecurseA[RecurseC].Path;
          End;

        Dec(RecurseC);
        If RecurseC=0 Then Begin
          Inc(RecurseD);

          {$IFDEF OS2}
          CheckDrive;
          {$ENDIF}

          If RecurseD>'Z' Then Begin
            HDSeekDone:=True;
{$IFDEF German}
            WriteXYabs(0,24,fLightGray,'Alle Laufwerke durchsucht.');
{$ELSE}
            WriteXYabs(0,24,fLightGray,'All drives searched.');
{$ENDIF}
          End;

          RecurseError:=0;
        End Else Begin
          lfnFindNext(RecurseA[RecurseC].SR);
          RecurseError:=DosError;
        End;
      End;
    End;
  End;
END;

{***************************************************************************}

PROCEDURE CloseHDDSeek;
BEGIN
  While RecurseC>0 Do Begin
    lfnFindClose(RecurseA[RecurseC].SR);
    Dec(RecurseC);
  End;
END;

{***************************************************************************}

FUNCTION sReadKey: Char;
BEGIN
  While Not KeyPressed Do
    NextHDDSeek;

  sReadKey:=ReadKey;
END;

{***************************************************************************}

PROCEDURE sGetKey(Var Key: tKey);
BEGIN
  While Not KeyPressed Do
    NextHDDSeek;

  GetKey(Key);
END;

{***************************************************************************}

PROCEDURE sDelay(MS: Word);
{ gettime(ds) kann nur 18tel sekungen auflsen! }
VAR S: LongInt;
BEGIN
  S:=GetTimeReal+(MS Div 100);
  While (GetTimeReal<S) And (Not KeyPressed) Do
    NextHDDSeek;
END;

{***************************************************************************}

BEGIN
  OwnPath:=UpcaseStr(fnDir(ParamStr(0)));
END.
