{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)

}

Unit INST_INI;

{$I SETTINGS.INI}

{ 09.11.96 - Fehler in LoadINIFile / DBPath, LOGXPAREA behoben
  15.11.96 - Fehler in CreateRegMsg / Non-Fido behoben
  31.12.96 - Fehler in Logmeldung: Interzonenmails behoben
  23.02.97 - verschiedene Boxer erhalten versch. Batchdateien
  06.03.97 - Fehler bei Logmailarea behoben
}

INTERFACE

{$IFDEF OS2}
Uses CRT_OS2,
{$ELSE}
Uses
{$ENDIF}
              DOS, PKTX_KEY, PKTX_SCR, PKTX_IO, PKTX_LFN, PKTX_MEM, INST_HDD,
              Strings, crt;

PROCEDURE LoadINIFile;
PROCEDURE SaveINIFile;
PROCEDURE ReleaseMemory;
PROCEDURE XPEinbindung;
PROCEDURE CreateRegMSG;
PROCEDURE CheckOldDB;

IMPLEMENTATION

{***************************************************************************}
{ INI-File }
{***************************************************************************}

const domain      : pText  = NIL;
      bnkoutbound : String = '';

PROCEDURE LoadINIFile;
CONST mNone      = 0;
      mGeneral   = 1;
      mDArea     = 2;
      mMArea     = 3;
      mEPath     = 4;
      mNMFilter  = 5;
      mFilter    = 6;
      mTextShort = 7;
      mTextSend  = 8;

VAR F                : Text;
    Line, L2         : String;
    Mode             : Byte;
    LCount           : LongInt;
    Buffer           : Pointer;

  FUNCTION GetQuotMarkTxt(Var Txt: String): Boolean;
  BEGIN
    If (Copy(Txt, 1, 1)='"') And (Copy(Txt, Length(Txt), 1)='"')
      Then Begin
        Txt:=Copy(Txt, 2, Length(Txt)-2);
        GetQuotMarkTxt:=True;
      End Else GetQuotMarkTxt:=False;
  END;

  FUNCTION GetDupeHandling(Txt: String): Byte;
  BEGIN
    If Txt='SKIP'            Then GetDupeHandling:=dupSkip
    Else If Txt='RENAME'     Then GetDupeHandling:=dupRenameFile
    Else If Txt='RENAMEEXT'  Then GetDupeHandling:=dupRenameExt
    Else If Txt='OVERWRITE'  Then GetDupeHandling:=dupOverwrite
    Else If Txt='COMPARE'    Then GetDupeHandling:=dupCompare
    Else If Txt='COMPAREALL' Then GetDupeHandling:=dupCompareAll
    Else If Txt='KEEP'       Then GetDupeHandling:=dupKeep
    { kein Error }
    Else GetDupeHandling:=DupeHandling;
  END;

  PROCEDURE DoLineExtractPath; Forward;

  PROCEDURE DoLineGeneral;
  VAR i                  : Byte;
      Command, Arg, Arg2 : String[127]; { Arg2: ohne Upcase }

    FUNCTION YesNo(Var B): Boolean;
    VAR Bo : Boolean absolute B;
    BEGIN
      If Arg='YES' Then Begin
        Bo:=True;
        YesNo:=True
      End Else If Arg='NO' Then Begin
        Bo:=False;
        YesNo:=True;
      End Else YesNo:=False;
    END;

  BEGIN
   i:=Pos('=', Line);
   If i<>0 Then Begin
    Command:=Copy(Line,1,i-1);
    Arg:=Copy(Line,i+1,255);
    Arg2:=Copy(L2,i+1,255);
    CompressStr(Arg);
    CompressStr(Arg2);

    { Pfade }
    If Command='DATABASEPATH' Then Begin
      DBPath:=fnFull(Arg2);
{      If Not lfnExistCreatePath(DBPath) Then Error:=DBPath+notexist;}
    End Else If Command='EXTRACTPATH' Then Begin
      ExtPath:=fnFull(Arg2);
{      If Not lfnExistCreatePath(ExtPath) Then Error:=ExtPath+notexist;}
    End Else If Command='EXTRACTBADPATH' Then Begin
      ExtBadPath:=fnFull(Arg2);
{      If Not lfnExistCreatePath(ExtBadPath) Then Error:=ExtBadPath+notexist;}
    End Else If Command='LOGPATH' Then Begin
      LogPath:=fnFull(Arg2);
{      If Not lfnExistCreatePath(LogPath) Then Error:=LogPath+notexist;}
    End Else If Command='LOGSUMPATH' Then Begin
      LogSumPath:=fnFull(Arg2);
{      If Not lfnExistCreatePath(LogSumPath) Then Error:=LogSumPath+notexist;}

    { Zahlen }
    End Else If Command='DELDAYS' Then Begin
      Deldays:=Value(Arg);
{      If Deldays<0 Then Error:=TxtDelday;}
    End Else If Command='CRITICALSUBJLEN' Then Begin
      If Value(Arg)>255 Then {Error:=TxtCtcSubj}
      Else CriticalSubjLen:=Value(Arg);

    { Texte }
    End Else If Command='LOGMAILAREA' Then Begin
      If GetQuotMarkTxt(Arg2) Then LogMailArea:=Arg2
{ alte Version }
      Else LogMailArea:='/'+Arg2;
{      Else Error:=TxtAnfZeich+L2};
    End Else If Command='FILEDESCSTYLE' Then Begin
      If GetQuotMarkTxt(Arg2) Then CreateDescStyle:=Arg2
{      Else Error:=TxtAnfZeich+L2;}
    End Else If Command='TEXTMARK' Then Begin
      If GetQuotMarkTxt(Arg2) Then TextMark:=Arg2
{      Else Error:=TxtAnfZeich+L2}
    End Else If Command='SPLITTEXT' Then Begin
      If GetQuotMarkTxt(Arg2) Then SplitText:=Arg2
{      Else Error:=TxtAnfZeich+L2}

    { Schalter }
    End Else If Command='AUTOFILEEXTENSION' Then Begin
      YesNo(AutoFileExtension)
    End Else If Command='FORCEFILEJOINING' Then Begin
      YesNo(ForceFileJoining)
    End Else If Command='ZIPMAGIC95COMPATIBILITY' Then Begin
      YesNo(ZipMagic95Comp)
    End Else If Command='USELONGNAMES' Then Begin
      If Not YesNo(lfnUseLongNames) Then
        If Arg='FORCE' Then lfnUseLongNames:=lfnUForce
{      Else Error:=TxtCommand+L2;} { Funktionswert egal }
    End Else If Command='USEBASE64HEADER' Then Begin
      If Not YesNo(UseBase64Header) Then
        If Arg='AUTO' Then UseBase64Header:=b64Auto
{      Else Error:=TxtCommand+L2;}
    End Else If Command='MEMSIZE' Then Begin
      If Arg='AUTO' Then XMemSize:=AutoMemSize
      Else Begin
        XMemSize:=Value(Arg);
{        If XMemSize>MaxMemSize Then Error:=TxtMemSize;}
      End;
    End Else If Command='DUPEHANDLING' Then Begin
      DupeHandling:=GetDupeHandling(Arg)

    { differenzierte Werte }
    End Else If Command='FILEDESC' Then Begin
      CreateDesc:=descNone;

      While Length(Arg)>0 Do Begin
        i:=Pos(',', Arg);
        If i=0 Then i:=Length(Arg)+1;

        If      Copy(Arg,1,i-1)='BBS'   Then CreateDesc:=CreateDesc Or descBBS
        Else If Copy(Arg,1,i-1)='4DOS'  Then CreateDesc:=CreateDesc Or desc4DOS
        Else Begin
{          Error:=TxtCommand+L2+' ('+Copy(Arg,1,i-1)+')';}
          Arg:='';
        End;
        Delete(Arg,1,i);
        CompressStr(Arg);
      End;
    End Else If Command='LOGLEVEL' Then Begin
      LogLevel:=logNone;

      While Length(Arg)>0 Do Begin
        i:=Pos(',', Arg);
        If i=0 Then i:=Length(Arg)+1;

        If      Copy(Arg,1,i-1)='EXTRACT'       Then LogLevel:=LogLevel Or logExtract
        Else If Copy(Arg,1,i-1)='FILEDESC'      Then LogLevel:=LogLevel Or logFileDesc
        Else If Copy(Arg,1,i-1)='ERRORS'        Then LogLevel:=LogLevel Or logErrors
        Else If Copy(Arg,1,i-1)='DELETE'        Then LogLevel:=LogLevel Or logDelete
        Else If Copy(Arg,1,i-1)='RENAME'        Then LogLevel:=LogLevel Or logRename
        Else If Copy(Arg,1,i-1)='SKIP'          Then LogLevel:=LogLevel Or logSkip
        Else If Copy(Arg,1,i-1)='OVERWRITE'     Then LogLevel:=LogLevel Or logOverWrite
        Else If Copy(Arg,1,i-1)='STATISTICDATA' Then LogLevel:=LogLevel Or logSummaryData
        Else If Copy(Arg,1,i-1)='STATISTICEVER' Then LogLevel:=LogLevel Or logSummaryEver
        Else If Copy(Arg,1,i-1)='ALL'           Then LogLevel:=LogLevel Or logAll
        Else Begin
{          Error:=TxtCommand+L2+' ('+Copy(Arg,1,i-1)+')';}
          Arg:='';
        End;
        Delete(Arg,1,i);
        CompressStr(Arg);
      End;

     { *** alte Version *** }
    End Else If Command='ALLOWLONGNAMES' Then Begin
      YesNo(lfnUseLongNames)
    End Else If Command='LOGXPAREA' Then Begin
      If Length(Arg)>0 Then LogMailArea:='/'+Arg2;
    End Else If Command='EXTRACTPATHAREA=' Then Begin
      Delete(Line,1,16);
      If Copy(Line,Length(Line)-1,2)=',I' Then Begin
        Dec(Line[0],2);
        DoLineExtractPath;
      End Else If Copy(Line,Length(Line)-1,2)=',B' Then Begin
        Dec(Line[0],2);
        Line:=Line+'*';
        DoLineExtractPath;
      End Else If Copy(Line,Length(Line)-1,2)=',C' Then Begin
        Dec(Line[0],2);
        Insert('*', Line, Pos(',', Line)+1);
        Line:=Line+'*';
        DoLineExtractPath;
      End Else DoLineExtractPath;;

    End{ Else Error:=TxtCommand+L2};
   End;
  END;

  PROCEDURE DoLineDecodeArea;
  {-*assembler*}
  VAR p, p2: pDecodeArea;
  BEGIN
    If ((Line[1]='+') Or (Line[1]='-')) And (Length(Line)>1) Then Begin
      If DecodeAreaCount<DecodeAreaCountMax Then Begin
        Inc(DecodeAreaCount);

        p:=DecodeAreaP;
        If p=NIL Then Begin
          New(p);
          DecodeAreaP:=p;
        End Else Begin
          While p^.Next<>NIL Do
            p:=p^.Next;

          New(p2);
          p^.Next:=p2;
          p:=p2;
        End;

        p^.Next:=NIL;
        p^.Positive:=(Line[1]='+');
        p^.Area:=Copy(Line,2,255);
      End {Else Error:=TxtMaxArea1+ST(DecodeAreaCountMax,1)+TxtMaxArea2};
    End {Else Error:=TxtLine+Line};
  END;

  PROCEDURE DoLineModifyArea;
  {*assembler*,no/shorten/delete/maydelete,pkt+text+zconnect}
  VAR p, p2        : pModifyArea;
      Area         : String;
      Mode, Typ, i : Byte;
      LineErr      : Boolean;
  BEGIN
    LineErr:=False;

    i:=1;
    While (i<=Length(Line)) And (Line[i]<>',') Do Inc(i);
    Area:=Copy(Line,1,i-1);

    Delete(Line,1,i);
    i:=1;
    While (i<=Length(Line)) And (Line[i]<>',') Do Inc(i);
    If      Copy(Line,1,i-1)='NO'        Then Mode:=mmNo
    Else If Copy(Line,1,i-1)='SHORTEN'   Then Mode:=mmShorten
    Else If Copy(Line,1,i-1)='DELETE'    Then Mode:=mmDelete
    Else If Copy(Line,1,i-1)='MAYDELETE' Then Mode:=mmMayDelete
    Else LineErr:=True;

    Typ:=0;
    Delete(Line,1,i);
    Repeat
      i:=Pos('+', Line);
      If i=0 Then i:=Length(Line)+1;

      If      Copy(Line,1,i-1)='PKT'      Then Typ:=Typ Or ptPKT
      Else If Copy(Line,1,i-1)='MSG'      Then Typ:=Typ Or ptMSG
      Else If Copy(Line,1,i-1)='ZCONNECT' Then Typ:=Typ Or ptZConnect
      Else If Copy(Line,1,i-1)='TEXT'     Then Typ:=Typ Or ptUnknown
      Else LineErr:=True;

      Delete(Line,1,i);
    Until Length(Line)=0;

    If (Not LineErr) Then Begin
      If (ModifyAreaCount<ModifyAreaCountMax) Then Begin
        Inc(ModifyAreaCount);

        p:=ModifyAreaP;
        If p=NIL Then Begin
          New(p);
          ModifyAreaP:=p;
        End Else Begin
          While p^.Next<>NIL Do
            p:=p^.Next;

          New(p2);
          p^.Next:=p2;
          p:=p2;
        End;

        p^.Next:=NIL;
        p^.Area:=Area;
        p^.Mode:=Mode;
        p^.Typ :=Typ;
      End {Else Error:=TxtMaxArea1+ST(ModifyAreaCountMax,1)+TxtMaxArea2};
    End {Else Error:=TxtLine+L2};
  END;

  PROCEDURE DoLineExtractPath;
  { D:\PKTXCODE\ASM,skip,ASSEMBLER.GER,"JPG" }
  { alt: Path,Area }
  VAR EP, EP2          : pExtractPath;
      i                : Byte;
      LineErr          : Boolean;
  BEGIN
    If ExtractPathCount<ExtractPathCountMax Then Begin
      Inc(ExtractPathCount);
      LineErr:=False;

      EP:=ExtractPathP;
      If EP=NIL Then Begin
        New(EP);
        ExtractPathP:=EP;
      End Else Begin
        While EP^.Next<>NIL Do
          EP:=EP^.Next;

        New(EP2);
        EP^.Next:=EP2;
        EP:=EP2;
      End;
      EP^.Next:=NIL;

      i:=1;
      While (i<=Length(Line)) And (Line[i]<>',') Do Inc(i);
      EP^.Path:=fnFull(Copy(L2,1,i-1));

      Delete(Line,1,i);
      i:=1;
      While (i<=Length(Line)) And (Line[i]<>',') Do Inc(i);

      If i<=Length(Line) Then Begin { neue Versoin }
        If i>1
          Then EP^.DupeHandling:=GetDupeHandling(Copy(Line,1,i-1))
          Else EP^.DupeHandling:=255;

        Delete(Line,1,i);
        i:=1;
        If Copy(Line,1,1)=',' Then EP^.AreaUse:=False
        Else Begin
          EP^.AreaUse:=True;
          EP^.Area:=Copy(Line,1,255);
          i:=Pos(',', EP^.Area);
          If i=0 Then LineErr:=True;

          EP^.Area[0]:=Chr(i-1);
        End;

        Delete(Line,1,i);
        If Length(Line)=0 Then EP^.ExtUse:=False
        Else Begin
          If Copy(Line,1,1)<>'"' Then LineErr:=True;

          EP^.ExtUse:=True;
          EP^.Ext:=Copy(Line,2,3);

          i:=Pos('"', EP^.Ext);
          If i<>0 Then EP^.Ext[0]:=Chr(i-1);
        End;
      End Else Begin { alte Version }
        EP^.DupeHandling:=DupeHandling;
        EP^.Area:=Copy(Line,1,255);
        EP^.AreaUse:=True;
        EP^.ExtUse:=False;
      End;

{      If LineErr Then Error:=TxtLine+L2
      Else If Not lfnExistCreatePath(EP^.Path) Then Error:=EP^.Path+notexist;}
    End{ Else Error:=TxtmaxArea1+ST(ExtractPathCountMax,1)+TxtMaxArea2;}
  END;

  PROCEDURE doLineNetmailFilter;
  VAR i: Byte;
      p: pFilterNM;
  BEGIN
    If FilterNMP=NIL Then Begin
      New(FilterNMP);
      p:=FilterNMP;
    End Else Begin
      p:=FilterNMP;
      While p^.Next<>NIL Do
        p:=p^.Next;
      New(p^.Next);
      p:=p^.Next;
    End;

    If Copy(Line,1,1)='+' Then p^.Positive:=True
    Else Begin
      p^.Positive:=False;
{      If Copy(Line,1,1)<>'-' Then Error:=TxtCommand+Line;}
    End;
    Delete(Line, 1, 1);

    i:=Pos('@',Line);
    If i=0 Then p^.Addr.Name:=''
    Else Begin
      p^.Addr.Name:={UpcaseStr(}Copy(Line,1,i-1);
      Delete(Line,1,i);
    End;

    If Not GetFidoAddr(Line, p^.Addr.Addr) Then {Error:=TxtAddr+Line};

    p^.AnyZone :=p^.Addr.Addr.Zone =TmpAny;
    p^.AnyNet  :=p^.Addr.Addr.Net  =TmpAny;
    p^.AnyNode :=p^.Addr.Addr.Node =TmpAny;
    p^.AnyPoint:=p^.Addr.Addr.Point=TmpAny;

    p^.Next:=NIL;
  END;

  PROCEDURE DoLineFilter;
  VAR Command : String;
      Arg     : String;
      i       : Byte;

    PROCEDURE doDomain;
    VAR p : pText;
    BEGIN
      if domain=nil then begin
        new(domain);
        p:=domain;
      end else begin
        p:=domain;
        while p^.next<>NIL do
          p:=p^.next;
        new(p^.next);
        p:=p^.next;
      end;

      p^.next:=NIL;
      p^.line:=arg;
    END;

    PROCEDURE doAka;
    VAR p, p2 : pAka;
        Addr  : tFidoAddr2;
    BEGIN
      If GetFidoAddr(Arg, Addr) Then Begin
        New(p);
        p^.Addr:=Addr;
        p^.Next:=NIL;

        If AkaList=NIL Then Begin
          AkaList:=p;
        End Else Begin
          p2:=AkaList;
          While p2^.Next<>NIL Do
            p2:=p2^.Next;

          p2^.Next:=p;
        End;
      End;
    END;

    PROCEDURE doOutBoundPath;
    BEGIN
      bnkoutbound:=fnFull(Arg);
    END;

    PROCEDURE doFilePath;
    BEGIN
      BnkFilePath:=fnFull(Arg);
    END;

    PROCEDURE doSend(Var Send: tSendTyp);
    {SENDMSG=MSG,,ATTACH,257,913}
    VAR i: Byte;
        error:boolean;
    BEGIN
      error:=false;

      If Copy(L2,1,3)='MSG' Then Send.Typ:=ptMSG
      Else Begin
        Send.Typ:=ptPKT;
        If Copy(L2,1,3)<>'PKT' Then Error:=true;
      End;

      If not Error Then Begin
        Delete(L2,1,4);
        Delete(Arg,1,4);
        If Copy(L2,1,1)=',' Then Begin
          Send.Path:='';
          Delete(L2,1,1);
        End Else Begin
          i:=Pos(',', L2);
          Send.Path:=fnFull(Copy(Arg,1,i-1));
          Delete(L2,1,i);
        End;

        If not Error Then Begin
          If Copy(L2,1,7)='BINKLEY' Then Begin
            Send.Mode:=smBinkley;
            Delete(L2,1,8);
          End Else Begin
            Send.Mode:=smAttach;
            Delete(L2,1,7);
          End;

          i:=Pos(',',L2);
          If i=0 Then Begin
            Send.Attr1:=Value(L2);
          End Else Begin
            Send.Attr1:=Value(Copy(L2,1,i-1));
            Send.Attr2:=Value(Copy(L2,i+1,255));
          End;
        End;
      End;
    END;

    FUNCTION YesNo: Boolean;
    BEGIN
      If L2='YES' Then YesNo:=True
      Else {If Arg='NO' Then} YesNo:=False
{      Else Error:=TxtCommand+L2;} { Funktionswert egal }
    END;

  BEGIN
    Command:=Line;
    i:=Pos('=', Command);
    If i<>0 Then Command[0]:=Chr(i-1);

    Arg:=Copy(L2, i+1, 255);
    L2:=UpCaseStr(Arg);

    If Command='DOMAIN' Then doDomain
    Else If Command='AKA' Then doAka
    Else If Command='OUTBOUNDPATH' Then doOutBoundPath
    Else If Command='FILEPATH' Then doFilePath
    Else If Command='MINSIZE' Then BnkMinCodeSize:=Value(Arg)
    Else If Command='HOLDDAYS' Then BnkHoldDays:=Value(Arg)
    Else If Command='ATTACHMESSAGE' Then AttachMessage:=YesNo
    Else If Command='ATTACHPATH' Then AttachPath:=YesNo
    Else If Command='SENDMSG' Then DoSend(SendMsg)
    Else If Command='SENDPKT' Then DoSend(SendPkt);
  END;

  PROCEDURE DoLineShortText;
  VAR p: pText;
  BEGIN
    If ShortText=NIL Then Begin
      New(ShortText);
      p:=ShortText;
    End Else Begin
      p:=ShortText;
      While p^.Next<>NIL Do
        p:=p^.Next;
      New(p^.Next);
      p:=p^.Next;
    End;

    p^.Line:=L2;
    p^.Next:=NIL;
  END;

  PROCEDURE DoLineSendText;
  VAR p: pText;
  BEGIN
    If SendText=NIL Then Begin
      New(SendText);
      p:=SendText;
    End Else Begin
      p:=SendText;
      While p^.Next<>NIL Do
        p:=p^.Next;
      New(p^.Next);
      p:=p^.Next;
    End;

    p^.Line:=L2;
    p^.Next:=NIL;
  END;


BEGIN
  LCount:=0;

  FileMode:=roFileMode;
  Assign(F, InstPath+IniName);
  Reset(F);
  If IOResult<>0 Then {Error:=TxtReadErr}
  Else Begin
    GetMem(Buffer, 8192);
    SetTextBuf(F, Buffer^, 8192);

    {Error:='';}
    Mode:=mNone;
    While (Not EOF(F)) {And (Error[0]=#0)} Do Begin
      Readln(F, L2);
      Inc(LCount);
      CompressStr(L2);
      If (Copy(L2,1,1)<>';') And
       ((Length(L2)>0) Or (Mode=mTextShort) Or (Mode=mTextSend)) Then Begin
        Line:=UpcaseStr(L2);

        If Mode=mNone Then Begin
          If Line='[GENERAL]' Then Mode:=mGeneral
          Else If Line='[DECODEAREA]' Then Mode:=mDArea
          Else If Line='[MODIFYAREA]' Then Mode:=mMArea
          Else If Line='[EXTRACTPATH]' Then Mode:=mEPath
          Else If Line='[NETMAILFILTER]' Then Mode:=mNMfilter
          Else If Line='[FILTERSETTINGS]' Then Mode:=mFilter
          Else If Line='[SHORTTEXT]' Then Mode:=mTextShort
          Else If Line='[SENDTEXT]' Then Mode:=mTextSend;
        End Else If Line='[END]' Then Mode:=mNone
        Else If Mode=mDArea Then DoLineDecodeArea
        Else If Mode=mMArea Then DoLineModifyArea
        Else If Mode=mEPath Then DoLineExtractPath
        Else If Mode=mNMFilter Then DoLineNetmailFilter
        Else If Mode=mFilter Then DoLineFilter
        Else If Mode=mTextShort Then DoLineShortText
        Else If Mode=mTextSend Then DoLineSendText
        Else {If Mode=mGeneral Then} DoLineGeneral;
      End;
    End;
    Close(F);
    FreeMem(Buffer, 8192);
  End;

  { Version feststellen }
{  WriteHeader;}

{  If Error='' Then Begin
    If DBPath='' Then Error:=TxtDBErr
    Else If ExtPath='' Then Error:=TxtExtErr
    Else If ExtBadPath='' Then Error:=TxtExtBErr;
  End;
  If Error<>'' Then Begin
    If LCount>0 Then Begin
      Writeln(TxtError1, LCount,TxtError2);
      Writeln(TxtReason+Error);
    End Else WriteLn(Error);

    ErrorAbort:=eaHalt;
  End;}
END;

PROCEDURE ReleaseMemory;
VAR EP : pExtractPath;
    MP : pModifyArea;
    AP : pDecodeArea;
BEGIN
  While ExtractPathP<>NIL Do Begin
    EP:=ExtractPathP;
    ExtractPathP:=EP^.Next;
    Dispose(EP);
  End;
  ExtractPathCount:=0;

  While ModifyAreaP<>NIL Do Begin
    MP:=ModifyAreaP;
    ModifyAreaP:=MP^.Next;
    Dispose(MP);
  End;
  ModifyAreaCount:=0;

  While DecodeAreaP<>NIL Do Begin
    AP:=DecodeAreaP;
    DecodeAreaP:=AP^.Next;
    Dispose(AP);
  End;
  DecodeAreaCount:=0;
END;

{***************************************************************************}

PROCEDURE SaveINIFile;
CONST mNone      = 0;
      mGeneral   = 1;
      mDArea     = 2;
      mMArea     = 3;
      mEPath     = 4;
      mNMFilter  = 5;
      mFilter    = 6;
      mTextShort = 7;
      mTextSend  = 8;

VAR F1               : Text;
    F2               : lfnTextBuf;
    Line, L2         : String;
    Mode             : Byte;
    LCount           : LongInt;
    Buffer           : Pointer;
    Error            : Boolean;

  FUNCTION DupeHandlingStr(B: Byte): String;
  BEGIN
    Case B Of
      dupSkip        : DupeHandlingStr:='SKIP';
      dupRenameFile  : DupeHandlingStr:='RENAME';
      dupRenameExt   : DupeHandlingStr:='RENAMEEXT';
      dupOverwrite   : DupeHandlingStr:='OVERWRITE';
      dupCompare     : DupeHandlingStr:='COMPARE';
      dupCompareAll  : DupeHandlingStr:='COMPAREALL';
      dupKeep        : DupeHandlingStr:='KEEP';
    Else DupeHandlingStr:='';
    End;
  END;

  FUNCTION YesNo(Var Buffer; Txt: S80): S80;
  VAR B : Byte absolute Buffer;
  BEGIN
    If B=0 Then YesNo:='NO'
    Else If B=1 Then YesNo:='YES'
    Else YesNo:=Txt;
  END;

  PROCEDURE DoLineDecodeArea;
  VAR p   : pDecodeArea;
      Out : Char;
  BEGIN
    While DecodeAreaP<>NIL Do Begin
      p:=DecodeAreaP;
      If p^.Positive Then Out:='+'
      Else Out:='-';

      lfnWriteTextFile(F2, Out+p^.Area);

      DecodeAreaP:=p^.Next;
      Dispose(p);

      Dec(DecodeAreaCount);
    End;
  END;

  PROCEDURE DoLineModifyArea;
  VAR p   : pModifyArea;
      S   : String;
  BEGIN
    While ModifyAreaP<>NIL Do Begin
      p:=ModifyAreaP;

      S:=p^.Area+',';
      Case p^.Mode of
        mmNo        : S:=S+'NO';
        mmShorten   : S:=S+'SHORTEN';
        mmDelete    : S:=S+'DELETE';
        mmMayDelete : S:=S+'MAYDELETE';
      End;

      S:=S+',';
      If p^.Typ And ptUnknown <>0 Then S:=S+'TEXT+';
      If p^.Typ And ptPKT     <>0 Then S:=S+'PKT+';
      If p^.Typ And ptMSG     <>0 Then S:=S+'MSG+';
      If p^.Typ And ptZConnect<>0 Then S:=S+'ZCONNECT+';

      Dec(S[0]);
      lfnWriteTextFile(F2, S);

      ModifyAreaP:=p^.Next;
      Dispose(p);

      Dec(ModifyAreaCount);
    End;
  END;

  PROCEDURE DoLineExtractPath;
  VAR EP          : pExtractPath;
      S           : String;
  BEGIN
    While ExtractPathP<>NIL Do Begin
      EP:=ExtractPathP;

      S:=EP^.Path+','+DupeHandlingStr(EP^.DupeHandling)+',';
      { bei 255 wird nichts ausgegeben }
      If EP^.AreaUse Then S:=S+EP^.Area;
      S:=S+',';

      If EP^.ExtUse Then S:=S+'"'+EP^.Ext+'"';

      lfnWriteTextFile(F2, S);

      ExtractPathP:=EP^.Next;
      Dispose(EP);

      Dec(ExtractPathCount);
    End;
  END;

  PROCEDURE DoLineGeneral;
  VAR i                : Byte;
      Comm, Comm2, Arg : String[127];
  BEGIN
    If Copy(Line,1,1)=';' Then Comm:=Copy(Line,2,255)
    Else Comm:=Line;

    i:=Pos('=', Comm);
    If i=0 Then Comm:=''
    Else Begin
      Comm2:=Copy(Comm,1,i);
      Comm[0]:=Chr(i-1);
    End;

    { Pfade }
    If Comm='DATABASEPATH' Then Begin
      L2:=Comm2+DBPath;
    End Else If Comm='EXTRACTPATH' Then Begin
      L2:=Comm2+ExtPath;
    End Else If Comm='EXTRACTBADPATH' Then Begin
      L2:=Comm2+ExtBadPath;
    End Else If Comm='LOGPATH' Then Begin
      If Length(LogPath)>0 Then L2:=Comm2+LogPath;
    End Else If Comm='LOGSUMPATH' Then Begin
      If Length(LogSumPath)>0 Then L2:=Comm2+LogSumPath;

    { Zahlen }
    End Else If Comm='DELDAYS' Then Begin
      L2:=Comm2+ST(Deldays,1)
    End Else If Comm='CRITICALSUBJLEN' Then Begin
      If CriticalSubjLen<>255 Then L2:=Comm2+ST(CriticalSubjLen,1);

    { Texte }
    End Else If Comm='LOGMAILAREA' Then Begin
      If LogMailArea<>'' Then L2:=Comm2+'"'+LogMailArea+'"';
    End Else If Comm='FILEDESCSTYLE' Then Begin
      If CreateDescStyle<>'' Then L2:=Comm2+'"'+CreateDescStyle+'"';
    End Else If Comm='TEXTMARK' Then Begin
      If TextMark<>'' Then L2:=Comm2+'"'+TextMark+'"';
    End Else If Comm='SPLITTEXT' Then Begin
      If SplitText<>'' Then L2:=Comm2+'"'+SplitText+'"';

    { Schalter }
    End Else If Comm='AUTOFILEEXTENSION' Then Begin
      L2:=Comm2+YesNo(AutoFileExtension,'');
    End Else If Comm='FORCEFILEJOINING' Then Begin
      L2:=Comm2+YesNo(ForceFileJoining,'');
    End Else If Comm='ZIPMAGIC95COMPATIBILITY' Then Begin
      L2:=Comm2+YesNo(ZipMagic95Comp,'');
    End Else If Comm='USELONGNAMES' Then Begin
      L2:=Comm2+YesNo(lfnUseLongNames,'FORCE');
    End Else If Comm='USEBASE64HEADER' Then Begin
      L2:=Comm2+YesNo(UseBase64Header,'AUTO');
    End Else If Comm='MEMSIZE' Then Begin
      If XMemSize=AutoMemSize Then L2:=Comm2+'AUTO'
      Else L2:=Comm2+ST(xMemSize,1);
    End Else If Comm='DUPEHANDLING' Then Begin
      L2:=Comm2+DupeHandlingStr(DupeHandling)

    { differenzierte Werte }
    End Else If Comm='FILEDESC' Then Begin
      Arg:='';
      If CreateDesc And descBBS<>0 Then Arg:=Arg+', BBS';
      If CreateDesc And desc4DOS<>0 Then Arg:=Arg+', 4DOS';

      Delete(Arg,1,2);
      If Length(Arg)>0 Then L2:=Comm2+Arg;
    End Else If Comm='LOGLEVEL' Then Begin
      If LogLevel=logAll Then Arg:='ALL'
      Else Begin
        Arg:='';
        If LogLevel And logExtract    <>0 Then Arg:=Arg+',EXTRACT';
        If LogLevel And logFileDesc   <>0 Then Arg:=Arg+',FILEDESC';
        If LogLevel And logErrors     <>0 Then Arg:=Arg+',ERRORS';
        If LogLevel And logDelete     <>0 Then Arg:=Arg+',DELETE';
        If LogLevel And logRename     <>0 Then Arg:=Arg+',RENAME';
        If LogLevel And logSkip       <>0 Then Arg:=Arg+',SKIP';
        If LogLevel And logOverwrite  <>0 Then Arg:=Arg+',OVERWRITE';
        If LogLevel And logSummaryData<>0 Then Arg:=Arg+',STATISTICDATA';
        If LogLevel And logSummaryEver<>0 Then Arg:=Arg+',STATISTICEVER';

        Delete(Arg,1,1);
      End;
      L2:=Comm2+Arg;
    End;
  END;

  PROCEDURE doLineNetmailFilter;
  VAR S           : String;
      p: pFilterNM;
  BEGIN
    While FilterNMP<>NIL Do Begin
      p:=FilterNMP;

      If p^.Positive Then S:='+'
      Else S:='-';
      If p^.Addr.Name<>'' Then S:=S+p^.Addr.Name+'@';

      if p^.anyzone then s:=s+'*'
      else s:=s+st(p^.addr.addr.zone,1);
      s:=s+':';
      if p^.anynet then s:=s+'*'
      else s:=s+st(p^.addr.addr.net,1);
      s:=s+'/';
      if p^.anynode then s:=s+'*'
      else s:=s+st(p^.addr.addr.node,1);

      if p^.addr.addr.ispoint then begin
        s:=s+'.';
        if p^.anypoint then s:=s+'*'
        else s:=s+st(p^.addr.addr.point,1);
      end;

      filternmp:=p^.next;
      dispose(p);
      lfnWriteTextFile(F2, S);
    End;
  END;

  PROCEDURE DoLineFilter;
  VAR i                : Byte;
      Comm, Comm2, Arg : String[127];

    PROCEDURE doDomain;
    VAR p : pText;
    BEGIN
      while domain<>NIL do begin
        lfnWriteTextFile(F2, 'DOMAIN='+domain^.line);
        p:=domain;
        domain:=p^.next;
        dispose(p);
      end;
    END;

    PROCEDURE doAka;
    VAR p     : pAka;
    BEGIN
      while akalist<>NIL do begin
        lfnWriteTextFile(F2, 'AKA='+writefidoaddr(akalist^.addr));
        p:=akalist;
        akalist:=akalist^.next;
        dispose(p);
      end;
    END;

    PROCEDURE doSend(Var Send: tSendTyp);
    {SENDMSG=MSG,,ATTACH,257,913}
    VAR i: Byte;
    BEGIN
      L2:=Comm2;

      If Send.Typ=ptMSG Then L2:=L2+'MSG'
      Else L2:=L2+'PKT';

      L2:=L2+','+Send.Path+',';
      If Send.Mode=smBinkley Then
        L2:=L2+'BINKLEY,'+ST(Send.Attr1,1)
      Else
        L2:=L2+'ATTACH,'+ST(Send.Attr1,1)+','+ST(Send.Attr2,1);
    END;

  BEGIN
    If Copy(Line,1,1)=';' Then Comm:=Copy(Line,2,255)
    Else Comm:=Line;

    i:=Pos('=', Comm);
    If i=0 Then Comm:=''
    Else Begin
      Comm2:=Copy(Comm,1,i);
      Comm[0]:=Chr(i-1);
    End;

    If Comm='FILEPATH' Then
      L2:=Comm2+BnkFilePath
    Else If Comm='MINSIZE' Then
      L2:=Comm2+ST(BnkMinCodeSize,1)
    Else If Comm='HOLDDAYS' Then
      L2:=Comm2+ST(BnkHoldDays,1)
    Else If Comm='OUTBOUNDPATH' Then
      L2:=Comm2+BnkOutbound
    Else If Comm='ATTACHMESSAGE' Then
      L2:=Comm2+YesNo(AttachMessage,'')
    Else If Comm='ATTACHPATH' Then
      L2:=Comm2+YesNo(AttachPath,'')
    Else If Comm='DOMAIN' Then doDomain
    Else If Comm='AKA' Then doAka
    Else If Comm='SENDMSG' Then DoSend(SendMsg)
    Else If Comm='SENDPKT' Then DoSend(SendPkt);
  END;

  PROCEDURE DoLineShortText;
  VAR p: pText;
  BEGIN
    if shorttext=NIL then exit;

    while copy(l2,1,1)=';' do begin
      readln(f1, l2);
      if copy(l2,1,1)=';' then lfnWriteTextFile(F2, l2);
    end;

    while shorttext<>NIL do begin
      lfnWriteTextFile(F2, shorttext^.line);
      p:=shorttext;
      shorttext:=p^.next;
      dispose(p);
    end;

    while line<>'[END]' do begin
      Readln(F1, L2);
      line:=UpcaseStr(L2);
    end;
    Mode:=mNone
  END;

  PROCEDURE DoLineSendText;
  VAR p: pText;
  BEGIN
    if sendtext=NIL then exit;

    while copy(l2,1,1)=';' do begin
      readln(f1, l2);
      if copy(l2,1,1)=';' then  lfnWriteTextFile(F2, l2);
    end;

    while sendtext<>NIL do begin
      lfnWriteTextFile(F2, sendtext^.line);
      p:=sendtext;
      sendtext:=p^.next;
      dispose(p);
    end;

    while line<>'[END]' do begin
      Readln(F1, L2);
      line:=UpcaseStr(L2);
    end;
    Mode:=mNone
  END;

BEGIN
  If DBPath='' Then DBPath:=InstPath+'DATABASE\';
  If ExtPath='' Then ExtPath:=InstPath+'FILES\';
  If ExtBadPath='' Then ExtBadPath:=InstPath+'BAD\';

  lfnCreatePath(DBPath);
  lfnCreatePath(ExtPath);
  lfnCreatePath(ExtBadPath);


  If lfnExistFile(InstPath+'PKTXCODE.IN_') Then
    lfnEraseFile(InstPath+'PKTXCODE.IN_');

  Error:=False;
  FileMode:=roFileMode;
  Assign(F1, OwnPath+IniName);
  ReSet(F1);
  GetError;
  If Result=0 Then Begin
    If lfnExistFile(InstPath+IniName) Then
      lfnRenameFile(InstPath+IniName, InstPath+'PKTXCODE.IN_');

    lfnOpenTextFile(F2, InstPath+IniName, ofCreate);
    If Result=0 Then Begin
      Mode:=mNone;
      While (Not EOF(F1)) And (Result=0) Do Begin
        Readln(F1, L2);
        If (Length(L2)>0) Then Begin
          Line:=UpcaseStr(L2);

          If Mode=mNone Then Begin
            If Line='[GENERAL]' Then Mode:=mGeneral
            Else If Line='[DECODEAREA]' Then Mode:=mDArea
            Else If Line='[MODIFYAREA]' Then Mode:=mMArea
            Else If Line='[EXTRACTPATH]' Then Mode:=mEPath
            Else If Line='[NETMAILFILTER]' Then Mode:=mNMfilter
            Else If Line='[FILTERSETTINGS]' Then Mode:=mFilter
            Else If Line='[SHORTTEXT]' Then Mode:=mTextShort
            Else If Line='[SENDTEXT]' Then Mode:=mTextSend;
          End Else If Line='[END]' Then Begin
            If Mode=mDArea Then DoLineDecodeArea
            Else If Mode=mMArea Then DoLineModifyArea
            Else If Mode=mEPath Then DoLineExtractPath
            Else If Mode=mNMFilter Then DoLineNetmailFilter;
            Mode:=mNone
          End Else Begin
            If Mode=mGeneral Then DoLineGeneral
            Else If Mode=mFilter Then DoLineFilter
            Else If Mode=mTextShort Then DoLineShortText
            Else If Mode=mTextSend Then DoLineSendText;
          End;
        End;
        lfnWriteTextFile(F2, L2);
        GetError;
      End;

      If Result<>0 Then Error:=True;

      {$IFNDEF OS2}
      Line:=FileRec(F2.F).Name;
      InstPath:=fnDir(Line);
      {$ENDIF}

      lfnCloseTextFile(F2);
    End;
    Close(F1);
    GetError;
  End Else Error:=True;

  If Error Then ErrorAbort:=eaInstWriteINIFile
  Else ErrorAbort:=eaInstReady;
END;

{***************************************************************************}

PROCEDURE XPEinbindung;
TYPE tFileName = String[12];
CONST MaxBFG = 20;
VAR SR       : lfnSearchRec;
    Boxes, i : Byte;
    F1, F2   : Text;
    Error    : Boolean;
    S        : String;
    BFG      : Array[1..MaxBFG] Of tFileName;

  FUNCTION AnalysiereFilter: String;
  VAR Alt    : String;
      CurDir : PathStr;
      Name   : String;
      CrtName: tFNStr;
      i      : Byte;

    PROCEDURE ChangeBatch;
    VAR F     : Text;
        S     : String;
        Found : Boolean;
    BEGIN
      Assign(F, Name);
      ReSet(F);
      GetError;
      If Result=0 Then Begin
        Found:=False;
        While (Not EOF(F)) And (Not Found) Do Begin
          ReadLn(F, S);
          If Pos('PKTXCODE', UpCaseStr(S))<>0 Then Found:=True;
        End;
        Close(F);
        GetError;

        If Not Found Then Begin
          Append(F);
          GetError;
          If Result=0 Then Begin
            WriteLn(F, '@'+InstPath+'PKTXCODE.EXE %1');
            Close(F);
            GetError;
          End Else Error:=True;
        End;
      End Else Error:=True;
    END;

    PROCEDURE CreateBatch;
    VAR F: Text;
        i: Byte;
    BEGIN
      While lfnExistFile(InstPath+CrtName.Name) Do
        GetNextName(CrtName, dupRenameFile);

      Assign(F, InstPath+CrtName.Name);
      ReWrite(F);
      GetError;
      If Result=0 Then Begin
        While Pos('$PUFFER', UpCaseStr(Alt))<>0 Do Begin
          i:=Pos('$PUFFER', UpCaseStr(Alt));
          Delete(Alt,i,7);
          Insert('%1',Alt,i);
        End;

        WriteLn(F, '@ECHO OFF');
        WriteLn(F, Alt);
        WriteLn(F, InstPath+'PKTXCODE.EXE %1');
        Close(F);
        GetError;
      End Else Error:=True;
    END;

    FUNCTION Ext(Path: PathStr): ExtStr;
    VAR Dir                 : DirStr;
        Name                : NameStr;
        Ext2                : ExtStr;
    BEGIN
      FSplit(Path, Dir, Name, Ext2);
      Ext:=Ext2
    END;

  BEGIN
    Alt:=Copy(S,16,255);
    { 1. gar nichts oder PKTXCODE installiert }
    If (Alt='') Or (Pos('PKTXCODE', UpCaseStr(Alt))<>0) Then
      AnalysiereFilter:=InstPath+'PKTXCODE.EXE $PUFFER'
    Else Begin
    {2. anderes Programm installiert: Batch-Datei ?}
      Name:=Alt;
      i:=1;
      While (i<=Length(Name)) Do
        If Name[i]=' ' Then Delete(Name, i, 255)
        Else Inc(i);

      Name:=UpCaseSTr(Name);
      If Ext(Name)='' Then Begin
        GetDir(0, CurDir);
        GetError;
        ChDir(InstPath);
        GetError;

        If lfnExistFile(Name+'.BAT') Then Begin
          Name:=Name+'.BAT';
          Name:=lfnFExpand(Name);
        End;
        ChDir(CurDir);
        GetError;
      End;

      If (Ext(Name)='.BAT') And (lfnExistFile(Name)) Then Begin
        ChangeBatch;
        AnalysiereFilter:=Alt;
      End Else Begin
        If Pos('PKTXCALL', UpCaseStr(Alt))<>0 Then Alt:='rem '+Alt;
        CrtName.Name:='PKTXCALL.BAT';
        CrtName.Long:=False;
        CreateBatch;
        AnalysiereFilter:=InstPath+CrtName.Name+' $PUFFER';
      End;
    End;
  END;

  PROCEDURE EditXPCFG(Name: tFileName);
  BEGIN
    Assign(F1, InstPath+Name);
    ReSet(F1);
    GetError;
    If Result=0 Then Begin
      Assign(F2, InstPath+'PKTXCODE.TMP');
      ReWrite(F2);
      GetError;
      If Result=0 Then Begin
        While (Not EOF(F1)) And (Result=0) Do Begin
          ReadLn(F1, S);
          GetError;
          If Copy(S,1,15)='Eingangsfilter=' Then
            S:=Copy(S,1,15)+AnalysiereFilter;

          WriteLn(F2, S);
          GetError;
        End;

        Close(F2);
        GetError;
      End Else Error:=True;
      Close(F1);
      GetError;
    End Else Error:=True;

    If Not Error Then Begin
      Erase(F1);
      GetError;
      If Result=0 Then Begin
        lfnRenameFile(InstPath+'PKTXCODE.TMP', InstPath+Name);
        GetError;
        If Result<>0 Then Error:=True;
      End Else Error:=True;
    End;
  END;

BEGIN
  OpenWaitWindow('ndere XP-Konfiguration');

  Boxes:=0;
  Error:=False;

  lfnFindFirst(InstPath+'*.BFG', AnyFile, SR);
  While (DosError=0) And (Boxes<=MaxBFG) Do Begin
    Inc(Boxes);
    If Boxes<=MaxBFG Then BFG[Boxes]:=SR.Name.Name;

    lfnFindNext(SR);
  End;
  lfnFindClose(SR);

  If Boxes>MaxBFG Then Error:=True
  Else
    For i:=1 To Boxes Do
      EditXPCFG(BFG[i]);

  If (Boxes=0) Or (Error) Then ErrorAbort:=eaInstEditXP;

  CloseWindow;
END;

{***************************************************************************}

PROCEDURE CreateRegMSG;
VAR F              : Text;
  {$IFNDEF OS2}
    Year, Month,
    Day, DayOfWeek : Word;
  {$ELSE}
    Year, Month,
    Day, DayOfWeek : LongInt;
  {$ENDIF}
    Key            : tKey;
    XPBox          : String;
    Asked          : Boolean;
    i              : Byte;
    SR             : lfnSearchRec;
    S              : String;

  FUNCTION AskOK: Boolean;
  BEGIN
{$IFDEF German}
    OpenWindow(59,12,fWhite+bBlue,1);
    WriteXY(2,2,fWhite+bBlue,'PKTXCODE ist Freeware. Das Installatinsprogramm kann');
    WriteXY(2,3,fWhite+bBlue,'nun eine Installationsmeldung an den Autor senden (es');
    WriteXY(2,4,fWhite+bBlue,'erstellt eine Nachricht im Nachrichtenausgang von XP).');
    WriteXY(2,5,fWhite+bBlue,'Diese Nachricht hilft dem Autor einzuschtzen, wieviele');
    WriteXY(2,6,fWhite+bBlue,'Leute dieses Programm benutzen. Diese Nachricht ist');
    WriteXY(2,7,fWhite+bBlue,'absolut unverbindlich und dient nur statistischen');
    WriteXY(2,8,fWhite+bBlue,'Zwecken. Sind Sie damit einverstanden, da diese');
    WriteXY(2,9,fWhite+bBlue,'Installationsmeldung geschickt wird (J/J) ?');
{$ELSE}
    OpenWindow(50,12,fWhite+bBlue,1);
    WriteXY(2,2,fWhite+bBlue,'PKTXCODE is freeware. The installation program');
    WriteXY(2,3,fWhite+bBlue,'can now send an installation notice to its');
    WriteXY(2,4,fWhite+bBlue,'author (it creates a mail in your XP outbound');
    WriteXY(2,5,fWhite+bBlue,'file). This mail helps the author evaluating');
    WriteXY(2,6,fWhite+bBlue,'how many people use this program. It does not');
    WriteXY(2,7,fWhite+bBlue,'bind you to anything and is for statistic');
    WriteXY(2,8,fWhite+bBlue,'purposes only. Do you agree to sending this');
    WriteXY(2,9,fWhite+bBlue,'mail (Y/Y) ?');
{$ENDIF}

    Repeat
      GetKey(Key);
    Until (Key.UpChar='J') Or (Key.UpChar='Y') Or (Key.UpChar='N') Or (Key.Scan=kbESC);
    CloseWindow;

    AskOK:=(Key.UpChar='J') Or (Key.UpChar='Y');
  END;

BEGIN
  If XPPathC=0 Then Exit;

  Asked:=False;
  For i:=1 To XPPathC Do Begin
    XPBox:='';
    lfnFindFirst(XPPathA[i]+'*.BFG', AnyFile, SR);
    While (DosError=0) And (XPBox='') Do Begin
      Assign(F, XPPathA[i]+SR.Name.Name);
      ReSet(F);
      GetError;
      If Result=0 Then Begin
        While (Not EOF(F)) And (XPBox='') Do Begin
          ReadLn(F, S);
          If (Copy(S,1,8)='Boxname=') Then
            If Copy(S,9,2)='2:' Then XPBox:=Copy(S,9,255);
        End;

        Close(F);
        GetError;
      End;

      lfnFindNext(SR);
    End;
    lfnFindClose(SR);

    If XPBox<>'' Then Begin
      If Not Asked Then Begin
        Asked:=AskOK;
        If Not Asked Then Exit;
      End;

      If lfnExistPath(XPPathA[i]+'AUTOEXEC') Then Begin
        GetDate(Year, Month, Day, DayOfWeek);
        If Year<1998 Then Begin
          Assign(F, XPPathA[i]+'AUTOEXEC\PKTXCODE.MSG');
          ReWrite(F);
          GetError;
          If Result=0 Then Begin
            WriteLn(F, 'Empfaenger: PKTXCODEs Home@2:2453/20.20');
{$IFDEF German}
            WriteLn(F, 'Betreff: '+verName+' - Installationsmeldung');
{$ELSE}
            WriteLn(F, 'Betreff: '+verName+' - installation notice');
{$ENDIF}
            WriteLn(F, 'Server: '+XPBox);
            WriteLn(F);
            WriteLn(F, 'Hallo Uli!');
{$IFDEF German}
            WriteLn(F, verName+' wurde heute auf diesem System installiert.');
            WriteLn(F, 'Diese Nachricht wurde automatisch erstellt.');
{$ELSE}
            WriteLn(F, verName+' has been installed on this system today.');
            WriteLn(F, 'This mail was created automatically.');
{$ENDIF}
            Close(F);
            GetError;
          End;
        End;
      End;
    End;
  End;
END;

{***************************************************************************}

PROCEDURE CheckOldDB;
VAR Key: tKey;
    SR : lfnSearchRec;
    F  : Boolean;
BEGIN
  F:=False;
  lfnFindFirst(DBPath+'*.', AnyFile, SR);
  While (DosError=0) And (Not F) Do Begin
    If (SR.Attr And (Directory Or VolumeID)=0) Then F:=True;
    lfnFindNext(SR);
  End;
  lfnFindClose(SR);

  If F Or (lfnExistFile(DBPath+'PKTXCODE.DAT') And
    (Not lfnExistFile(DBPath+'PKTXCODE.IDX'))) Then Begin

{$IFDEF German}
    OpenWindow(42,9,fWhite+bBlue,1);
    WriteXY(2,2,fWhite+bBlue, 'Im Datenbankverzeichnis befinden sich');
    WriteXY(2,3,fWhite+bBlue, 'wahrscheinlich Dateien einer lteren');
    WriteXY(2,4,fWhite+bBlue, 'Version. Diese Version kann mit diesen');
    WriteXY(2,5,fWhite+bBlue, 'Dateien nichts anfangen. Sollen diese');
    WriteXY(2,6,fWhite+bBlue, 'Dateien gelscht werden? (J/N)');
{$ELSE}
    OpenWindow(40,8,fWhite+bBlue,1);
    WriteXY(2,2,fWhite+bBlue, 'There are probably files of an older');
    WriteXY(2,3,fWhite+bBlue, 'version in the database directory.');
    WriteXY(2,4,fWhite+bBlue, 'This version cannot use these files.');
    WriteXY(2,5,fWhite+bBlue, 'Do you want to delete them (Y/N) ?');
{$ENDIF}

    Repeat
      GetKey(Key);
    Until (Key.UpChar='J') Or (Key.UpChar='Y') Or (Key.UpChar='N')
     Or (Key.Scan=kbESC);

    CloseWindow;

    If Key.UpChar='J' Then Begin
{$IFDEF German}
      OpenWaitWindow('lsche Dateien');
{$ELSE}
      OpenWaitWindow('deleting files');
{$ENDIF}

      lfnEraseFile(DBPath+'PKTXCODE.DAT');
      lfnFindFirst(DBPath+'*.', AnyFile, SR);
      While (DosError=0) Do Begin
        lfnEraseFile(DBPath+SR.Name.Name);
        lfnFindNext(SR);
      End;
      lfnFindClose(SR);

      CloseWindow;
    End;

  End;
END;

{***************************************************************************}

END.
