{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)

}

Unit PKTX_APP;

{$I SETTINGS.INI}

{ 27.10.96 BinHexDecode auf Outfield umgelenkt
           Programmablauf anhand JobExec
  30.10.96 Anpassung an neuen IDXEntry-Format
           Cursortasten bei Listfunktion
           Anzeige, welcher Kodiertyp verwendet
  17.11.96 Binhex prft Headergre
  27.11.96 Bug in ExtractManul: View erased entrys, behoben
  13.01.97 Bug in ExtractFile bei Binhexerror behoben
  10.02.97 ExtractManual: auflsen und verbinden von Daten
  09.04.98 UserExtractPath hinzugefgt
  17.04.98 SwapLongint/2 korrigiert
           alternative CRC-Prfung, BAD-Flag bei FileExtract

}

INTERFACE

{$IFDEF OS2}
Uses CRT_OS2,
{$ELSE}
Uses CRT,
{$ENDIF}
     DOS,
     PKTX_IO,
     PKTX_SCR,
     PKTX_MEM,
     PKTX_DB,
     PKTX_KEY,
     PKTX_LFN
{$IFDEF Binkley}
    ,PKTX_BNK
{$ENDIF}
     ;


PROCEDURE ExtractDataBase;
PROCEDURE ListDataBase;
PROCEDURE ExtractDatabaseManuel;
PROCEDURE TestIniFile;
PROCEDURE AnalyseParam;
PROCEDURE CheckOldFileList;

IMPLEMENTATION

Const UserExtractPath : String = '';

{***************************************************************************}
{ CRC Funktion }
{***************************************************************************}

  CONST CRCStart = $0000;

  Function Crc16(Var Data; CRC, wo_Size: Word) : Word; Assembler;
  Asm
{$IFDEF OS2} push   esi                   {$ELSE} push ds                    {$ENDIF}
{$IFDEF OS2} push   ebx                   {$ELSE}                            {$ENDIF}
{$IFDEF OS2} mov    esi, Data             {$ELSE} lds si, Data               {$ENDIF}
{$IFDEF OS2} movzx  edx, CRC              {$ELSE} mov dx, CRC                {$ENDIF}
{$IFDEF OS2} movzx  ebx, wo_Size          {$ELSE} mov bx, wo_Size            {$ENDIF}
           @L1:
             xor    ah, ah
             lodsb
{$IFDEF OS2} xor    ecx, ecx              {$ELSE} mov cx, 8                  {$ENDIF}
{$IFDEF OS2} mov    cl,  8                {$ELSE}                            {$ENDIF}
             shl    ax, cl
             xor    dx, ax
             mov    cx, 8
           @L2:
             shl    dx, 1
             jnc    @L3
             xor    dx, $1021
           @L3:
             loop   @L2
             dec    bx
             jnz    @L1

{$IFDEF OS2} movzx  eax, dx               {$ELSE} mov    ax, dx              {$ENDIF}
{$IFDEF OS2} pop    ebx                   {$ELSE}                            {$ENDIF}
{$IFDEF OS2} pop    esi                   {$ELSE} pop  ds                    {$ENDIF}
  End;

{***************************************************************************}
{ Dateien extrahieren }
{***************************************************************************}

PROCEDURE ExtractDatabaseFile(IDXPos: LongInt; Bad: Boolean);
{ Datei ab Datenbankeintrag "IDXPos" erstellen }
CONST bheBadHeader   = 1; { Werte fr bhError }
      bheReadError   = 2;
      bheBadFile     = 3;
      bheIllegalCode = 4;
      bheCRCError    = 5;
      bheFCreateError= 6;
      bheWriteFile   = 7;

      feNo           = 0; { Werte fr bhFileEnd }
      feLoading      = 1;
      feEndmarker    = 2;
      feDecompressed = 4;
      feAllDone      = 8;

TYPE tBuffer         = Array[0..65527] Of Byte;
VAR IDX1, IDX2       : tIDXEntry;
    j                : LongInt;
    InFileOpen       : Boolean;
    InFileSize       : LongInt;
    InFilePos        : LongInt;
    OutFile          : File;
    OutFileOpen      : Boolean;
    OutFileSize      : LongInt;
    LogFileOpened    : Boolean;
    Path             : String;
    DupeHandUse      : Byte;
    rFileName,                 {benutzter name, idx.r=geplanter name}
    dFileName,                 {dupeFilename wg. dupehandling}
    oFileName        : tFNStr; {Kopie des org. langen Namens fr renbatch}
    overWritten      : Boolean;
    bhFileEnd        : Byte;       { Dateiende erreicht }
    bhError          : Byte;

    IsZipFile        : Boolean;

  {.........................................................................}

  PROCEDURE WriteFileDesc;
  VAR F     : lfnTextBuf;
      ok    : Boolean;
      FName : String;
      Desc  : String;
      i     : Byte;
  BEGIN
    Desc:=CreateDescStyle;
    i:=Pos('$SUBJECT', UpcaseStr(Desc));
    While i<>0 Do Begin
      Delete(Desc, i, Length('$SUBJECT'));
      Insert(IDX1.SubjStr, Desc, i);

      i:=Pos('$SUBJECT', UpcaseStr(Desc));
    End;

    i:=Pos('$AREA', UpcaseStr(Desc));
    While i<>0 Do Begin
      Delete(Desc, i, Length('$AREA'));
      Insert(IDX1.AreaStr, Desc, i);

      i:=Pos('$AREA', UpcaseStr(Desc));
    End;

    If CreateDesc And descBBS=descBBS Then Begin
      lfnOpenTextFile(F, Path+'FILES.BBS', ofAppend);

      If Result=0 Then Begin
        FName:=rFileName.Name;
        While Length(FName)<12 Do
          FName:=FName+' ';

        lfnWriteTextFile(F, FName+' '+Desc);
        lfnCloseTextFile(F);
      End;
    End;

    If CreateDesc And desc4DOS=desc4DOS Then Begin
      lfnOpenTextFile(F, Path+'DESCRIPT.ION', ofAppend);
      If Result=0 Then Begin
        lfnWriteTextFile(F, rFileName.Name+' '+Desc);
        lfnCloseTextFile(F);
        SetFAttr(F.F, Hidden);
        GetError;
      End;
    End;
  END;

  {.........................................................................}

  PROCEDURE WriteLogFileInternal(Txt: String);
  BEGIN
    If Not LogFileOpened Then Begin
      If logLevel And logRename<>0 Then
        WriteLogFile(Path+IDX1.rFileName.Name) { geplanter Dateiname }
      Else
        WriteLogFile(Path+rFileName.Name);    { echter Dateiname }
      LogFileOpened:=True;
    End;

    WriteLogFile('  '+Txt);
  END;

  {.........................................................................}

  PROCEDURE OpenOutFile(Var Buf);

    PROCEDURE CheckExtension;
    TYPE ExtData   = Record
                       Len : Byte;
                       Dat : Array[0..5] Of Char;
                       Erw : String[3];
                     End;
    CONST ExtCount = 14;
    CONST Data     : Array[1..ExtCount] Of ExtData =
                   (( Len: 6; Dat: 'Rar!'#$1A#07            ; Erw: 'RAR'),
                    ( Len: 2; Dat: 'PK'                     ; Erw: 'ZIP'),
                    ( Len: 2; Dat: #$60#$EA                 ; Erw: 'ARJ'),
                    ( Len: 2; Dat: #$1A#$08                 ; Erw: 'ARC'),
                    ( Len: 2; Dat: #$1A#$09                 ; Erw: 'ARC'),
                    ( Len: 2; Dat: #$1A#$0B                 ; Erw: 'PAK'),
                    ( Len: 3; Dat: 'ZOO'                    ; Erw: 'ZOO'),
                    ( Len: 5; Dat: 'HLSQZ'                  ; Erw: 'SQZ'),
                    ( Len: 4; Dat: 'RIFF'                   ; Erw: 'WAV'),
                    ( Len: 6; Dat: 'Creati'                 ; Erw: 'VOC'),
                    ( Len: 4; Dat: 'MThd'                   ; Erw: 'MID'),
                    ( Len: 6; Dat: #$FF#$D8#$FF#$E0#$00#$10 ; Erw: 'JPG'),
                    ( Len: 2; Dat: 'BM'                     ; Erw: 'BMP'),
                    ( Len: 4; Dat: 'GIF8'                   ; Erw: 'GIF') );

    VAR Buffer : Array[0..5] Of Char absolute Buf;
        i, j   : Byte;
        ok     : Boolean;
        OldName: fnStr;
    BEGIN
      i:=0;
      ok:=False;
      While (i<ExtCount) And (Not ok) Do Begin
        Inc(i);
        ok:=True;
        For j:=0 To Data[i].Len-1 Do
          If Buffer[j]<>Data[i].Dat[j] Then ok:=False;
      End;

      If ok Then Begin
        OldName:=rFileName.Name;
        j:=Length(rFileName.Name);
        While (j>0) And (rFileName.Name[j]<>'.') Do Dec(j);
        If j=0 Then j:=Length(rFileName.Name)
        Else Delete(rFileName.Name,j,255);
        rFileName.Name:=rFileName.Name+'.'+Data[i].Erw;

        If UpCaseStr(OldName)=UpCaseStr(rFileName.Name) Then
          rFileName.Name:=OldName;
      End;
    END;

  {$IFDEF German}
  CONST TxtDeleted   = '* gelscht, da Datei mit selbem Namen bereits existiert';
        TxtPassed    = 'bergangen';
        TxtCreate1   = 'Fehler beim Erstellen';
        TxtCreate2   = 'Fehler beim Erstellen von ';
        TxtOverwrite = '* alte Datei wurde berschrieben';
        TxtKeep      = '* bergangen, da Datei mit selbem Namen bereits existiert';
  {$ELSE}
  CONST TxtDeleted   = '* deleted, because filename is alread in use';
        TxtPassed    = 'passed';
        TxtCreate1   = 'error creating file';
        TxtCreate2   = 'error creating ';
        TxtOverwrite = '* old file has been overwritten';
        TxtKeep      = '* keeped in database, because filename is alread in use';
  {$ENDIF}
  CONST RenCountMax = 16384;
  VAR CError  : Boolean;
      Counter : LongInt;
      Buffer  : Array[0..5] Of Char absolute Buf;
  BEGIN
    OutFileOpen:=False;
    CError:=False;

    IsZipFile:=ZipMagic95Comp And (Buffer[0]='P') And (Buffer[1]='K');
    If IsZipFile Then Buffer[0]:=#0;

    { 1. Extension, 2. Pfad, 3. langer Name }

    rFileName:=IDX1.rFileName;
    If AutoFileExtension Then CheckExtension;

    If Bad Then Begin
      Path:=ExtBadPath;
      DupeHandUse:=DupeHandling;
    End Else GetExtractPath(IDX1.AreaStr, rFileName, Path, DupeHandUse);
    If UserExtractPath<>'' Then Path:=UserExtractPath;

    {$IFDEF Binkley}
    If IDX1.BnkMode=bnkDecode Then Begin
      Path:=BnkFilePath;

      If (IDX1.PktType=ptPKT) And (SendPKT.Mode=smAttach)
       Then
        If SendPKT.Path='' Then Path:=fnFull(IDX1.Inbound)
        Else Path:=SendPKT.Path;
      If (IDX1.PktType=ptMSG) And (SendMSG.Mode=smAttach)
       Then
        If SendMSG.Path='' Then Path:=fnFull(IDX1.Inbound)
        Else Path:=SendMSG.Path;

      DupeHandUse:=dupRenameExt;
    End;
    {$ENDIF}

    If (lfnUseLongNames=lfnUNo) Or (Not lfnDriveSupportsLFN(Path[1]))
     Or (IDX1.BnkMode=bnkDecode) Then Begin
      oFileName:=rFileName;
      lfnShortenFileName(rFileName.Name);
      rFileName.Long:=False;

      If lfnUseLongNames=lfnUNo Then
        lfnShortenFilename(IDX1.rFileName.Name); { ursprngl Name }
        { keine Anzeige wg. Krzung }

      If UpcaseStr(rFileName.Name)=UpcaseStr(oFileName.Name) Then
        oFileName.Name:=''; { keine Batch-Datei }
    End Else oFileName.Name:='';

    dFileName:=rFileName; { unter diesem Namen sollte angelegt werden }

    { Logmail }
    If logLevel And logFileDesc<>0 Then Begin
      WriteLogFileInternal('- "'+IDX1.SubjStr+'"');
      WriteLogFileInternal('- Area: '+IDX1.AreaStr);
    End;
    OverWritten:=False;
    If lfnExistFile(Path+rFileName.Name) Then Begin
      If dupeHandUse=dupSkip Then Begin
        UpdateFileCreateWindow(IDX1.rFileName.Name, TxtPassed);

        If logLevel And logSkip<>0 Then WriteLogFileInternal(TxtDeleted);

        If IDX1.Flag And ifVComplete<>0 Then { vollst. Datei -> lschen }
          Repeat
            ReadIDX(j, IDX2);
            IDX2.Flag:=IDX2.Flag Or ifErase;
            WriteIDX(j, IDX2);
            j:=IDX2.Link;
            Inc(OutFileSize, IDX2.dSize);
          Until (j=ilUnlinked) Or (IDX2.Flag And ifVEnd<>0);

        bhError:=bheFCreateError;
        OutFileOpen:=False;
      End Else If dupeHandUse=dupOverwrite Then Begin
        OverWritten:=True;
      End Else If (dupeHandUse=dupRenameFile) Or (dupeHandUse=dupRenameExt)
       Or (dupeHandUse=dupCompare) Or (dupeHandUse=dupCompareAll) Then Begin
        If Not IsZipFile Then Begin
          Counter:=0;

          Repeat
            GetNextName(rFileName, dupeHandUse);
            inc(Counter);
            UpdateFileCreateWindow(rFileName.Name, '');
          Until (Not lfnExistFile(Path+rFileName.Name))
            Or (Counter=RenCountMax);

          If Counter=RenCountMax Then CError:=True;
        End;
      End Else If dupeHandUse=dupKeep Then Begin
        UpdateFileCreateWindow(IDX1.rFileName.Name, TxtPassed);

        If logLevel And logSkip<>0 Then WriteLogFileInternal(TxtKeep);
        bhError:=bheFCreateError;
        OutFileOpen:=False;
      End;
    End;

    If bhError<>0 Then Exit;

    If Not CError Then Begin
      UpdateFileCreateWindow(IDX1.rFileName.Name, '');

      lfnOpenFile(OutFile, Path+rFileName.Name, ofCreate);
      If Result=0 then xMemOpenFile(OutFile, xcWrite, OutField^, OutPos);
      If Result=0 Then Begin
        OutFileOpen:=True;
      End;
    End;

    If CError Or (Result<>0) Then Begin
      UpdateFileCreateWindow(IDX1.rFileName.Name, TxtCreate1);
      If logLevel And logErrors<>0 Then
        WriteLogFile(TxtCreate2+Path+rFileName.Name);

      bhError:=bheFCreateError;
    End;

  { Logmail }
    If (logLevel And logSkip<>0) And (OverWritten) Then
      WriteLogFileInternal(TxtOverwrite);
  END;

  {........................................................................}

  PROCEDURE SaveDataFile(Size: Word);
  VAR X : Word;
  BEGIN
    If Not OutFileOpen Then Begin
      X:=OutPos;
      OpenOutFile(OutField^);
      OutPos:=X;
    End;

    If bhError=0 Then Begin
      If Size=BlockSize Then Begin
        xMemAppendFile(OutFile, OutField^);
        If Result<>0 Then bhError:=bheWriteFile;

        OutPos:=0;
      End;

      If (ErrorAbort=eaDatFileRead) Then
        bhError:=bheWriteFile;

      Inc(OutFileSize, Size);
{$IFDEF German}
      UpdateFileCreateWindow(IDX1.rFilename.Name, ST(OutFileSize,7)+' Bytes   ');
{$ELSE}
      UpdateFileCreateWindow(IDX1.rFilename.Name, ST(OutFileSize,7)+' bytes   ');
{$ENDIF}
    End;
  END;

  {........................................................................}

  PROCEDURE LoadDataFile(Var Buffer; Size: Word; Var Got: Word);
  { "Size" Byte in Buf laden }
  VAR ToRead            : Word;
      CanRead           : LongInt;
      Buf               : tBuffer absolute Buffer;
  BEGIN
    Got:=0;
    While (Got<Size) And (bhFileEnd And feLoading=0) And (ErrorAbort=eaOK)
     Do Begin
      If Not InFileOpen Then Begin
        InFileOpen:=True;
        InFileSize:=IDX2.dSize;
        InFilePos:=0;
      End;

      CanRead:=InFileSize-InFilePos;
      ToRead:=Size-Got;
      If ToRead>CanRead Then ToRead:=CanRead;

      ReadDatFile(IDX2.dStart+InFilePos, ToRead, Buf[Got]);
      Inc(InFilePos, ToRead);
      Inc(Got, ToRead);

      If InFilePos=InFileSize Then Begin { nchste Datei }
        If IDX1.Flag And ifVComplete<>0 Then Begin
          IDX2.Flag:=IDX2.Flag Or ifErase;
          WriteIDX(j, IDX2);
        End;
        InFileOpen:=False;

        j:=IDX2.Link;
        If (j=ilUnlinked) Or (IDX2.Flag And ifVEnd<>0) Then
          bhFileEnd:=bhFileEnd Or feLoading
        Else ReadIDX(j, IDX2);
      End;
    End;
  END;

  {........................................................................}

  PROCEDURE JoinDataFiles;
  BEGIN
    FillChar(OutField^, 8, 0); {wg. Autoextension}

    Repeat
      LoadDataFile(OutField^, BlockSize, OutPos);
      SaveDataFile(OutPos);
    Until (bhError<>0) Or (bhFileEnd And feLoading<>0) Or (ErrorAbort<>eaOK);
  END;

  {.........................................................................}
  { BinHex-Dekodierung }
  {.........................................................................}

  PROCEDURE BinHexDecode;
  CONST mHeader        = 0;
        mDataFork      = 1;
        mDataCRC       = 2; { 2 Bytes }
        mRsrcFork      = 3;
        mRsrcCRC       = 4; { 2 Bytes }
        mAllDone       = 5;

  CONST bhBufferSize   = 8192;
        bhBlockSize    = 2048; { soviel auf Disk schreiben }
  TYPE tbhBuffer       = Array[0..bhBufferSize-1] Of Byte;
  VAR BufInload        : ^tbhBuffer; { damit immer 4 Bytes da sind }
      PosInload        : Word;
      BufBitShift      : ^tbhBuffer; { damit nchstes dekodierte Byte da ist }
      PosBitShift      : Word;
      StartDecompress  : Word;
      FirstBitShift    : Boolean;
      Mode             : Byte; { was gerade gelesen wird }
      CRCCalc          : Word;
      DataLen          : LongInt;
      RsrcLen          : LongInt;

  PROCEDURE LoadInload;
  { es sollen immer BS im Puffer sein }
  VAR i, Got: Word;
  BEGIN
    If bhFileEnd And feLoading<>0 Then Exit;

    i:=bhBufferSize-PosInload;
    LoadDataFile(BufInload^[PosInload], i, Got);
    Inc(PosInload, Got);
  END;

  PROCEDURE LoadBitShift;
  VAR Left, i    : Word;
      B, dShift  : Byte;
  BEGIN
    While (bhBufferSize-PosBitShift>=bhBlockSize) And
      (bhFileEnd And feEndMarker=0) And (bhError=0) Do Begin

      LoadInload;
      If FirstBitShift Then Begin
        If BufInload^[0]<>128 Then Begin
          bhError:=bheBadHeader;
          Exit;
        End;
        i:=PosInload-1
      End Else i:=PosInload;

      Left:=((bhBufferSize-PosBitShift) Div 3)*3;  { kann soviel schreiben }
      FillChar(BufBitShift^[PosBitShift], Left, 0);
      If bhFileEnd And feLoading<>0 Then i:=((i Div 4)*3) + (i Mod 4)
      Else i:=(i Div 4)*3;  { kann lesen }

      If i<Left Then Left:=i;

      If i=0 Then bhError:=bheBadFile;

      { kann jetzt "Left" Zeichen bearbeiten! }
      If FirstBitShift Then Begin
        i:=1;
        FirstBitShift:=False;
      End Else i:=0;

      dShift:=4;
      While Left>0 Do Begin
        B:=BufInload^[i];
        Inc(i);

        If b=128 Then Begin
          bhFileEnd:=bhFileEnd Or feEndMarker;
          Left:=0;
        End Else Begin
          Case DShift Of
            4: Begin
                 BufBitShift^[PosBitShift]:=B Shl 2;
                 Inc(PosBitShift);
                 dShift:=0;
               End;
            1: Begin
                 BufBitShift^[PosBitShift-1]:=BufBitShift^[PosBitShift-1]
                   Or (B Shr 4);
                 BufBitShift^[PosBitShift]:=B Shl 4;
                 Inc(PosBitShift);
               End;
            2: Begin
                 BufBitShift^[PosBitShift-1]:=BufBitShift^[PosBitShift-1]
                   Or (B Shr 2);
                 BufBitShift^[PosBitShift]:=B Shl 6;
                 Inc(PosBitShift);
                 Inc(Left); { nchstes Zeichen braucht keinen Speicher }
               End;
            3: Begin
                 BufBitShift^[PosBitShift-1]:=BufBitShift^[PosBitShift-1]
                   Or B;
               End;
          End;

          Inc(DShift);
          Dec(Left);
        End;
      End;

      Dec(PosInload, i);
      If i>0 Then Move(BufInload^[i], BufInload^, PosInload);
    End;
  END;

  PROCEDURE LoadDecompress;
  { BufDecompress nie vllig leer laden! }
  VAR Top, i     : Word;
      a, r       : Byte;
  BEGIN
    While (FieldSize-OutPos>=bhBlockSize) And
     (bhFileEnd And feDecompressed=0) And (bhError=0) Do Begin
      LoadBitShift;
      If bhError<>0 Then Exit;

      Top:=PosBitShift;
      If bhFileEnd And feEndMarker=0 Then Dec(Top); {brauche evtl nZ}

      i:=0;
      While (i<Top) And (OutPos<FieldSize-256) Do Begin
        r:=BufBitShift^[i];
        If r=$90 Then Begin
          If BufBitShift^[i+1]=0 Then Begin { Zeichen 90h selbst }
            OutField^[OutPos]:=$90;
            Inc(OutPos);
            Inc(i,2);
          End Else Begin { Dekomprimierung }
            If OutPos=0 Then bhError:=bheIllegalCode
            Else r:=OutField^[OutPos-1];

            a:=BufBitShift^[i+1]-1; { Zeichen wurde schon geschrieben }
            FillChar(OutField^[OutPos], a, r);
            Inc(OutPos, a);
            Inc(i,2);
          End;
        End Else Begin
          OutField^[OutPos]:=r;
          Inc(OutPos);
          Inc(i);
        End;
      End;

      Dec(PosBitShift, i);
      If i>0 Then Move(BufBitShift^[i], BufBitShift^, PosBitShift);
      If (PosBitShift=0) And (bhFileEnd And feEndMarker<>0) Then
        bhFileEnd:=bhFileEnd Or feDecompressed;
    End;
  END;

  {$IFDEF OS2}
  FUNCTION SwapLongInt(x: LongInt): LongInt;
  { Longint: Macintosh -> Intel }
  TYPE dw = Record b1, b2, b3, b4: Byte End;
  VAR r   : longint;
      old : dw absolute x;
      new : dw absolute r;
  BEGIN
    new.b1:=old.b4;
    new.b2:=old.b3;
    new.b3:=old.b2;
    new.b4:=old.b1;

    SwapLongInt:=r;
  END;
  {$ELSE}
  FUNCTION SwapLongInt(x: LongInt): LongInt; assembler;
  { Longint: Macintosh -> Intel }
  ASM
    MOV AX, [BP+6]
    MOV DX, [BP+8]
    XCHG AX, DX
    XCHG AL, AH
    XCHG DL, DH
  END;
  {$ENDIF}

  PROCEDURE ProcessDecompress;
  VAR i, Avail, CRCGiven, w: Word;
  BEGIN
    i:=StartDecompress;
    Avail:=OutPos-i;
    Repeat

      Case Mode Of
        mHeader:
          Begin
            i:=OutField^[0];
            If (i>63) Or (OutPos<1+1+12+10) Then Begin
              bhError:=bheBadHeader;
              Exit;
            End;

            Move(OutField^, IDX1.rFilename, i+1);
            Inc(i, 12);
            Move(OutField^[i], DataLen, 4);
            DataLen:=SwapLongInt(DataLen);
            Move(OutField^[i+4], RsrcLen, 4);
            RsrcLen:=SwapLongInt(RsrcLen);
            Move(OutField^[i+8], CRCGiven, 2);
            CRCGiven:=Swap(CRCGiven);
            Inc(i, 10);

            CRCCalc:=Crc16(OutField^, CRCStart, i-2);
            If CRCCalc<>CRCGiven Then Begin { alternative crc16 }
              w:=0;
              CRCCalc:=Crc16(w, CRCCalc, 2);
            End;
            If CRCCalc<>CRCGiven Then bhError:=bheCRCError
            Else If OutPos<i+4 Then bhError:=bheBadHeader;

            Move(OutField^[i], OutField^, OutPos-i);
            Dec(OutPos, i);

            Inc(Mode);
            CRCCalc:=CRCStart;
            i:=StartDecompress;
          End;

        mDataFork, mRsrcFork:
          Begin
            If Avail>DataLen Then Avail:=DataLen;

            If Avail>0 Then Begin
              CRCCalc:=Crc16(OutField^[i], CRCCalc, Avail);
              Dec(DataLen, Avail);
              Inc(i, Avail);
            End;
            If DataLen=0 Then Inc(Mode);
          End;

        mDataCRC, mRsrcCRC:
          Begin
            If Avail>=2 Then Begin

              Move(OutField^[i], CRCGiven, 2);
              CRCGiven:=Swap(CRCGiven);

              If CRCCalc<>CRCGiven Then Begin { alternative crc16 }
                w:=0;
                CRCCalc:=Crc16(w, CRCCalc, 2);
              End;
              If CRCCalc<>CRCGiven Then bhError:=bheCRCError;

              Dec(Avail, 2);
              Move(OutField^[i+2], OutField^[i], Avail);
              Dec(OutPos, 2);

              Inc(Mode);
              CRCCalc:=CRCStart;
            End;
          End;

      End;
      Avail:=OutPos-i;
    Until (Mode={mAllDone} mRsrcFork) Or (bhError<>0) Or (Avail<2);

    If (Mode={mAllDone}mRsrcFork) Or (bhFileEnd And feDecompressed<>0) Then Begin
      Avail:=i;
      OutPos:=i;
      bhFileEnd:=bhFileEnd Or feAllDone;
    End Else If i>BlockSize Then Avail:=BlockSize
    Else Avail:=0;
    { BufDecompress nie vllig leer laden! }

    If Avail>0 Then SaveDataFile(Avail);
    StartDecompress:=OutPos;
  END;

  BEGIN
    New(BufInload);
    PosInload:=0;
    New(BufBitShift);
    PosBitShift:=0;
    OutPos:=0;
    StartDecompress:=0;
    FillChar(OutField^, 8, 0); {wg. Autoextension}

    FirstBitShift:=True;
    Mode:=mHeader;

    While (bhError=0) And (bhFileEnd And feAllDone=0) Do Begin
      LoadDecompress; { BufDecompressed fllen }
      If bhError=0 Then ProcessDecompress;
    End;

    Dispose(BufBitShift);
    Dispose(BufInload);

    If (bhError>=1) And (bhError<=5) And (logLevel And logErrors<>0) Then Begin
      If IDX1.rFileName.Name='' Then IDX1.rFileName.Name:='[BINHEX]';
      If bhError=bheCRCError Then Begin
{$IFDEF German}
        UpdateFileCreateWindow(IDX1.rFileName.Name, 'CRC Fehler');
        WriteLogFileInternal('* CRC Fehler');
      End Else Begin
        UpdateFileCreateWindow(IDX1.rFileName.Name, 'BINHEX Fehler');
        WriteLogFileInternal('* BINHEX Fehler #'+ST(bhError,1));
{$ELSE}
        UpdateFileCreateWindow(IDX1.rFileName.Name, 'CRC error');
        WriteLogFileInternal('* CRC error');
      End Else Begin
        UpdateFileCreateWindow(IDX1.rFileName.Name, 'BINHEX error');
        WriteLogFileInternal('* BINHEX error #'+ST(bhError,1));
{$ENDIF}
      End;
    End;
  END;

  {.........................................................................}

  PROCEDURE CreateLFNBatch;
  VAR Batch : lfnTextBuf;
  BEGIN
    If (lfnUseLongNames=lfnUForce) And (oFileName.Name<>'') Then Begin
      lfnOpenTextFile(Batch, DBPath+BatchName, ofAppend);

      If Result=0 Then Begin
        lfnWriteTextFile(Batch, 'REN '+Path+rFilename.Name+' "'+oFileName.Name+'"');
        lfnCloseTextFile(Batch);
      End;
    End;
  END;

  {.........................................................................}

{$IFDEF German}
CONST TxtFileExists    = 'Datei existiert bereits';
      TxtFileExistsAs  = 'Datei existiert bereits als ';
      TxtRenamed       = 'Umbenennung in ';
      TxtBytes         = ' Bytes ok';
{$ELSE}
CONST TxtFileExists    = 'file already exists';
      TxtFileExistsAs  = 'file already exists as ';
      TxtRenamed       = 'renamed to ';
      TxtBytes         = ' bytes ok';
{$ENDIF}
BEGIN
  { Logmail }
  bhFileEnd:=feNo;
  bhError:=0;
  OutFileSize:=0;
  OutFileOpen:=False;
  InFileOpen:=False;
  LogFileOpened:=False;
  IsZipFile:=False; { ZipMagic-Workaround }
  j:=IDXPos;

  ReadIDX(j, IDX1);
  IDX2:=IDX1;

  rFileName:=IDX1.rFileName; {Init wg. Logfile}
  UpdateFileCreateWindowLine;

  { alle Teile zusammenfgen }
  Path:=''; { fr Logfile }
  If IDX1.Typ<>opBinHex Then JoinDataFiles
  Else BinHexDecode;

  If OutFileOpen Then Begin
    If IDX1.FileTime<>noFileTime Then Begin
      SetFTime(OutFile, IDX1.FileTime);
      GetError;
    End;
    xMemCloseFile(OutFile, OutField^, OutPos);
    If Result<>0 Then bhError:=bheWriteFile;
  End;

  Inc(stDecodeSize, OutFileSize);
  Inc(stDecodeCount);

  If IDX1.Flag And ifVComplete<>0 Then Dec(DatKeepSize, OutFileSize);

  If OutFileOpen Then Begin
    If bhError=bheFCreateError Then Exit;

    If bhError=bheWriteFile Then Begin
      j:=IDXPos;
      Repeat
        ReadIDX(j, IDX2);
        IDX2.Flag:=IDX2.Flag And (Not ifErase);
        WriteIDX(j, IDX2);
        j:=IDX2.Link;
      Until (j=ilUnlinked) Or (IDX2.Flag And ifVEnd<>0);
    End
    {$IFDEF Binkley}
        Else If IDX1.BnkMode<>bnkNo Then BnkNewFile(IDX1, Path, rFilename,
          OutFileSize);
    {$ENDIF};

    If IsZipFile Then Begin
      Char(IsZipFile):='P';
      Seek(OutFile, 0);
      BlockWrite(OutFile, IsZipFile, 1);
      GetError;
    End;

    lfnCloseFile(OutFile);

    If (DupeHandUse=dupCompareAll) And IsDupeAny(rFilename, Path, OutFileSize, dFileName)
     Then Begin
      lfnEraseFile(Path+rFileName.Name);

      UpdateFileCreateWindow(IDX1.rFileName.Name, TxtFileExists);
      If logLevel And logDelete<>0 Then
        WriteLogFileInternal('* '+TxtFileExistsAs+dFileName.Name);
    End Else If rFileName.Name<>IDX1.rFileName.Name Then Begin
      If (DupeHandUse=dupCompare) And IsDupe(dFileName, rFileName, Path) Then Begin
        lfnEraseFile(Path+rFileName.Name);

        UpdateFileCreateWindow(IDX1.rFileName.Name, TxtFileExists);
        If logLevel And logDelete<>0 Then
          WriteLogFileInternal('* '+TxtFileExists);
      End Else Begin { mu dupRename sein }
        UpdateFileCreateWindow(IDX1.rFileName.Name, TxtRenamed+rFileName.Name);
        If logLevel And logRename<>0 Then
          WriteLogFileInternal('* '+TxtRenamed+rFileName.Name);
        If (Not LogFileOpened) And (logLevel And logExtract<>0) Then
          WriteLogFile(Path+rFileName.Name); { echter Dateiname }

        WriteFileDesc;
      End;
    End Else Begin
      If (Not LogFileOpened) And (logLevel And logExtract<>0) Then
        WriteLogFile(Path+rFileName.Name); { echter Dateiname }

      WriteFileDesc;
      UpdateFileCreateWindow(IDX1.rFilename.Name, ST(OutFileSize,7)+TxtBytes);
    End;

    CreateLFNBatch;
  End;
END;

{***************************************************************************}
{ Datenbankauswertung: vollstndige Dateien suchen }
{***************************************************************************}

PROCEDURE ExtractDataBase;
{ alle Files extrahieren }
VAR IDX1         : tIDXEntry;
    i            : LongInt;
BEGIN
  If (stAllFMsgData>0) Or (UpcaseStr(ioGetParamStr(1))='/X') Then Begin
    OpenFileCreateWindow;

    i:=1;
    While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
      ReadIDX(i, IDX1);
      If IDX1.Flag And ifVComplete<>0 Then ExtractDataBaseFile(i, False);

      UpdateFileCreateWindowBar(i, IDXCounter);
      Inc(i);
    End;

    CloseFileCreateWindow;
  End;
END;

{***************************************************************************}
{ Datenbank ansehen }
{***************************************************************************}

PROCEDURE ListDataBase;
VAR IDX1       : tIDXEntry;
    i          : LongInt;
    b          : Byte;
    F          : lfnTextBuf;
    Key        : tKey;

  FUNCTION Marker: Char;
  BEGIN
    If IDX1.Flag And ifFBegin<>0 Then
      If IDX1.Flag And ifFEnd<>0 Then Marker:='C'
      Else Marker:='B'
    Else
      If IDX1.Flag And ifFEnd<>0 Then Marker:='E'
      Else Marker:='-';
  END;

  FUNCTION ShowC(w: Word): String;
  BEGIN
    If w=isUnassigned Then ShowC:=' - '
    Else ShowC:=LeadingZero(w,3);
  END;

  FUNCTION ShowTyp: Char;
  BEGIN
    If IDX1.Typ=opUU Then ShowTyp:='U'
    Else If IDX1.Typ=opXX Then ShowTyp:='X'
    Else If IDX1.Typ=opBase64 Then ShowTyp:='B'
    Else If IDX1.Typ=opBinHex Then ShowTyp:='H'
    Else ShowTyp:='?';
  END;

  FUNCTION IDXContents: String;
  BEGIN
    lfnShortenFileName(IDX1.rFileName.Name);
    IDXContents:= IDX1.rFileName.Name+S(13-Length(IDX1.rFileName.Name))
{$IFDEF German}
                  +LeadingZero(IDX1.Date.Day,2)+'.'
                  +LeadingZero(IDX1.Date.Month,2)+'.'
                  +LeadingZero(IDX1.Date.Year Mod 100,2)+' '
{$ELSE}
                  +LeadingZero(IDX1.Date.Month,2)+'-'
                  +LeadingZero(IDX1.Date.Day,2)+'-'
                  +LeadingZero(IDX1.Date.Year Mod 100,2)+' '
{$ENDIF}
                  +ShowC(IDX1.cPart)+' '
                  +ShowC(IDX1.cSplit)+' '
                  +ShowTyp+' '
                  +Marker+' '
                  +IDX1.SubjStr+'/'+IDX1.AreaStr;
  END;

VAR Param : String;
{$IFDEF German}
CONST TxtCreating    = 'Erstelle Dateiliste ';
      TxtCreateError = 'Fehler beim Erstellen der Datei';
      TxtDataDir     = ' - Datenbankbersicht';
      TxtAnnot1      = 'Abkrzungen: "T" - Teil, "S" - Splitteil, "C" - Kodiertyp,';
      TxtAnnot2      = '             "M" Kopfmarkierungen, wobei "B" - Dateianfang, "E" - Dateiende';
      TxtAnnot3      = 'Name         Datum    T   S   C M Betreff/Area';
      TxtDone        = ' fertig';
{$ELSE}
CONST TxtCreating    = 'creating file list ';
      TxtCreateError = 'error creating file';
      TxtDataDir     = ' - Database Contents';
      TxtAnnot1      = 'Abbreviations: "T" - part, "S" - split number, "C" - coding typ,';
      TxtAnnot2      = '               "M" marks, in which "B" - file begin, "E" - file end';
      TxtAnnot3      = 'Name         Date     T   S   C M Subject/Area';
      TxtDone        = ' done';
{$ENDIF}
BEGIN
  Param:=ioGetParamStr(1);
  If UpcaseStr(Copy(Param,1,5))='/LIST' Then Delete(Param,1,5)
  Else Delete(Param,1,2);

  If Length(Param)>0 Then Begin { in Datei }
    Param:=lfnFExpand(Param);
    Write(TxtCreating+Param+'...');

    lfnOpenTextFile(F, Param, ofCreate);
    If Result<>0 Then WriteLn(TxtCreateError)
    Else Begin
      lfnWriteTextFile(F, verName+ TxtDataDir);
      lfnWriteTextFile(F, '');
      If (IDXCounter=0) Then lfnWriteTextFile(F, databaseempty)
      Else Begin
        lfnWriteTextFile(F, TxtAnnot1);
        lfnWriteTextFile(F, TxtAnnot2);
        lfnWriteTextFile(F, '');
        lfnWriteTextFile(F, TxtAnnot3);

        i:=1;
        While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
          ReadIDX(i, IDX1);
          lfnWriteTextFile(F, IDXContents);
          Inc(i);
        End;
      End;

      lfnCloseTextFile(F);

      WriteLn(TxtDone);
    End;
  End Else Begin { auf Bildschirm }
    If (IDXCounter=0) Then Begin
      WriteLn(databaseempty);
      Exit;
    End;

    OpenListDataBaseWindow;
    i:=1;
    Repeat
      For b:=0 To 20 Do
        If i+b<=IDXCounter Then Begin
          ReadIDX(i+b, IDX1);
          UpdateListDataBaseWindow(b+1, IDXContents);
        End Else UpdateListDataBaseWindow(b+1, '');

      Repeat
        GetKey(Key);
      Until (Key.Scan=kbUp) Or (Key.Scan=kbDown) Or
            (Key.Scan=kbHome) Or (Key.Scan=kbEnd) Or
            (Key.Scan=kbESC);

      If (Key.Scan=kbDown) And (i<IDXCounter) Then Inc(i)
      Else If (Key.Scan=kbUp) And (i>1) Then Dec(i)
      Else If (Key.Scan=kbHome) Then i:=1
      Else If (Key.Scan=kbEnd) Then Begin
        i:=IDXCounter-20;
        If i<=0 Then i:=1;
      End;
    Until (Key.Scan=kbESC) Or (ErrorAbort<>eaOK);

    CloseWindow;
  End;
END;

{***************************************************************************}
{ Datenbank manuel extrahieren }
{***************************************************************************}

PROCEDURE ExtractDatabaseManuel;
CONST rsNo   = 0;
      rsView = 1;
      rsJoin = 2;
VAR IDX                       : tIDXEntry;
    CurPos, DestCurPos,
    CurNum, AllNum            : LongInt;
    Key                       : tKey;
    Restart                   : Byte;

  PROCEDURE NextEntry;
  VAR eCount: LongInt;
  BEGIN
    Repeat
      eCount:=0;
      Repeat
        Inc(CurPos);
        If CurPos>IDXCounter Then CurPos:=1;

        Inc(eCount);
        If eCount>IDXCounter Then ErrorAbort:=eaIDXError;
        ReadIDX(CurPos, IDX);
      Until (IDX.Flag And (ifVLinked Or ifErase)=0) Or (ErrorAbort<>eaOK);
      Inc(CurNum);
      If CurNum>AllNum Then CurNum:=1;
    Until (CurPos<>DestCurPos) Or (ErrorAbort<>eaOK);
  END;

  PROCEDURE LastEntry;
  VAR eCount: LongInt;
  BEGIN
    Repeat
      eCount:=0;
      Repeat
        Dec(CurPos);
        If CurPos=0 Then CurPos:=IDXCounter;

        Inc(eCount);
        If eCount>IDXCounter Then ErrorAbort:=eaIDXError;
        ReadIDX(CurPos, IDX);
      Until (IDX.Flag And (ifVLinked Or ifErase)=0) Or (ErrorAbort<>eaOK);
      Dec(CurNum);
      If CurNum=0 Then CurNum:=AllNum;
    Until (CurPos<>DestCurPos) Or (ErrorAbort<>eaOK);
  END;

  PROCEDURE ReduceEntrys;
  BEGIN
    If AllNum>1 Then Begin
      Dec(AllNum);
      Dec(CurPos);
      NextEntry;
    End Else Key.Scan:=kbEsc; {quit}
  END;

 {.........................................................................}

  PROCEDURE SucheVerbunde;
  VAR i : LongInt;
  BEGIN
    OpenWaitWindow('');

    { CurPos: 0, wenn erster Eintrag gesucht werden soll
              sont diesen Eintrag wieder suchen }
    AllNum:=0;
    CurNum:=1;
    i:=1;

    While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
      ReadIDX(i, IDX);
      If IDX.Flag And ifVLinked=0 Then Begin
        Inc(AllNum);
        If CurPos=0 Then CurPos:=i;
        If i<CurPos Then Inc(CurNum);
      End;

      UpdateWaitWindow(i, IDXCounter);
      Inc(i);
    End;

    CloseWindow;
  END;

 {.........................................................................}

  PROCEDURE DeleteFile;
  VAR j              : LongInt;
      IDX2           : tIDXEntry;
  BEGIN
{$IFDEF German}
    OpenWaitWindow('lsche');
{$ELSE}
    OpenWaitWindow('deleting');
{$ENDIF}

    { bis Ende...}
    j:=CurPos;
    Repeat
      ReadIDX(j, IDX2);
      IDX2.Flag:=IDX2.Flag Or ifErase;
      WriteIDX(j, IDX2);
      Dec(DatKeepSize, IDX2.dSize);
      j:=IDX2.Link;
    Until (j=ilUnlinked) Or (IDX2.Flag And ifVEnd<>0);

    ReduceEntrys;
    CloseWindow;
  END;

 {.........................................................................}

  PROCEDURE DeleteAllFiles;
  VAR i   : LongInt;
  BEGIN
{$IFDEF German}
    OpenWaitWindow('lsche');
{$ELSE}
    OpenWaitWindow('deleting');
{$ENDIF}

    i:=1;
    Repeat
      ReadIDX(i, IDX);
      IDX.Flag:=IDX.Flag Or ifErase;
      WriteIDX(i, IDX);
      Dec(DatKeepSize, IDX.dSize);
      UpDateWaitWindow(i, IDXCounter);
      Inc(i);
    Until (i>IDXCounter) Or (ErrorAbort<>eaOK);
    CloseWindow;

    Key.Scan:=kbESC;
  END;

 {.........................................................................}

  PROCEDURE ExtractFile;
  BEGIN
    OpenFileCreateWindow;
    ExtractDatabaseFile(CurPos, True);
    WaitKeyFileCreateWindow;
    CloseFileCreateWindow;
  END;

 {.........................................................................}

  PROCEDURE ExtractAllFiles;
  VAR Counter : LongInt;
  BEGIN
    OpenFileCreateWindow;
    Counter:=1;
    While (Counter<=AllNum) And (ErrorAbort=eaOK) Do Begin
      UpdateFileCreateWindowBar(Counter, AllNum);
      ExtractDatabaseFile(CurPos, True);
      NextEntry;
      Inc(Counter);
    End;
    UpdateFileCreateWindowBar(CurNum, Counter);
    WaitKeyFileCreateWindow;
    CloseFileCreateWindow;
  END;

 {.........................................................................}

  PROCEDURE DissolveUnit;
  VAR i,j: LongInt;
  BEGIN
    OpenWaitWindow('');
    i:=CurPos;

    Repeat
      ReadIDX(i, IDX);
      IDX.Flag:=IDX.Flag And (Not (ifVStart   { erste Nachricht im Verbund }
                                Or ifVEnd     { letzte Nachricht im Verbund }
                                Or ifVComplete{ erste Nachricht eines vollst. Verb. }
                                Or ifVLinked  { Nachricht ist Nachfolger einer anderen }
                                                ));
      j:=IDX.Link;
      IDX.Link:=ilUnlinked;
      WriteIDX(i, IDX);
      i:=j;
    Until (i=ilUnLinked);

    CloseWindow;
    Restart:=rsView;
  END;

 {.........................................................................}

  PROCEDURE JoinUnits;
  VAR i: LongInt;
  BEGIN
    ReadIDX(CurPos, IDX);
    OpenEMLinkWindow(CurNum, AllNum, CurPos);

    DestCurPos:=CurPos;
    NextEntry;

    Repeat
      ReadIDX(CurPos, IDX);
      UpdateEMLinkWindow(CurNum, AllNum, CurPos);

      Repeat
        GetKey(Key);
      Until (Key.Scan=kbESC) Or (Key.Scan=kbUp) Or (Key.Scan=kbDown)
        Or (Key.Scan=kbLeft) Or (Key.Scan=kbRight)
        Or (Key.Scan=kbEnter);

      If (Key.Scan=kbUp) Or (Key.Scan=kbLeft) Then LastEntry
      Else If (Key.Scan=kbDown) Or (Key.Scan=kbRight) Then NextEntry;

    Until (ErrorAbort<>eaOK) Or (Key.Scan=kbESC) Or (Key.Scan=kbEnter);

    If Key.Scan=kbEnter Then Begin
      Restart:=rsJoin;

      ReadIDX(CurPos, IDX);
      IDX.Flag:=IDX.Flag Or ifVLinked;
      WriteIDX(CurPos, IDX);

      { letzen Teil des ersten Verbundes suchen }
      i:=DestCurPos;
      ReadIDX(i, IDX);
      While (IDX.Link<>ilUnlinked) And (ErrorAbort=eaOK) Do Begin
        i:=IDX.Link;
        ReadIDX(i, IDX);
      End;

      IDX.Link:=CurPos;
      WriteIDX(i, IDX);
    End Else Restart:=rsView;

    Key.Scan:=kbNoKey;
    CurPos:=DestCurPos;
    DestCurPos:=0;

    CloseEMLinkWindow;
  END;

 {.........................................................................}

BEGIN
  If IDXCounter=0 Then WriteLn(databaseempty)
  Else Begin
    LogMailArea:=''; { keine Logmail erstellen! }

    OpenExtractManualWindow;
    CurPos:=0;     { ersten Eintrag suchen }
    DestCurPos:=0; { Nummer des auszuschlieenden Eintrag, normale Ansicht }

    Restart:=rsNo;
    Repeat
      SucheVerbunde;

      If CurPos=0 Then ErrorAbort:=eaIDXError;
      If ErrorAbort=eaOK Then Begin
        Repeat
          ReadIDX(CurPos, IDX);
          UpdateExtractManualWindow(CurNum, AllNum, CurPos);

          If Restart=rsJoin Then Key.UpChar:='N'
          Else
            Repeat
              GetKey(Key);
            Until (Key.Scan=kbESC) Or (Key.Scan=kbUp) Or (Key.Scan=kbDown)
              Or (Key.Scan=kbLeft) Or (Key.Scan=kbRight)
              Or (Key.UpChar='E') Or (Key.UpChar='X')
              Or (Key.UpChar='L') Or (Key.UpChar='A')
              Or (Key.UpChar='N') Or (Key.UpChar='S');

          Restart:=rsNo;

          If (Key.Scan=kbUp) Or (Key.Scan=kbLeft) Then LastEntry
          Else If (Key.Scan=kbDown) Or (Key.Scan=kbRight) Then NextEntry
          Else Case Key.UpChar Of
            'E': ExtractFile;
            'X': ExtractAllFiles;
            'L': DeleteFile;
            'A': If SecurityWindow Then DeleteAllFiles;
            'N': If AllNum>1 Then JoinUnits;
            'S': DissolveUnit;
          End;

        Until (ErrorAbort<>eaOK) Or (Key.Scan=kbESC) Or (Restart<>rsNo);
      End;
    Until (ErrorAbort<>eaOK) Or (Key.Scan=kbESC);

    CloseWindow;
  End;
END;

{***************************************************************************}
{ Ini-Datei testen }
{***************************************************************************}

PROCEDURE TestIniFile;
BEGIN
{$IFDEF German}
  WriteLn('INI-Datei ist in Ordnung');
{$ELSE}
  WriteLn('INI file is okay');
{$ENDIF}
END;

{***************************************************************************}
{ Programausfhrung festlegen }
{***************************************************************************}

PROCEDURE CheckOldFileList;
VAR Key   : Char;
    Start : LongInt;
BEGIN
  If lfnExistFile(DBPath+PreDirName) Then Begin
    WriteLn;
{$IFDEF German}
    WriteLn('Im Datenbankverzeichnis befindet sich eine temporre Datei von PktXCode.');
    WriteLn('Entweder luft es bereits in einer anderen Task, oder es wurde bereits zuvor');
    WriteLn('ein Verzeichnis voreingelesen. Ich warte eine Minute, bevor ich die Datei');
    WriteLn('berschreibe. Drcken Sie eine beliebige Taste, um das Warten zu beenden...');
{$ELSE}
    WriteLn('A temprorary file of PktXCode was found in the database directory. Either');
    WriteLn('PktXCode already runs in another task or another directory has been scanned');
    WriteLn('before. I will wait a minute before overwriting the file. Press any key to');
    WriteLn('abort waiting.');
{$ENDIF}

    While KeyPressed Do Key:=ReadKey;
    Key:=#0;
    Start:=GetTimeReal+600;
    Repeat
      Write(#13, ST((Start-GetTimeReal) Div 10,2));

      Delay(100);
      {$IFNDEF OS2} Asm Int $28 End; {$ENDIF}

      While KeyPressed Do Key:=ReadKey;
    Until (GetTimeReal>=Start) Or
          (Not lfnExistFile(DBPath+PreDirName)) Or
          (Key<>#0);
    WriteLn(#13, 'Schwupps...');
    WriteLn;
  End;
END;

{***************************************************************************}
{ Programausfhrung festlegen }
{***************************************************************************}

PROCEDURE AnalyseParam;
VAR Param   : String;
    NoFiles : Boolean;
    FSize   : Longint;
    i       : Byte;
    FlagX   : Boolean;
BEGIN
  { ioGetParamCount In [1..2] }
  FlagX:=False;

  For i:=1 To ioGetParamCount Do Begin
    Param:=UpCaseStr(ioGetParamStr(i));
    If (Copy(Param,1,1)='/') And (Length(Param)>1) Then Begin
      Case Param[2] Of
        'X' : FlagX:=True;
        'T' : JobExec:=jobLoadIniFile Or
                       jobTestIniFile;
        'L' : JobExec:=jobLoadIniFile Or
                       jobXMemInit Or
                       jobOpenDataBase Or
                       jobListDataBase;
        'M' : JobExec:=jobLoadIniFile Or
                       jobXMemInit Or
                       jobOpenDataBase Or
                       jobExtractManual;
        'V' : JobExec:=jobLoadIniFile Or
                       jobXMemInit Or
                       jobOpenDataBase Or
                       jobVerifyDataBase;
        'R' : Begin
                CmdFile:=ioGetParamStr(i);
                JobExec:=jobLoadIniFile Or
                         jobPrereadDir;
              End;
        'C' : JobExec:=jobLoadIniFile Or
                       jobCheckDir Or
                       jobXMemInit Or
                       jobOpenDataBase Or
                       jobBuildDatabase Or
                       jobExtractDatabase Or
                       jobDecodeStatistic;
        'E' : Begin
                UserExtractPath:=fnFull(Copy(ioGetParamStr(i),4,255));
                If Not lfnExistPath(UserExtractPath) Then Begin
                  WriteLn;
                  WriteLn(UserExtractPath+notexist);
                  JobExec:=JobTerminate;
                End;
              End;
        Else JobExec:=jobDisplayHelp;
      End;
    End Else Begin
      CmdFile:=ioGetParamStr(i);
      JobExec:=jobLoadIniFile Or
               jobUnpackFiles Or
               jobXMemInit Or
               jobOpenDataBase Or
               jobBuildDatabase Or
               jobExtractDatabase Or
               jobDecodeStatistic;
    End;
  End;

  If FlagX Then
    If CmdFile='' Then
      JobExec:=jobLoadIniFile Or
               jobXMemInit Or
               jobOpenDataBase Or
               jobBuildDatabase Or
               jobExtractDatabase Or
               jobDecodeStatistic
    Else JobExec:=JobExec And (Not jobExtractDatabase);

END;

{***************************************************************************}

END.

