{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)

}

Unit PKTX_BNK; { Binkley-Support }

{$I SETTINGS.INI}

{ 09.07.97 erstellt

}

INTERFACE

{$IFDEF OS2}
Uses CRT_OS2, OS2DEF, OS2BASE,
{$ELSE}
Uses CRT,
{$ENDIF}
                    DOS, PKTX_KEY, PKTX_IO, PKTX_SCR, PKTX_LFN, BinkOut;

{***************************************************************************}

{$IFDEF Debug_BNK}
PROCEDURE BnkLog(S: String);
{$ENDIF}


FUNCTION BinkleyFilter: Boolean;
{ wird Binkleyfilter benutzt ? }

PROCEDURE BnkInitMailBuffer;
{ initalisiert Puffer }

PROCEDURE BnkInitMail;
{ nach dem einlesen des Nachrichtenkopfes in OutIDX aufrufen,
  setzt BnkThisMail }

PROCEDURE BnkModifyMail;
{ liefert Nachrichtentext "ShortText" in BnkMessageBuf zurck }

PROCEDURE BnkCloseMail;
{ setzt Variblen zurck }

PROCEDURE BnkNewFile(IDX: tIDXEntry; Path: String; FName: tFNStr; FSize: LongInt);
{ wenn neue Datei wurde erstellt wurde, hiermit in Datenbank eintragen }

PROCEDURE BnkCheckDatabase;
{ prft, ob Nachrichten verschickt oder Files gelscht werden mssen }

Const BnkMessageMaxSize = 8192;
Var   BnkMessageBuf     : Pointer;
      BnkMessageSize    : Word;

{***************************************************************************}

IMPLEMENTATION

Uses Strings;

{***************************************************************************}

FUNCTION BinkleyFilter: Boolean;
BEGIN
  BinkleyFilter:= {((RegMode=rmLicence) Or (RegMode=rmShareware))
    And} (FilterNMP<>NIL)
END;

{***************************************************************************}

FUNCTION BnkGetAka(Zone: Word): pAka;
VAR P : pAka;
BEGIN
  p:=AkaList;

  While (p<>NIL) And (p^.Addr.Zone<>Zone) Do
    p:=p^.Next;

  If p=NIL Then p:=AkaList;

  BnkGetAka:=p;
END;

FUNCTION GetAka(Zone: Word): S80;
VAR P : pAka;
BEGIN
  p:=BnkGetAka(Zone);
  GetAka:=WriteFidoAddr(p^.Addr);
END;

{***************************************************************************}

PROCEDURE BnkInitMailBuffer;
BEGIN
  GetMem(BnkMessageBuf, BnkMessageMaxSize);
END;

{***************************************************************************}

PROCEDURE BnkInitMail;
VAR p: pFilterNM;
BEGIN
  BnkThisMail:=False;

{  If Not ((RegMode=rmLicence) Or (RegMode=rmShareware)) Then Exit;}

  p:=FilterNMP;
  While p<>NIL Do Begin
    If ((p^.Addr.Name='') Or (p^.Addr.Name=UpcaseStr(OutIDX.FidoAddr.Name)))
     And

       (p^.AnyZone Or (p^.Addr.Addr.Zone=OutIDX.FidoAddr.Addr.Zone)) And
       (p^.AnyNet  Or (p^.Addr.Addr.Net =OutIDX.FidoAddr.Addr.Net ))  And
       (p^.AnyNode Or (p^.Addr.Addr.Node=OutIDX.FidoAddr.Addr.Node)) And

       (((p^.Addr.Addr.IsPoint) And
        (p^.AnyPoint Or (p^.Addr.Addr.Point=OutIDX.FidoAddr.Addr.Point))) Or
        (Not p^.Addr.Addr.IsPoint))
     Then Begin
      BnkThisMail:=p^.Positive;
    End;

    p:=p^.Next;
  End;

{  debuginfo('Mail to Zone ' + st(OutIDX.FidoAddr.Zone,1)+
            ' Net '         + st(OutIDX.FidoAddr.Net,1)+
            ' Node '        + st(OutIDX.FidoAddr.Node,1)+
            ' Point '       + st(OutIDX.FidoAddr.Point,1)+
            ' Name '        + OutIDX.FidoAddr.Name+
            ' Short '       + st(ord(BnkThisMail),1));}

  {$IFDEF Debug_BNK}
  if bnkthismail then BnkLog('applying bnkfilter')
  else bnklog('NOT applying bnkfilter');
  {$ENDIF}
END;

{***************************************************************************}

PROCEDURE BnkModifyMail;
VAR Buf   : PField;
    l, l2 : String[127];
    i     : Byte;
    p     : pText;

  PROCEDURE Save;
  BEGIN
    l2:=GetAka(OutIDX.FidoAddr.Addr.Zone);
    While Pos('$NODE', l)<>0 Do Begin
      i:=Pos('$NODE', l);
      Delete(l,i,5);
      Insert(l2,l,i);
    End;

    l2:=CodeName(OutIDX.Typ);
    While Pos('$TYPE', l)<>0 Do Begin
      i:=Pos('$TYPE', l);
      Delete(l,i,5);
      Insert(l2,l,i);
    End;

    l2:=ST(OutIDX.dSize,1);
    While Pos('$SIZE', l)<>0 Do Begin
      i:=Pos('$SIZE', l);
      Delete(l,i,5);
      Insert(l2,l,i);
    End;

    If BnkMessageMaxSize-BnkMessageSize>Length(l) Then Begin
      l:=l+#13;
      Move(l[1], Buf^[BnkMessageSize], Length(l));
      Inc(BnkMessageSize, Length(l));
    End;
  END;

BEGIN
  Buf:=BnkMessageBuf;
  BnkMessageSize:=0;

  l:=' '+verName+' ';
  i:=68-Length(l);
  l:=SOf('-', i Div 2)+l;
  l:=l+SOf('-', 68-Length(l));
  l:='['+l+']';
  Save;

  p:=ShortText;
  Repeat
    l:=p^.Line;
    Save;
    p:=p^.Next;
  Until p=NIL;

  l:='['+SOf('-', 68)+']';
  Save;
END;

{***************************************************************************}

PROCEDURE BnkCloseMail;
BEGIN
  BnkThisMail:=False;
END;

{***************************************************************************}
{* Datenbank ***************************************************************}
{***************************************************************************}

TYPE tBnkDB      = Record
                     BnkMode   : Byte;
                     FidoAddr  : tFidoAddr;
                     Inbound   : String[74];
                     Date      : tDate;
                     FName     : String;
                     FSize     : LongInt;
                     PktType   : Byte; { MSG/PKT }
                   End;
     tBnkDBHead  = Record
                     verInfo   : tVerInfo;
                     Size      : LongInt;
                   End;

{***************************************************************************}

PROCEDURE BnkDBAdd(DB: tBnkDB);
VAR F   : File;
    DB2 : tBnkDB;
    DBh : tBnkDBHead absolute DB2;

  PROCEDURE WriteHeader;
  BEGIN
    Seek(F, 0);
    GetError;
    BlockWrite(F, DB2, SizeOf(tBnkDB));
    GetError;
    If Result<>0 Then ErrorAbort:=eaDatFileWrite;
  END;

  PROCEDURE ResetHeader;
  BEGIN
    Seek(F, 0);
    Truncate(F);
    GetError;
    Fillchar(DB2, SizeOf(tBnkDB), 0);
    DBh.verInfo:=BnkVerinfo;
    DBh.Size:=0;
    WriteHeader;
  END;

BEGIN
  lfnOpenFile(F, DBPath+BnkDBName, ofRW);
  If Result<>0 Then lfnOpenFile(F, DBPath+BnkDBName, ofCreate);
  If Result<>0 Then ErrorAbort:=eaDatFileWrite
  Else Begin
    If FileSize(F)=0 Then ResetHeader
    Else Begin
      BlockRead(F, DB2, SizeOf(tBnkDB));
      GetError;
      If (Result<>0) Or (DBh.verinfo<>BnkVerinfo) Then ResetHeader;
    End;

    Seek(F, (DBh.Size+1)*SizeOf(tBnkDB));
    BlockWrite(F, DB, SizeOf(tBnkDB));
    GetError;
    If Result<>0 Then ErrorAbort:=eaDatFileWrite;

    Inc(DBh.Size);
    WriteHeader;

    lfnCloseFile(F);
  End;
END;

{***************************************************************************}
{***************************************************************************}

FUNCTION FidoTime: S80;
{ Creates Fido standard "01 Jan 89  21:05:18" }
{$IFDEF OS2}
VAR Year, Month, Day, DayOfWeek  : Longint;
    Hour, Minute, Second, Sec100 : Longint;
{$ELSE}
VAR Year, Month, Day, DayOfWeek  : Word;
    Hour, Minute, Second, Sec100 : Word;
{$ENDIF}
BEGIN
  GetDate(Year, Month, Day, DayOfWeek);
  GetTime(Hour, Minute, Second, Sec100);

  FidoTime:= LeadingZero(Day,2)
            +' '+cMonth[Month]
            +' '+LeadingZero(Year Mod 100, 2)
            +'  '+LeadingZero(Hour,2)
            +':'+LeadingZero(Minute,2)
            +':'+LeadingZero(Second,2);
END;

{***************************************************************************}

FUNCTION SerialNo: String;
CONST HexChars : Array[0..$F] Of Char = '0123456789ABCDEF';
VAR Name       : String;
    i          : Byte;
BEGIN
  For i:=1 To 8 Do
    Name[i]:=HexChars[Random(16)];

  Name[0]:=#8;
  SerialNo:=Name;
END;

{***************************************************************************}

FUNCTION BnkCreateMail(FPath: String; { Pfad d. Nachricht }
                       PKTType: Byte; { Typ: MSG oder PKT }
                       Dest: tFidoAddr; { Empfnger }
                       MAttr: Word;     { Attrib der Nachricht }
                       FName: String;   { Name der Attach-Datei }
                       FSize: LongInt;
                       MText: Boolean   { true: sendmail; false: sendfile }
                      ): Boolean;

VAR Name     : tFNStr;
    F        : File;
    r        : Boolean;
    Buf      : PField;
    pp       : ^tPktHdr;
    pm       : ^tPktMsgHdr;
    pmsg     : ^tMsgHead;
    pa       : pAka;
    ps       : pText;
    l        : String;

  PROCEDURE GetFileName;
  VAR sr     : lfnSearchRec;
      MaxNum : LongInt;
      NewNum : Longint;
      NumStr : String[80];
      i      : Byte;
  BEGIN
{a) Die .MSG-Dateien *ohne* ohne fuehrende Nullen numeriert.
 b) Die erste .MSG-Datei muss "1.MSG" heissen, nicht "0.MSG".
 c) Wenn Du eine neue Message erstellst, musst Du erst nach der .MSG-Datei mit
    der hoechsten Nummer suchen, diese um eins erhoehen, und die zu erstellende
    Datei dann entsprechend benennen.}

    MaxNum:=0;
    Name.Long:=False;
    If PKTType=ptPKT Then Begin
      Name.Name:=GetDateTimeXP+'.PKT'; {'19960531121300W'}
      Delete(Name.Name,1,6);
      Delete(Name.Name,9,1);

      MaxNum:=1000;
      While lfnExistFile(FPath+Name.Name) And (MaxNum>0) Do Begin
        Dec(MaxNum);
        GetNextName(Name, dupRenameFile);
      End;
    End Else Begin
      Name.Name:='.MSG';

      lfnFindFirst(FPath+'*'+Name.Name, AnyFile, sr);
      While (DosError=0) Do Begin
        NumStr:=sr.name.name;
        i:=Length(NumStr);
        While (i>0) And (NumStr[i]<>'.') Do
          Dec(i);
        { i steht auf letztem '.' oder auf 0 }

        If i>0 Then Begin
          NumStr[0]:=Chr(i-1);
          Dec(i);
          While (i<>0) And (NumStr[i] In ['0'..'9']) Do
            Dec(i);

          If i=0 Then Begin
            NewNum:=Value(NumStr);
            If NewNum>MaxNum Then MaxNum:=NewNum;
          End;
        End;
        lfnFindNext(sr);
      End;
      lfnFindClose(sr);

      If MaxNum=99999999 Then MaxNum:=0;
      Name.Name:=ST(MaxNum+1,1)+Name.Name;
    End;
  END;

  PROCEDURE WriteBuf(l: String);
  BEGIN
    If BnkMessageMaxSize-BnkMessageSize>Length(l) Then Begin
      Move(l[1], Buf^[BnkMessageSize], Length(l));
      Inc(BnkMessageSize, Length(l));
    End;
  END;

  PROCEDURE CheckLine;
  VAR i: Byte;
  BEGIN
    While Pos('$NODE', l)<>0 Do Begin
      i:=Pos('$NODE', l);
      Delete(l,i,5);
      Insert( GetAka(OutIDX.FidoAddr.Addr.Zone),l,i);
    End;

    While Pos('$USERNAME', l)<>0 Do Begin
      i:=Pos('$USERNAME', l);
      Delete(l,i,9);
      Insert(Dest.Name,l,i);
    End;

    While Pos('$FILENAME', l)<>0 Do Begin
      i:=Pos('$FILENAME', l);
      Delete(l,i,9);
      Insert(fnName(FName),l,i);
    End;

    While Pos('$FILESIZE', l)<>0 Do Begin
      i:=Pos('$FILESIZE', l);
      Delete(l,i,9);
      Insert(ST(FSize,1),l,i);
    End;

    While Pos('$HOLDDAYS', l)<>0 Do Begin
      i:=Pos('$HOLDDAYS', l);
      Delete(l,i,9);
      Insert(ST(BnkHoldDays,1),l,i);
    End;
  END;

BEGIN
  r:=False;

  GetFileName;

  lfnOpenFile(F, FPath+Name.Name, ofCreate);
  If Result=0 Then Begin
    Buf:=@BnkMessageBuf^;
    BnkMessageSize:=0;
    Fillchar(Buf^, BnkMessageMaxSize, 0);

    ps:=SendText;
    l:=ps^.Line;
    ps:=ps^.Next;
    CheckLine; { Betreff dekodiert }


    pa:=BnkGetAka(Dest.Addr.Zone);
    If PKTType=ptPKT Then Begin
      pp:=@Buf^;

      With pp^ Do Begin
        orig_node  := pa^.Addr.Node;
        dest_node  := pa^.Addr.Node;
        rate       := 0;
        ver        := 2;
        orig_net   := pa^.Addr.Net;
        dest_net   := pa^.Addr.Net;
        product    := 0;
        rev        := 3;
        {password}
        q_orig_zone:= pa^.Addr.Zone;
        q_dest_zone:= pa^.Addr.Zone;
        {pktjunk2}
        {cwcopy}
        {producthi}
        {revmin}
        {cw}
        t_orig_zone:= pa^.Addr.Zone;
        t_dest_zone:= pa^.Addr.Zone;
        If pa^.Addr.IsPoint Then Begin
          t_orig_pnt := pa^.Addr.Point;
          t_dest_pnt := pa^.Addr.Point;
        End;
        {pktjunk3}
      End;

      pm:=@Buf^[SizeOf(tPktHdr)];
      With pm^ Do Begin
        ver        := 2;
        orignode   := pa^.Addr.Node;
        destnode   := Dest.Addr.Node;
        orignet    := pa^.Addr.Net;
        destnet    := Dest.Addr.Net;
        attr       := MAttr;
        cost       := 0;
      End;

      BnkMessageSize:=SizeOf(tPktHdr)+SizeOf(tPktMsgHdr);

      WriteBuf(FidoTime+#0);
      WriteBuf(Dest.Name+#0); { toUserName, fromUserName, subject, text }
      WriteBuf(verName+#0);
      { Subject }
      If MText Then WriteBuf(l+#0)
      Else WriteBuf(FName+#0);
    End Else Begin {MSG}
      pmsg:=@Buf^;

      With pmsg^ Do Begin
        StrPCopy(fromUserName, verName);
        StrPCopy(ToUserName, Dest.Name);
        If MText Then StrPCopy(Subject, l)
        Else StrPCopy(Subject, FName);
        StrPCopy(DateTime, FidoTime);
        TimesRead    :=0;
        destNode     :=Dest.Addr.Node;
        origNode     :=pa^.Addr.Node;
        cost         :=0;
        origNet      :=pa^.Addr.Net;
        destNet      :=Dest.Addr.Net;
        destZone     :=Dest.Addr.Zone;
        origZone     :=pa^.Addr.Zone;

        If Dest.Addr.IsPoint Then destPoint:=Dest.Addr.Point
        Else destPoint    :=0;
        If pa^.Addr.IsPoint Then origPoint:=pa^.Addr.Point
        Else origPoint    :=0;

        replyTo      :=0;
        Attribute    :=MAttr;
        nextReply    :=0;
      End;

      BnkMessageSize:=SizeOf(tMsgHead);
    End;

    { MessageText }
    If (Dest.Addr.IsPoint) And (Dest.Addr.Point<>0) Then
      WriteBuf(#1'TOPT '+ST(Dest.Addr.Point,1)+#13);
    If (pa^.Addr.IsPoint) And (pa^.Addr.Point<>0) Then
      WriteBuf(#1'FMPT '+ST(pa^.Addr.Point,1)+#13);
    {If (Dest.Addr.Zone<>pa^.Addr.Zone) Then}
      WriteBuf(#1'INTL '
      {dest} + ST(Dest.Addr.Zone,1) + ':'
             + ST(Dest.Addr.Net,1) + '/'
             + ST(Dest.Addr.Node,1) + ' '
      {org}  + ST(pa^.Addr.Zone,1) + ':'
             + ST(pa^.Addr.Net,1) + '/'
             + ST(pa^.Addr.Node,1) + #13);

    WriteBuf(#1'MSGID: '+WriteFidoAddr(pa^.Addr)+' '+SerialNo+#13);

    If MText Then begin
      While ps<>NIL Do Begin
        l:=ps^.Line;
        ps:=ps^.Next;

        CheckLine;
        WriteBuf(l+#13);
      End;
    end Else If AttachMessage then begin
      checkline;
      {$IFDEF German}
      writebuf('Diese Nachricht ist mit einem File-Attach verbunden.'#13);
      {$ELSE}
      writebuf('This message is carrying a file attach.'#13);
      {$ENDIF}
    end;

    If PktType=ptMSG Then WriteBuf(#0)
    Else WriteBuf(#0#0#0);

    BlockWrite(F, BnkMessageBuf^, BnkMessageSize);
    GetError;
    r:=(Result=0);

    lfnCloseFile(F);
  End;

  BnkCreateMail:=r;
END;

{***************************************************************************}
{***************************************************************************}

PROCEDURE BnkCheckDatabase;
{ prft, ob Nachrichten verschickt oder Files gelscht werden mssen }
VAR F, F2     : File;
    DB, DB2   : tBnkDB;
    DBh       : tBnkDBHead absolute DB2;
    c         : Longint; { Anzahl der neuen Eintrge }
    today     : tDate;
    keep      : Boolean;

  PROCEDURE SendFile;
  VAR NodeData : T_Nodedata;
      SendCFG  : tSendTyp;
      Path     : String;
      fName    : String;
  BEGIN
    If DB.PKTType=ptMSG Then SendCFG:=SendMSG
    Else SendCFG:=SendPKT;

    If SendCFG.Mode=smAttach Then Begin
      Path:=SendCFG.Path;
      If Path='' Then Path:=DB.Inbound;
      Path:=fnFull(Path);
      If AttachPath Then fName:=DB.fname
      Else fName:=fnName(DB.fName);

      If BnkCreateMail(Path,          { Pfad d. Nachricht }
                       SendCFG.Typ,    { Typ: MSG oder PKT }
                       DB.FidoAddr,   { Empfnger }
                       SendCFG.Attr2, { Attrib der Nachricht }
                       fName,         { Name der Attach-Datei }
                       DB.fSize,
                       False          { true: sendmail; false: sendfile }
                      ) Then DB.BnkMode:=bnkMessage;

    End Else Begin
      NodeData.Zone :=DB.FidoAddr.Addr.Zone;
      NodeData.Net  :=DB.FidoAddr.Addr.Net;
      NodeData.Node :=DB.FidoAddr.Addr.Node;
      NodeData.Point:=DB.FidoAddr.Addr.Point;
      NodeData.is5d :=False;

      BOUT_InsertFile (DB.FName, NodeData, FL_Hold Or ST_KillSent);
      If BOUT_Result=BOUT_NOERROR Then DB.BnkMode:=bnkMessage;
    End;
  END;

  PROCEDURE SendMail;
  VAR Path     : String;
      SendCFG  : tSendTyp;
  BEGIN
    If DB.PKTType=ptMSG Then SendCFG:=SendMSG
    Else SendCFG:=SendPKT;

    Path:=SendCFG.Path;
    If Path='' Then Path:=DB.Inbound;
    Path:=fnFull(Path);

    If BnkCreateMail(Path,          { Pfad d. Nachricht }
                     SendCFG.Typ,    { Typ: MSG oder PKT }
                     DB.FidoAddr,   { Empfnger }
                     SendCFG.Attr1, { Attrib der Nachricht }
                     DB.fName,      { Name der Attach-Datei }
                     DB.fSize,
                     True           { true: sendmail; false: sendfile }
                    ) Then
      If SendCFG.Mode=smBinkley Then DB.BnkMode:=bnkWait
      Else Begin
        DB.BnkMode:=bnkNo;
        Keep:=False;
      End;
  END;

BEGIN
  lfnOpenFile(F, DBPath+BnkDBName, ofRead);
  If Result<>0 Then Exit;

  BlockRead(F, DB2, SizeOf(tBnkDB));
  GetError;
  If Result<>0 Then Begin
    ErrorAbort:=eaDatFileRead;
    lfnCloseFile(F);
  End Else Begin
    If DBh.verInfo<>BnkVerinfo Then Begin
      lfnCloseFile(F);
      lfnEraseFile(DBPath+BnkDBName);
    End Else Begin
      lfnOpenFile(F2, DBPath+BnkDBName2, ofCreate);
      If Result<>0 Then ErrorAbort:=eaDatFileWrite
      Else Begin
        BlockWrite(F2, DBh, SizeOf(tBnkDB));
        GetError;
        If Result<>0 Then ErrorAbort:=eaDatFileWrite;
        c:=0;
        GetDateDT(today);

        While (ErrorAbort=eaOK) And (DBh.Size>0) Do Begin
          Dec(DBh.Size);
          BlockRead(F, DB, SizeOf(tBnkDB));
          GetError;
          If Result<>0 Then DBh.Size:=0
          Else Begin
            keep:=False;

            If DB.BnkMode=bnkExtract Then Begin
              keep:=True;
              SendFile;
            End;

            If DB.BnkMode=bnkMessage Then Begin
              keep:=True;
              SendMail;
            End;

            If DB.BnkMode=bnkWait Then
              If lfnExistFile(DB.FName) And
                (GetDateDifference(DB.Date, today)<BnkHoldDays)
                Then keep:=True
                Else keep:=False;

            If keep Then Begin
              Inc(c);
              BlockWrite(F2, DB, SizeOf(tBnkDB));
              GetError;
              If Result<>0 Then ErrorAbort:=eaDatFileWrite;
            End;
          End;
        End;

        If c>0 Then Begin
          Fillchar(DB2, SizeOf(tBnkDB), 0);
          DBh.verInfo:=BnkVerinfo;
          DBh.Size:=c;
          Seek(F2, 0);
          GetError;
          BlockWrite(F2, DB2, SizeOf(DB2));
          GetError;
          If Result<>0 Then ErrorAbort:=eaDatFileWrite;
          lfnCloseFile(F2);
        End Else Begin
          lfnCloseFile(F2);
          lfnEraseFile(DBPath+BnkDBName2);
        End;
      End;

      lfnCloseFile(F);
      If ErrorAbort=eaOK Then Begin
        lfnEraseFile(DBPath+BnkDBName);
        lfnRenameFile(DBPath+BnkDBName2, DBPath+BnkDBName);
      End;
    End;
  End;
END;

{***************************************************************************}
{***************************************************************************}
{***************************************************************************}

PROCEDURE BnkNewFile(IDX: tIDXEntry; Path: String; FName: tFNStr; FSize: LongInt);
{ wenn neue Datei wurde erstellt wurde, hiermit in Datenbank eintragen }
VAR DB : tBnkDB;
BEGIN
  Fillchar(DB, SizeOf(DB), 0);
  DB.BnkMode:=bnkExtract;
  DB.FidoAddr:=IDX.FidoAddr;
  DB.Inbound:=IDX.Inbound;
  DB.FName:=Path+FName.Name; { BnkFilePath knnte verndert werden }
  DB.FSize:=FSize;
  DB.PktType:=IDX.PktType;
  GetDateDT(DB.Date);

  BnkDBAdd(DB);
END;

{***************************************************************************}

{***************************************************************************}

{$IFDEF Debug_BNK}
PROCEDURE BnkLog(S: String);
VAR f : lfnTextBuf;
BEGIN
  If LogPath='' Then Exit;

  lfnOpenTextFile(f, fnFull(LogPath)+'PKTXBINK.LOG', ofAppend);
  lfnWriteTextFile(f, GetDateTimeStr+'  '+S);
  lfnCloseTextFile(f);
END;
{$ENDIF}


END.
