{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)

}

Unit PKTX_DB;

{$I SETTINGS.INI}

{ 27.10.96 CompressDB: Prozentanzeige anhand Keepsize
           Datenbankkomprimierung nur bei 50+% Abfall
           Fehler in CloseIDX behoben
  28.10.96 mehrere in CloseDB behoben
  23.11.96 Verifydatabase fnge gekrzte Datendatei ab
  24.11.96 Fehler in Statsitik (div 0) behoben
           Fehler in SaveIDXCache behoben
           Taskblocking anhand Database
  15.02.97 Extpath anhand Dateierweiterung
  16.02.97 Bezge im DB-Index werden nach Komprimierung restautiert
  27.02.97 Abfrage von ExistCreatepath !

}

INTERFACE

{$IFDEF OS2}
Uses CRT_OS2,
{$ELSE}
Uses CRT,
{$ENDIF}
              DOS, PKTX_IO, PKTX_SCR, PKTX_LFN, PKTX_MEM

{$IFDEF Binkley}
  ,PKTX_BNK, BinkOut
{$ENDIF}      ;

PROCEDURE OpenDatabase;
PROCEDURE CloseDataBase;

PROCEDURE ReadIDX(Num: LongInt; Var IDX: tIDXEntry);
PROCEDURE WriteIDX(Num: LongInt; Var IDX: tIDXEntry);
PROCEDURE AddIDX(IDX: tIDXEntry);

PROCEDURE ReadDatFile(Pos: LongInt; Size: Word; Var Puffer);

PROCEDURE VerifyDataBase;

PROCEDURE ReleaseMemory;
PROCEDURE LoadINIFile;
FUNCTION ShallDecodeArea(Area: String): Boolean;
FUNCTION ShallModifyArea(Area: String; Typ: Byte): Byte;
PROCEDURE GetExtractPath(Area: String; FName: tFNStr; Var Path: PathStr;
            Var DH: Byte);

PROCEDURE DoLogSummary(Var IDXBuf: tIDXEntry);
PROCEDURE Statistics;
PROCEDURE WriteLogFile(Txt: String);
PROCEDURE CloseLogFile;

IMPLEMENTATION

{***************************************************************************}
{ IDX-Cache-Verwaltung }
{***************************************************************************}

VAR IDXCache      : PIDXCache;
{$IFDEF OS2}
    OldIDXCache   : PIDXCache;
{$ENDIF}
    IDXCacheStart,
    IDXCacheEnd   : LongInt;
    IDXCacheDirty : Boolean; { Cacheinhalt weicht von Disk ab }
    IDXFile       : File;
    IDXModified   : Boolean;

  PROCEDURE SaveIDXCache;
  BEGIN
    If IDXCacheStart=-1 Then Exit;

    If IDXCacheDirty Then Begin
      IDXModified:=True;

      xMemWriteFile(IDXFile, IDXCacheStart*SizeOf(tIDXEntry),
       (IDXCacheEnd-IDXCacheStart+1)*SizeOf(tIDXEntry), IDXCache^);
      If Result<>0 Then
        If lfnFreeDiskSpace(DBPath[1])<(IDXCacheEnd-IDXCacheStart+1)*SizeOf(tIDXEntry)
          Then ErrorAbort:=eaDiskFull
          Else ErrorAbort:=eaIDXWrite;

      IDXCacheDirty:=False;
    End;
  END;

{***************************************************************************}

  PROCEDURE LoadIDXCache(Num: LongInt);
  VAR Addr    : LongInt;
  BEGIN
    SaveIDXCache;

    Addr:=Addr2BlockAddr(Num*SizeOf(tIDXEntry));
    IDXCacheStart:=(Addr Div SizeOf(tIDXEntry));

    IDXCacheEnd:=IDXCacheStart+IDXCacheSize-1;
    If IDXCacheEnd>IDXCounter Then IDXCacheEnd:=IDXCounter;

    xMemReadFile(IDXFile, Addr,
      (IDXCacheEnd-IDXCacheStart+1)*SizeOf(tIDXEntry), IDXCache^);
    If Result<>0 Then
      ErrorAbort:=eaIDXRead;

    If (Num<IDXCacheStart) Or (Num>IDXCacheEnd) Or (Num>IDXCounter) Then
      ErrorAbort:=eaIDXCache;
  END;

{***************************************************************************}

  PROCEDURE ReadIDX(Num: LongInt; Var IDX: tIDXEntry);
  { liet IDX-Eintrag }
  BEGIN
    If (Num<IDXCacheStart) Or (Num>IDXCacheEnd) Then Begin
      LoadIDXCache(Num);
      If (Num<IDXCacheStart) Or (Num>IDXCacheEnd) Then Exit;
    End;

    IDX:=IDXCache^[Num-IDXCacheStart];
  END;

{***************************************************************************}

  PROCEDURE WriteIDX(Num: LongInt; Var IDX: tIDXEntry);
  { modifiziert IDX-Eintrag }
  BEGIN
    If (Num<IDXCacheStart) Or (Num>IDXCacheEnd) Then Begin
      LoadIDXCache(Num);
      If (Num<IDXCacheStart) Or (Num>IDXCacheEnd) Then Exit;
    End;

    IDXCache^[Num-IDXCacheStart]:=IDX;
    IDXCacheDirty:=True;
  END;

{***************************************************************************}

  PROCEDURE AddIDX(IDX: tIDXEntry);
  { fgt IDX-Eintrag hinzu }
  VAR IDX2: tIDXEntry;
  BEGIN
    If IDXCounter>IDXCacheEnd Then ReadIDX(IDXCounter, IDX2); { Cache einladen }

    Inc(IDXCounter);
    If IDXCounter Mod IDXCacheSize=0 Then Begin { berlauf }
      SaveIDXCache;
      IDXCacheStart:=IDXCounter;
      IDXCacheEnd:=IDXCacheStart;
    End Else Inc(IDXCacheEnd);

    WriteIDX(IDXCounter, IDX);
  END;

{***************************************************************************}
{ DatFile - Zugriff }
{***************************************************************************}

  PROCEDURE ReadDatFile(Pos: LongInt; Size: Word; Var Puffer);
  BEGIN
    Seek(DatFile, Pos);
    GetError;
    BlockRead(DatFile, Puffer, Size);
    GetError;
  END;

{**************************************************************************}
{ Opendatabase }
{**************************************************************************}

CONST dbvNo      = 0;
      dbvVerify  = 1;
      dbvRestore = 2;
CONST DataBaseOpen     : Boolean    = False;
      DataBaseVerify   : Byte       = dbvNo;
      DataBaseError    : Boolean    = False;

PROCEDURE OpenDatabase;
VAR IDXBuf           : tIDXEntry;
    IDXHeader        : tIDXHeader absolute IDXBuf;

  PROCEDURE WaitIdxRelease;
  CONST WB      : Array[1..4] Of Char = '\/';
  VAR i         : Byte;
      FirstCall : Boolean;
      Ready     : Boolean;

    PROCEDURE Wait;
    BEGIN
      If FirstCall Then Begin
        FirstCall:=False;
{$IFDEF German}
        WriteLn('Kein Zugriff auf die Datenbank mglich. Vermutlich luft PktXCode bereits in');
        WriteLn('einer anderen Task. Warte auf Freigabe der Dateien, ESC zum Abbrechen...');
{$ELSE}
        WriteLn('No access to database possible. Most probably PktXCode is currently running');
        WriteLn('in anohter task. Waiting for release of files, hit ESC to abort...');
{$ENDIF}
      End;

      Write(#13, WB[i]);
      Inc(i);
      If i>SizeOf(WB) Then i:=1;

      Delay(250);
      {$IFNDEF OS2}
      Asm Int $28 End;
      {$ENDIF}

      If (KeyPressed) And (ReadKey=#27) Then ErrorAbort:=eaHalt;
    END;

  BEGIN
    { erst Datfile, dann IdxFile -> umgekehrt wie Compress }
    FirstCall:=True;
    Ready:=False;
    i:=1;

    Repeat
      lfnOpenFile(DatFile, DBPath+DatName, ofRW);
      If Result=5 Then Wait
      Else Begin
        If Result<>0 Then Begin
          lfnOpenFile(DatFile, DBPath+DatName, ofCreate);
          If Result<>0 Then ErrorAbort:=eaDatFileWrite;
        End;

        If Result=0 Then Begin
          lfnOpenFile(IDXFile, DBPath+IDXName, ofRW);
          If Result=5 Then Wait
          Else Begin
            If Result<>0 Then Begin
              lfnOpenFile(IDXFile, DBPath+IDXName, ofCreate);
              If Result<>0 Then ErrorAbort:=eaIDXWrite;
            End;

            If Result=0 Then Ready:=True;
          End;

          If Not Ready Then lfnCloseFile(DatFile);
        End;
      End;
    Until (ErrorAbort<>eaOK) Or (Ready);

    If Not FirstCall Then WriteLn;
  END;

  PROCEDURE CreateNewBuf;
  BEGIN
    lfnCloseFile(IDXFile);
    lfnOpenFile(IDXFile, DBPath+IDXName, ofCreate);
    If Result<>0 Then ErrorAbort:=eaIDXWrite
    Else Begin
      IDXCacheStart:=0;
      IDXCacheEnd:=0;
      IDXCounter:=0;

      FillChar(IDXBuf, SizeOf(IDXBuf), 0);
      IDXHeader.VerInfo:=dbVerInfo;
{     IDXHeader.IDXCounter:=0;
      IDXHeader.DatFileSize:=0;
      IDXHeader.DatKeepSize:=0;}
      GetDateDT(IDXHeader.stDate);
{      IDXHeader.stAllFNumber:=0;
      IDXHeader.stAllFSize:=0;
      IDXHeader.stAllFMsg:=0;
      IDXHeader.stAllFMsgCheck:=0;
      IDXHeader.stAllFMsgData:=0;
      FMsgShortened
      FMsgDeleted
      IDXHeader.stAllFDecode:=0;
      IDXHeader.stDecodeCount:=0;
      IDXHeader.stDecodeSize:=0;
      IDXHeader.stProcessTime:=0; }

      WriteIDX(0, IDXBuf);
    End;
  END;

VAR tmp: Word;
BEGIN
  If DataBaseOpen Then Exit;
  DataBaseOpen:=True;

  New(OutField);
  OutPos:=0;

  New(IDXCache);       { mu vor createnewbuf sein!! }
  IDXCacheStart:=-1;
  IDXCacheEnd:=-1;
  IDXCounter:=-1;
  IDXCacheDirty:=False;
  IDXModified:=False;

  WaitIdxRelease;
  If ErrorAbort=eaOK Then Begin
    If (Result<>0) Or (FileSize(IDXFile)<SizeOf(IDXBuf)) Then CreateNewBuf;

    If ErrorAbort=eaOK Then Begin
      IDXCounter:=0;
      ReadIDX(0, IDXBuf);

      If IDXHeader.verInfo<>dbVerInfo Then CreateNewBuf;

      IDXCounter:=IDXHeader.IDXCounter;
      DatFileSize:=IDXHeader.DatFileSize;
      DatKeepSize:=IDXHeader.DatKeepSize;

      xMemOpenFile(IDXFile, xcRandom, IDXCache^, tmp); { ldt nichts ! }
      If Result<>0 Then
        ErrorAbort:=eaIDXRead;
    End;

    If (ErrorAbort=eaOK) And ( (FileSize(DatFile)<DatFileSize) Or
     ( (FileSize(IdxFile)<>0) And
       (FileSize(IdxFile)<LongInt(IdxCounter+1)*SizeOf(tIDXEntry)) ) ) And
     (DataBaseVerify=dbvNo) Then VerifyDataBase;
  End;

  If (ErrorAbort<>eaOK) And (DataBaseOpen) Then Begin
    Dispose(OutField);
    Dispose(IDXCache);

    lfnCloseFile(DatFile);
    lfnCloseFile(IdxFile);

    DataBaseOpen:=False;
  End;

  If ErrorAbort=eaHalt Then Begin
    WriteLn;
    WriteLn(#13, 'Bye!');
  End;
END;

{**************************************************************************}
{ Closedatabase }
{**************************************************************************}

PROCEDURE CloseDataBase;
{$IFDEF German}
CONST TxtCompDat = 'komprimiere Datenbank';
      TxtCompIdx = 'komprimiere Datenbankindex';
      TxtVerify  = 'prfe Datenbank';
      TxtnoFiles = 'keine Dateien gefunden';
{$ELSE}
CONST TxtCompDat = 'compressing database';
      TxtCompIdx = 'compressing database index';
      TxtVerify  = 'checking database';
      TxtnoFiles = 'no files found';
{$ENDIF}

CONST IdxBufSize = BlockSize Div SizeOf(tIdxEntry);
      clNone = 0;
      clIDX  = 1;
      clAll  = 2;

TYPE tIdxBuf = Array[0..IdxBufSize-1] Of tIdxEntry;
VAR IDX           : tIDXEntry;
    IDXHeader     : tIDXHeader absolute IDX;
    CompressLevel : Byte;

  PROCEDURE RestoreIDXLink;
{$IFDEF German}
  CONST Txt0 = 'restauriere Bezge';
        Txt1 = 'ungltige Verbindung in Datenbank aufgehoben (';
{$ELSE}
  CONST Txt0 = 'restoring references';
        Txt1 = 'invalid reference in database fixed (';
{$ENDIF}
        Txt2 = ')';

  VAR i, j, t : LongInt;
      IDX2    : tIDXEntry;
      Found   : Boolean;
  BEGIN
    OpenWaitWindow(Txt0);

    i:=1;
    While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
      ReadIDX(i, IDX);
      If IDX.Link<>ilUnlinked Then Begin {alten Verbund suchen}
        j:=i;
        t:=0;
        Found:=False;
        Repeat
          Inc(t); {timeout}
          Inc(j);
          If j>IDXCounter Then j:=1;

          ReadIDX(j, IDX2);
          If IDX2.OldIDXPos=IDX.Link Then Begin
            IDX.Link:=j;
            Found:=True;
          End;
        Until Found Or (t>=IDXCounter) Or (ErrorAbort<>eaOK);

        If Not Found Then Begin
          IDX.Link:=ilUnlinked;
          IDX.Flag:=IDX.Flag And (ifFBegin Or ifFEnd);

          WriteLogFile(Txt1+ST(i,1)+Txt2);
        End;
        WriteIDX(i, IDX);
      End;

      Inc(i);
    End;

    CloseWindow;
  END;

  PROCEDURE CompressALL;
  VAR i,
      NDatFileSize,
      NIdxCounter   : LongInt;
      IDXBuf        : ^tIdxBuf;
      IDXBufPos     : Word;
      NIdxFile      : File;
      NDatFile      : File;
      CurrentDate   : TDate;
      Avail         : Word;
  BEGIN
    lfnOpenFile(NIdxFile, DBPath+IdxName2, ofCreate);

    If Result<>0 Then ErrorAbort:=eaDatCompress
    Else Begin
      lfnOpenFile(NDatFile, DBPath+DatName2, ofCreate);

      If Result<>0 Then Begin
        ErrorAbort:=eaDatCompress;
        lfnCloseFile(NIdxFile);
      End Else Begin
        New(IDXBuf);

        xMemOpenFile(NIdxFile, xcWrite, IDXBuf^, Avail);
        If Result<>0 Then ErrorAbort:=eaDatCompress;
        xMemOpenFile(NDatFile, xcWrite, OutField^, Avail);
        If Result<>0 Then ErrorAbort:=eaDatCompress;

        ReadIDX(0, IDXBuf^[0]);

        IDXBufPos:=1;
        NIdxCounter:=0;
        NDatFileSize:=0;
        OutPos:=0;

        GetDateDT(CurrentDate);

        i:=1;
        While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
          ReadIDX(i, IDX);
          If (IDX.Flag And ifErase=0) And
           (GetDateDifference(IDX.Date,CurrentDate)<DelDays) Then Begin
            If (IDX.dStart+IDX.dSize<=DatFileSize) Then Begin
              Inc(NIdxCounter);

              IDX.OldIDXPos:=i;
              Move(IDX, IDXBuf^[IDXBufPos], SizeOf(IDX));
              IDXBuf^[IDXBufPos].dStart:=NDatFileSize;

              { Daten kopieren }
              Inc(NDatFileSize, IDX.dSize);
               { IDX wird eh nicht mehr gebraucht }
              While IDX.dSize>0 Do Begin
                Avail:=BlockSize-OutPos;
                If Avail>IDX.dSize Then Avail:=IDX.dSize;

                ReadDatFile(IDX.dStart, Avail, OutField^[OutPos]);
                Inc(OutPos, Avail);
                If OutPos=BlockSize Then Begin
                  xMemAppendFile(NDatFile, OutField^);
                  If Result<>0 Then
                    If lfnFreeDiskSpace(DBPath[1])<BlockSize
                      Then ErrorAbort:=eaDiskFull
                      Else ErrorAbort:=eaDatCompress;

                  OutPos:=0;
                End;

                Inc(IDX.dStart, Avail);
                Dec(IDX.dSize, Avail);
              End;
              { fertig }

              Inc(IDXBufPos);
              If IDXBufPos=IdxBufSize Then Begin
                xMemAppendFile(NIdxFile, IDXBuf^);
                If Result<>0 Then
                  If lfnFreeDiskSpace(DBPath[1])<BlockSize
                    Then ErrorAbort:=eaDiskFull
                    Else ErrorAbort:=eaDatCompress;

                IDXBufPos:=0;
              End;

              UpdateWaitWindow(NDatFileSize, DatKeepSize);
            End Else DataBaseError:=True;
          End;

          Inc(i);
        End;

        { NIdxfile schlieen }
        xMemCloseFile(NIdxFile, IDXBuf^, Word(IDXBufPos)*SizeOf(IDX));
        If Result<>0 Then
          If lfnFreeDiskSpace(DBPath[1])<BlockSize
            Then ErrorAbort:=eaDiskFull
            Else ErrorAbort:=eaDatCompress;

        DatFileSize:=NDatFileSize;
        DatKeepSize:=NDatFileSize;
        IdxCounter:=NIdxCounter;

        lfnCloseFile(IDXFile);
        lfnCloseFile(NIDXFile);

        Dispose(IDXBuf);

        lfnEraseFile(DBPath+IDXName);
        lfnRenameFile(DBPath+IDXName2, DBPath+IDXName);
        If Result<>0 Then ErrorAbort:=eaDatCompress;

        lfnOpenFile(IDXFile, DBPath+IdxName, ofRW); { fr Taskblocking }

        { Datfile schlieen }
        lfnCloseFile(DatFile);

        xMemCloseFile(NDatFile, OutField^, OutPos);
        If Result<>0 Then
          If lfnFreeDiskSpace(DBPath[1])<BlockSize
            Then ErrorAbort:=eaDiskFull
            Else ErrorAbort:=eaDatCompress;

        lfnCloseFile(NDatFile);

        lfnEraseFile(DBPath+DatName);
        lfnRenameFile(DBPath+DatName2, DBPath+DatName);

        If Result<>0 Then ErrorAbort:=eaDatCompress;
      End;
    End;
  END;

  PROCEDURE CompressIDX;
  VAR NIdxCounter   : LongInt;
      IDXBuf        : ^tIdxBuf;
      IDXBufPos     : Word;
      CurrentDate   : TDate;
      NIdxFile      : File;
      i             : LongInt;
  BEGIN
    lfnOpenFile(NIdxFile, DBPath+IdxName2, ofCreate);

    If Result<>0 Then ErrorAbort:=eaDatCompress
    Else Begin
      IDXBuf:=@OutField^;
      xMemOpenFile(NIdxFile, xcWrite, IDXBuf^, IDXBufPos);
      If Result<>0 Then ErrorAbort:=eaDatCompress;

      ReadIDX(0, IDXBuf^[0]);
      IDXBufPos:=1;
      NIdxCounter:=0;

      GetDateDT(CurrentDate);

      i:=1;
      While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
        ReadIDX(i, IDX);

        If (IDX.Flag And ifErase=0) And (GetDateDifference(IDX.Date,CurrentDate)<DelDays)
         Then Begin
           Inc(NIdxCounter);
           IDX.OldIDXPos:=i;
           Move(IDX, IDXBuf^[IDXBufPos], SizeOf(IDX));

           Inc(IDXBufPos);
           If IDXBufPos=IdxBufSize Then Begin
             xMemAppendFile(NIdxFile, OutField^);
             If Result<>0 Then
               If lfnFreeDiskSpace(DBPath[1])<BlockSize
                 Then ErrorAbort:=eaDiskFull
                 Else ErrorAbort:=eaDatCompress;

             IDXBufPos:=0;
           End;
        End;

        UpdateWaitWindow(i, IDXCounter);
        Inc(i);
      End;

      { Originaldateien schlieen }
      lfnCloseFile(IdxFile);

      IdxCounter:=NIdxCounter;
      xMemCloseFile(NIdxFile, OutField^, Word(IDXBufPos)*SizeOf(tIDXEntry));
      If Result<>0 Then
        If lfnFreeDiskSpace(DBPath[1])<BlockSize
          Then ErrorAbort:=eaDiskFull
          Else ErrorAbort:=eaDatCompress;

      lfnCloseFile(NIdxFile);

      lfnEraseFile(DBPath+IdxName);
      lfnRenameFile(DBPath+IdxName2, DBPath+IdxName);

      If Result<>0 Then ErrorAbort:=eaDatCompress;

      lfnOpenFile(IdxFile, DBPath+IdxName, ofRW); { Taskblocking }
    End;
  END;

BEGIN
  If Not DataBaseOpen Then Exit;

  SaveIDXCache;
  xMemCloseFile(IDXFile, IDXCache^, 0);
  If Result<>0 Then
    If lfnFreeDiskSpace(DBPath[1])<BlockSize
      Then ErrorAbort:=eaDiskFull
      Else ErrorAbort:=eaIDXWrite;

  Seek(IDXFile, (IDXCounter+1)*SizeOf(tIDXEntry));
  GetError;
  Truncate(IDXFile);
  GetError;

  If ErrorAbort<>eaOK Then CompressLevel:=clNone
  Else If DataBaseVerify=dbvVerify Then  CompressLevel:=clAll
  Else If DataBaseVerify=dbvRestore Then CompressLevel:=clNone
  Else If IdxModified Then
         If DatKeepSize<=DatFileSize Div 2 Then CompressLevel:=clAll
         Else CompressLevel:=clIdx
       Else CompressLevel:=clNone;

  If DataBaseVerify=dbvVerify Then OpenWaitWindow(TxtVerify)
  Else If CompressLevel=clAll Then OpenWaitWindow(TxtCompDat)
  Else OpenWaitWindow(TxtCompIdx);

  If CompressLevel=clAll Then CompressAll
  Else If CompressLevel=clIdx Then CompressIDX;

  Seek(IdxFile, 0);
  GetError;
  If Result=0 Then Begin
    BlockRead(IDXFile, IDX, SizeOf(IDX));
    GetError;
  End;

  If (Result<>0) And (ErrorAbort=eaOK) Then ErrorAbort:=eaDatCompress;
  IDXHeader.IDXCounter:=IDXCounter;
  IDXHeader.DatFileSize:=DatFileSize;
  IDXHeader.DatKeepSize:=DatKeepSize;

  CloseWindow;
  If (DataBaseVerify=dbvNo) And (JobExec And JobDecodeFiles<>0)
    Then XMemShowSize;

  If (JobExec And jobDecodeStatistic<>0) And
    ( (DataBaseVerify=dbvRestore) Or (CompressLevel=clNone) ) Then Begin
      If (stAllFSize>0) Or (stDecodeCount>0) Then Begin
        Statistics;
        DoLogSummary(IDX);
      End Else If (stAllFSize=0) And (stDecodeCount=0) Then WriteLn(TxtnoFiles);
  End;

  Seek(IdxFile, 0);
  GetError;
  If Result=0 Then Begin
    BlockWrite(IDXFile, IDX, SizeOf(IDX));
    GetError;
  End;
  If (Result<>0) And (ErrorAbort=eaOK) Then ErrorAbort:=eaDatCompress;

  lfnCloseFile(IDXFile);
  lfnCloseFile(DatFile);

  Dispose(OutField);
  Dispose(IDXCache);
  DataBaseOpen:=False;

  If (DataBaseVerify=dbvNo) And ((CompressLevel=clAll) Or (CompressLevel=clIdx))
   Then Begin
    DataBaseVerify:=dbvRestore;
    OpenDatabase; { keine weitere Rekursion !!! }
    RestoreIDXLink;
    CloseDatabase; { Verify }
    DataBaseVerify:=dbvNo;
  End;
END;

{***************************************************************************}
{ Datenbank prfen }
{***************************************************************************}

PROCEDURE VerifyDataBase;
{$IFDEF German}
CONST Txt01 = 'Datenbank wird berprft';
      Txt02 = '* Indexdatei gekrzt';
      Txt03 = '* Datendatei gekrzt';
{$ELSE}
CONST Txt01 = 'checking database';
      Txt02 = '* index file shortened';
      Txt03 = '* data file shortened';
{$ENDIF}
VAR i: LongInt;
BEGIN
  JobExec:=JobExec And (Not jobVerifyDatabase); { falls autom. Aufruf }

  WriteLn(Txt01);
  WriteLogFile(Txt01);

  i:=FileSize(IDXFile) Div SizeOf(tIDXEntry);
  If i>0 Then Dec(i);
  If i<IDXCounter Then Begin
    WriteLn(Txt02);
    WriteLogFile(Txt02);
    IDXCounter:=i;
  End;

  DatFileSize:=FileSize(DatFile);

  DataBaseVerify:=dbvVerify;
  CloseDatabase; { Verify }
  DataBaseVerify:=dbvVerify; { falls verndert hat }
  OpenDatabase; { keine weitere Rekursion !!! }
  DataBaseVerify:=dbvNo;

  If DataBaseError Then Begin
    DataBaseError:=False;
    WriteLn(Txt03);
    WriteLogFile(Txt03);
  End;
END;

{***************************************************************************}
{ LogDatei }
{***************************************************************************}

VAR LogFile,
    LogMailFile      : lfnTextBuf;

PROCEDURE WriteLogFile(Txt: String);
{ in Logdatei/XPLogdatei schreiben, ggf. vorher ffnen }
BEGIN
  If LogPath[0]<>#0 Then Begin
    If Not LogFileOpen Then Begin
      lfnOpenTextFile(LogFile, LogPath+LogName, ofAppend);

      If Result=0 Then Begin
        If lfnTextFilePos(LogFile)=0 Then Begin
          lfnWriteTextFile(LogFile, verName+ {$IFDEF German} ' - Logdatei'
                                            {$ELSE} ' - log file'{$ENDIF}
                                +#13#10);
        End;

        LogFileOpen:=True;
        Txt:=GetDateTimeStr+' '+Txt;
      End Else Begin
        LogPath:='';
        Exit;
      End;
{$IFDEF German}
    End Else Txt:='                 '+Txt;
{$ELSE}
    End Else Txt:='                  '+Txt;
{$ENDIF}

    lfnWriteTextFile(LogFile, Txt);
  End;

  If LogMailArea[0]<>#0 Then Begin
    If Not LogMailFileOpen Then Begin
      lfnOpenTextFile(LogMailFile, DBPath+LogXPName, ofCreate);
      If Result=0 Then Begin
        lfnWriteTextFile(LogMailFile, verName+
          {$IFDEF German} ' - Logbericht'
          {$ELSE} +' - log report' {$ENDIF} +#13#10);
        LogMailFileOpen:=True;
      End Else Begin
        LogMailArea:='';
        Exit;
      End;
    End;

    lfnWriteTextFile(LogMailFile, Txt);
  End;
END;

{***************************************************************************}

PROCEDURE CreateMailLogFile;
{ Logmail erstellen }
VAR Mail                 : lfnTextBuf;
    F1, F2               : File;
    Buffer               : Pointer;
    Got                  : {$IFDEF OS2} LongInt {$ELSE} Word {$ENDIF} ;
BEGIN
  If (LogMailFileName[0]<>#0) And lfnExistFile(LogMailFileName) Then Begin
      lfnOpenTextFile(Mail, LogMailFileName, ofAppend);
      If Result=0 Then Begin
        lfnWriteTextFile(Mail, 'EMP: '+LogMailArea);
        lfnWriteTextFile(Mail, 'ABS: '+verName);
        lfnWriteTextFile(Mail, 'BET: PktXCode '+GetDateTimeStr);
        lfnWriteTextFile(Mail, 'EDA: '+GetDateTimeXP);
        lfnWriteTextFile(Mail, 'MID: ');
        lfnWriteTextFile(Mail, 'ROT:');
        lfnWriteTextFile(Mail, 'X-XP-NTP: 30');
        lfnWriteTextFile(Mail, 'LEN: '+ST(lfnFileSizeOf(DBPath+LogXPName),1));
        lfnWriteTextFile(Mail, '');
        lfnCloseTextFile(Mail);

        lfnOpenFile(F2, LogMailFileName, ofRW);
        Seek(F2, FileSize(F2));
        lfnOpenFile(F1, DBPath+LogXPName, ofRead);

        GetMem(Buffer, BlockSize);
        Repeat
          BlockRead(F1, Buffer^, BlockSize, Got);
          GetError;
          If Result=0 Then Begin
            BlockWrite(F2, Buffer^, Got);
            GetError;
          End;
        Until (Result<>0) Or (Got<>BlockSize);
        FreeMem(Buffer, BlockSize);

        lfnCloseFile(F1);
        lfnCloseFile(F2);
      End;
  End;
  lfnEraseFile(DBPath+LogXPName);
END;


PROCEDURE CloseLogFile;
BEGIN
  If (ErrorAbort<>eaOK) And (LogLevel And LogErrors<>0) Then
    WriteLogFile(ErrorText);

  If LogFileOpen Then Begin
    lfnCloseTextFile(LogFile);
    LogFileOpen:=False;
  End;
  If LogMailFileOpen Then Begin
    lfnCloseTextFile(LogMailFile);
    LogMailFileOpen:=False;
    CreateMailLogFile;
  End;
END;

{***************************************************************************}
{ Logsummary }
{***************************************************************************}

FUNCTION percent(a,b:longint): longint;
{ berechnet prozentsatz von prozentwert a und grundwert b,
  beachtet longint-berlauf }
BEGIN
  if a>21474836 then percent:=a div (b div 100)
  else percent:=(a*100) div b;
END;


PROCEDURE DoLogSummary(Var IDXBuf: tIDXEntry);
{$IFDEF German}
CONST Txt01 = ' - Zusammenfassung';
      Txt02 = 'bearbeitete Daten seit dem ';
      Txt03 = '     bearbeitete Packete:            ';
      Txt04 = '     durchschnittliche Packetgre:  ';
      Txt05 = '     geprfte Nachrichten:           ';
      Txt06 = ' von ';
      Txt07 = '     dekodierte Nachrichten:         ';
      Txt08 = '     gekrzte Nachrichten:           ';
      Txt09 = '     gelschte Nachrichten:          ';
      Txt10 = '     Datenvolumen:                   ';
      Txt11 = '     vollstndige Dateien:           ';
      Txt12 = '     durchschnittliche Dateigre:   ';
      Txt13 = '     bentigte Zeit:               ';
{$ELSE}
CONST Txt01 = ' - summary';
      Txt02 = 'processed data since ';
      Txt03 = '     processed pakets:          ';
      Txt04 = '     average paket size:        ';
      Txt05 = '     processed messages:        ';
      Txt06 = ' of ';
      Txt07 = '     decoded messages:          ';
      Txt08 = '     shortened messages:        ';
      Txt09 = '     deleted messages:          ';
      Txt10 = '     data volume:               ';
      Txt11 = '     complete files:            ';
      Txt12 = '     average file size:         ';
      Txt13 = '     needed time:             ';
{$ENDIF}

VAR F            : lfnTextBuf;
    L            : String;
    IDXHeader    : tIDXHeader absolute IDXBuf;
BEGIN
  If (LogSumPath[0]=#0) Then Exit;

  If lfnExistFile(LogSumPath+LogSName) Then Begin
    Inc(IDXHeader.stAllFNumber,       stAllFNumber);
    Inc(IDXHeader.stAllFSize,         stAllFSize Shr 10);
    Inc(IDXHeader.stAllFMsg,          stAllFMsg);
    Inc(IDXHeader.stAllFMsgCheck,     stAllFMsgCheck);
    Inc(IDXHeader.stAllFMsgData,      stAllFMsgData);
    Inc(IDXHeader.stAllFMsgShortened, stAllFMsgShortened);
    Inc(IDXHeader.stAllFMsgDeleted,   stAllFMsgDeleted);
    Inc(IDXHeader.stAllFDecode,       stAllFDecode Shr 10);
    Inc(IDXHeader.stDecodeCount,      stDecodeCount);
    Inc(IDXHeader.stDecodeSize,       stDecodeSize Shr 10);
    Inc(IDXHeader.stProcessTime,      stProcessTime);
  End Else Begin
    GetDateDT(IDXHeader.stDate);
    IDXHeader.stAllFNumber      :=stAllFNumber;
    IDXHeader.stAllFSize        :=stAllFSize Shr 10;
    IDXHeader.stAllFMsg         :=stAllFMsg;
    IDXHeader.stAllFMsgCheck    :=stAllFMsgCheck;
    IDXHeader.stAllFMsgData     :=stAllFMsgData;
    IDXHeader.stAllFMsgShortened:=stAllFMsgShortened;
    IDXHeader.stAllFMsgDeleted  :=stAllFMsgDeleted;
    IDXHeader.stAllFDecode      :=stAllFDecode Shr 10;
    IDXHeader.stDecodeCount     :=stDecodeCount;
    IDXHeader.stDecodeSize      :=stDecodeSize Shr 10;
    IDXHeader.stProcessTime     :=stProcessTime;
  End;

  lfnOpenTextFile(F, LogSumPath+LogSName, ofCreate);
  If Result=0 Then Begin
    lfnWriteTextFile(F, verName + Txt01);
    lfnWriteTextFile(F, '');

    lfnWriteTextFile(F, Txt02
    {$IFDEF German} + LeadingZero(IDXHeader.stDate.Day,2)+'.'
      +LeadingZero(IDXHeader.stDate.Month,2)+'.'
      +LeadingZero(IDXHeader.stDate.Year,4)+':');
    {$ELSE}         + LeadingZero(IDXHeader.stDate.Month,2)+'-'
      +LeadingZero(IDXHeader.stDate.Day,2)+'-'
      +LeadingZero(IDXHeader.stDate.Year,4)+':');
    {$ENDIF}

    lfnWriteTextFile(F, Txt03 + ST(IDXHeader.stAllFNumber,6)+' ('
     +ST(IDXHeader.stAllFSize,1)+' kb)');

    If IDXHeader.stAllFNumber<>0 Then Begin
      L:=Txt04 + ST(IDXHeader.stAllFSize Div IDXHeader.stAllFNumber,6)+' kb';
      lfnWriteTextFile(F, L);
    End;

    L:=Txt05 +ST(IDXHeader.stAllFMsgCheck,6)+Txt06+ST(IDXHeader.stAllFMsg,1);
    If IDXHeader.stAllFMsgCheck<>0 Then
      L:=L+' ('+ST(percent(IDXHeader.stAllFMsgCheck, IDXHeader.stAllFMsg),3)+'%)';
    lfnWriteTextFile(F, L);

    L:=Txt07 +ST(IDXHeader.stAllFMsgData,6)+Txt06 +ST(IDXHeader.stAllFMsg,1);
    If IDXHeader.stAllFMsg<>0 Then
      L:=L+' ('+ST(percent(IDXHeader.stAllFMsgData, IDXHeader.stAllFMsg),3)+'%)';
    lfnWriteTextFile(F, L);

    L:=Txt08 +ST(IDXHeader.stAllFMsgShortened,6)+Txt06 +ST(IDXHeader.stAllFMsg,1);
    If IDXHeader.stAllFMsg<>0 Then
      L:=L+' ('+ST(percent(IDXHeader.stAllFMsgShortened, IDXHeader.stAllFMsg),3)+'%)';
    lfnWriteTextFile(F, L);

    L:=Txt09 +ST(IDXHeader.stAllFMsgDeleted,6)+Txt06 +ST(IDXHeader.stAllFMsg,1);
    If IDXHeader.stAllFMsg<>0 Then
      L:=L+' ('+ST(percent(IDXHeader.stAllFMsgDeleted, IDXHeader.stAllFMsg),3)+'%)';
    lfnWriteTextFile(F, L);

    L:=Txt10+ST(IDXHeader.stAllFDecode,6)+' kb';
    If IDXHeader.stAllFSize<>0 Then
      L:=L+' ('+ST(percent(IDXHeader.stAllFDecode, IDXHeader.stAllFSize),3)+'%)';
    lfnWriteTextFile(F, L);

    lfnWriteTextFile(F, Txt11+ST(IDXHeader.stDecodeCount,6)+' ('
      +ST(IDXHeader.stDecodeSize,1)+' kb)');

    If IDXHeader.stDecodeCount<>0 Then
      lfnWriteTextFile(F, Txt12+ ST(IDXHeader.stDecodeSize Div IDXHeader.stDecodeCount,6)+' kb');

    L:=Txt13+ST(IDXHeader.stProcessTime Div 10,6)
      +'.'+ST(IDXHeader.stProcessTime Mod 10,1)+'s';
    If IDXHeader.stProcessTime>0 Then
      L:=L+' ('+ST((IDXHeader.stAllFSize*10) Div IDXHeader.stProcessTime,1)
     +' kb/s)';
    lfnWriteTextFile(F, L);

    lfnCloseTextFile(F);
  End;
END;

{***************************************************************************}
{ Statistik auf Bildschirm / Logfiles }
{***************************************************************************}

PROCEDURE Statistics;
{ gibt Statistik auf Bildschirm und in smtlichen Dateien aus }
{$IFDEF German}
CONST Txt01 = 'bearbeitete Dateien:           ';
      Txt02 = 'Nachrichten/geprft/dekodiert: ';
      Txt03 = 'Nachrichten gekrzt/gelscht:  ';
      Txt04 = 'Datenvolumen:                  ';
      Txt05 = 'vollstndige Dateien:          ';
      Txt06 = 'bentigte Zeit:              ';
      Spr01 = 'Frohe Weihnachten!';
      Spr02 = 'Guten Rutsch ins neue Jahr!';
      Spr03 = 'Frohes neues Jahr!';
      Spr04 = '>>> PktXCode - the better one wins <<<';
      Spr05 = 'PktXCode - soviel Zeit mu sein';
      Spr06 = 'fast, faster, PktXCode';
{$ELSE}
CONST Txt01 = 'processed files:              ';
      Txt02 = 'messages/processed/decoded:   ';
      Txt03 = 'messages shortened/deleted:   ';
      Txt04 = 'data volume:                  ';
      Txt05 = 'complete files:               ';
      Txt06 = 'needed time:                ';
      Spr01 = 'Happy christmas!';
      Spr02 = 'A good change to the new year!';
      Spr03 = 'A happy new year!';
      Spr04 = '>>> PktXCode - the better one wins <<<';
      Spr05 = 'PktXCode - take its time';
      Spr06 = 'fast, faster, PktXCode';
{$ENDIF}
VAR L, L2   : String[80];
    i       : LongInt;
    curDate : tDate;

  PROCEDURE Out;
  BEGIN
    WriteLn(L);
    If ((logLevel And logSummaryData<>0) And (stAllFMsgData>0)) Or
        (logLevel And logSummaryEver<>0) Then WriteLogFile(L);
  END;

BEGIN
  WriteLn;
  If LogFileOpen Then WriteLogFile('');
  { nur, wenn bereits beschrieben wurde }

  L:=Txt01+ST(stAllFNumber,4)+' (' +ST(stAllFPrcd Div 1024,1)+' kb)';
  Out;

  L:=Txt02+ST(stAllFMsg,4)+' / '+ST(stAllFMsgCheck,1)+' / '
    +ST(stAllFMsgData,1);
  If stAllFMsg<>0 Then L:=L+' ('+ST(percent(stAllFMsgData, stAllFMsg),3)+'%)';
  Out;

  L:=Txt03+ST(stAllFMsgShortened,4);
  If stAllFMsg<>0 Then L:=L+' ('+ST(percent(stAllFMsgShortened, stAllFMsg),3)+'%)';
  L:=L+' / '+ST(stAllFMsgDeleted,1);
  If stAllFMsg<>0 Then L:=L+' ('+ST(percent(stAllFMsgDeleted, stAllFMsg),3)+'%)';
  Out;

  L:=Txt04+ST(stAllFDecode Div 1024,4)+' kb';
  If stAllFPrcd<>0 Then L:=L+' ('+ST(percent(stAllFDecode, stAllFPrcd),3)+'%)';
  Out;

  L:=Txt05+ST(stDecodeCount,4)+' (' +ST(stDecodeSize Div 1024,1)+' kb)';
  Out;

  stProcessTime:=GetTimeReal-stProcessTime;
  L:=Txt06+ST(stProcessTime Div 10,4)+'.'
    +ST(stProcessTime Mod 10,1)+'s';

  i:=stProcessTime*1024;
  If i>0 Then L:=L+' ('+ST((stAllFSize*10) Div i,1)+' kb/s)';
  Out;

  GetDateDT(curDate);
  If (CurDate.Month=12) And ((CurDate.Day=25) Or (CurDate.Day=26)) Then L2:=Spr01
  Else If (CurDate.Month=12) And (CurDate.Day>=30)                 Then L2:=Spr02
  Else If (CurDate.Month= 1) And (CurDate.Day = 1)                 Then L2:=Spr03
  Else If (CurDate.Month= 5) And (CurDate.Day = 3)                 Then L2:=Spr04
  Else If (CurDate.Month=11) And (CurDate.Day>=25)                 Then L2:=Spr05
  Else If (CurDate.Month= 4) And (CurDate.Day = 1)                 Then L2:=Spr06
  Else L2:='';

  If L2<>'' Then Begin
    L:='';
    Out;
    L:=L2;
    Out;
  End;
END;

{***************************************************************************}
{ INI-File }
{***************************************************************************}

PROCEDURE LoadINIFile;
{$IFDEF German}
CONST TxtCommand  = 'ungltiges Kommando: ';
      TxtDupeHand = 'ungltige DUPEHANDLING-Einstellung: ';
      TxtDelDay   = 'ungltige DELDAY-Einstellung';
      TxtMemSize  = 'ungltige MEMSIZE-Einstellung';
      TxtCtcSubj  = 'ungltige CRITICALSUBJLEN-Einstellung';
      TxtAnfZeich = 'Anfhrungszeichen fehlen: ';
      TxtMaxArea1 = 'es sind max. ';
      TxtMaxArea2 = ' verschiedene Areaeintrge mglich!';
      TxtLine     = 'fehlerhafte Zeile: ';
      TxtReadErr  = 'INI-Datei kann nicht gelesen werden';
      TxtDBErr    = 'Pfad fr Datenbank ist nicht definiert';
      TxtExtErr   = 'Pfad fr neue Dateien ist nicht definiert';
      TxtExtBErr  = 'Pfad fr fehlerhafte Dateien ist nicht definiert';
      TxtError1   = 'Fehler in Zeile ';
      TxtError2   = ' der INI-Datei !';
      TxtReason   = 'Grund: ';
      TxtdbECP    = 'Erstellen (Ja/Nein/Alle) ?';

      TxtAddr     = 'fehlerhafte Adresse: ';
      TxtPath     = 'der angegebene Pfad des Binkley-Outbounds existiert nicht';
      TxtBout     = 'Fehler beim Aufruf einer BinkOut-Funktion';
      TxtFPath    = 'der angegebene Pfad existiert nicht';
      TxtAka      = 'es wurde keine Aka-Adresse angegeben';
      TxtSTxt     = 'es wurde kein Nachrichtentext definiert';
{$ELSE}
CONST TxtCommand  = 'invalid command: ';
      TxtDupeHand = 'invalid DUPEHANDLING setting: ';
      TxtDelDay   = 'invalid DELDAY setting';
      TxtMemSize  = 'invalid MEMSIZE setting';
      TxtCtcSubj  = 'invalid CRITICALSUBJLEN setting';
      TxtAnfZeich = 'inverted commans missing: ';
      TxtMaxArea1 = 'you reached the maximum of ';
      TxtMaxArea2 = ' entrys for areas!';
      TxtLine     = 'incorrect line: ';
      TxtReadErr  = 'unable to read INI file';
      TxtDBErr    = 'path for database not defined';
      TxtExtErr   = 'path for new files not defined';
      TxtExtBErr  = 'path for bad new files not defined';
      TxtError1   = 'error in line ';
      TxtError2   = ' of INI file !';
      TxtReason   = 'reason: ';
      TxtdbECP    = 'Create (Yes/No/All) ?';

      TxtAddr     = 'bad address:' ;
      TxtPath     = 'the spezified Binkley-Outbound does not exist';
      TxtBout     = 'error calling an BinkOut function';
      TxtFPath    = 'the spezified path does not exist';
      TxtAka      = 'no aka adress defined';
      TxtSTxt     = 'no message text defined';
{$ENDIF}

CONST mNone      = 0;
      mGeneral   = 1;
      mDArea     = 2;
      mMArea     = 3;
      mEPath     = 4;
      mNMFilter  = 5;
      mFilter    = 6;
      mTextShort = 7;
      mTextSend  = 8;

CONST dbECPAsk  : Boolean = True;

VAR F                : Text;
    Line, L2, Error  : String;
    Mode             : Byte;
    LCount           : LongInt;
    Buffer           : Pointer;
    OutBoundPath     : String;

  FUNCTION dbExistCreatePath(Var Path: String): Boolean;
  VAR c       : Char;
      EndTime : LongInt;
  BEGIN
    If Not lfnExistPath(Path) Then Begin
      If dbECPAsk Then Begin
        WriteLn;
        WriteLn(Path+notexist);
        WriteLn(TxtdbECP);

        EndTime:=GetTimeReal+600;
        While KeyPressed Do c:=ReadKey;
        c:=#0;
        Repeat
          Write(#13+ST((EndTime-GetTimeReal) Div 10,2));
          If GetTimeReal>=EndTime Then c:='N';

          While KeyPressed Do c:=Upcase(ReadKey);
        Until (c In ['Y','J','N','A',#27]);

        WriteLn(#13'  ');
        If c='A' Then dbECPAsk:=False;

        If c In ['N',#27] Then dbExistCreatePath:=False
        Else dbExistCreatePath:=lfnExistCreatePath(Path);
      End Else dbExistCreatePath:=lfnExistCreatePath(Path);
    End Else dbExistCreatePath:=True;
  END;

  FUNCTION GetQuotMarkTxt(Var Txt: String): Boolean;
  BEGIN
    If (Copy(Txt, 1, 1)='"') And (Copy(Txt, Length(Txt), 1)='"')
      Then Begin
        Txt:=Copy(Txt, 2, Length(Txt)-2);
        GetQuotMarkTxt:=True;
      End Else GetQuotMarkTxt:=False;
  END;

  FUNCTION GetDupeHandling(Txt: String): Byte;
  BEGIN
    If Txt='SKIP'            Then GetDupeHandling:=dupSkip
    Else If Txt='RENAME'     Then GetDupeHandling:=dupRenameFile
    Else If Txt='RENAMEEXT'  Then GetDupeHandling:=dupRenameExt
    Else If Txt='OVERWRITE'  Then GetDupeHandling:=dupOverwrite
    Else If Txt='COMPARE'    Then GetDupeHandling:=dupCompare
    Else If Txt='COMPAREALL' Then GetDupeHandling:=dupCompareAll
    Else If Txt='KEEP'       Then GetDupeHandling:=dupKeep
    Else Error:=TxtDupeHand+Txt;
  END;

  PROCEDURE DoLineGeneral;
  VAR i                  : Byte;
      Command, Arg, Arg2 : String[127]; { Arg2: ohne Upcase }

    FUNCTION YesNo(Var B): Boolean;
    VAR Bo : Boolean absolute B;
    BEGIN
      If Arg='YES' Then Begin
        Bo:=True;
        YesNo:=True
      End Else If Arg='NO' Then Begin
        Bo:=False;
        YesNo:=True;
      End Else YesNo:=False;
    END;

  BEGIN
   i:=Pos('=', Line);
   If i=0 Then Error:=TxtCommand+L2
   Else Begin
    Command:=Copy(Line,1,i-1);
    Arg:=Copy(Line,i+1,255);
    Arg2:=Copy(L2,i+1,255);
    CompressStr(Arg);
    CompressStr(Arg2);

    { Pfade }
    If Command='DATABASEPATH' Then Begin
      DBPath:=fnFull(Arg2);
      If Not dbExistCreatePath(DBPath) Then Error:=DBPath+notexist;
    End Else If Command='EXTRACTPATH' Then Begin
      ExtPath:=fnFull(Arg2);
      If Not dbExistCreatePath(ExtPath) Then Error:=ExtPath+notexist;
    End Else If Command='EXTRACTBADPATH' Then Begin
      ExtBadPath:=fnFull(Arg2);
      If Not dbExistCreatePath(ExtBadPath) Then Error:=ExtBadPath+notexist;
    End Else If Command='LOGPATH' Then Begin
      LogPath:=fnFull(Arg2);
      If Not dbExistCreatePath(LogPath) Then Error:=LogPath+notexist;
    End Else If Command='LOGSUMPATH' Then Begin
      LogSumPath:=fnFull(Arg2);
      If Not dbExistCreatePath(LogSumPath) Then Error:=LogSumPath+notexist;

    { Zahlen }
    End Else If Command='DELDAYS' Then Begin
      Deldays:=Value(Arg);
      If Deldays<0 Then Error:=TxtDelday;
    End Else If Command='CRITICALSUBJLEN' Then Begin
      If Value(Arg)>255 Then Error:=TxtCtcSubj
      Else CriticalSubjLen:=Value(Arg);

    { Texte }
    End Else If Command='LOGMAILAREA' Then Begin
      If GetQuotMarkTxt(Arg2) Then LogMailArea:=Arg2
      Else Error:=TxtAnfZeich+L2;
    End Else If Command='FILEDESCSTYLE' Then Begin
      If GetQuotMarkTxt(Arg2) Then CreateDescStyle:=Arg2
      Else Error:=TxtAnfZeich+L2;
    End Else If Command='TEXTMARK' Then Begin
      If GetQuotMarkTxt(Arg2) Then TextMark:=Arg2
      Else Error:=TxtAnfZeich+L2
    End Else If Command='SPLITTEXT' Then Begin
      If GetQuotMarkTxt(Arg2) Then SplitText:=Arg2
      Else Error:=TxtAnfZeich+L2

    { Schalter }
    End Else If Command='AUTOFILEEXTENSION' Then Begin
      If Not YesNo(AutoFileExtension)
      Then Error:=TxtCommand+L2; { Funktionswert egal }
    End Else If Command='FORCEFILEJOINING' Then Begin
      If Not YesNo(ForceFileJoining)
      Then Error:=TxtCommand+L2; { Funktionswert egal }
    End Else If Command='ZIPMAGIC95COMPATIBILITY' Then Begin
      If Not YesNo(ZipMagic95Comp)
      Then Error:=TxtCommand+L2; { Funktionswert egal }
    End Else If Command='USELONGNAMES' Then Begin
      If Not YesNo(lfnUseLongNames)
      Then If Arg='FORCE' Then lfnUseLongNames:=lfnUForce
           Else Error:=TxtCommand+L2; { Funktionswert egal }
    End Else If Command='USEBASE64HEADER' Then Begin
      If Not YesNo(UseBase64Header)
      Then If Arg='AUTO' Then UseBase64Header:=b64Auto
           Else Error:=TxtCommand+L2;
    End Else If Command='MEMSIZE' Then Begin
      If Arg='AUTO' Then XMemSize:=AutoMemSize
      Else Begin
        XMemSize:=Value(Arg);
        If XMemSize>MaxMemSize Then Error:=TxtMemSize;
      End;
    End Else If Command='DUPEHANDLING' Then Begin
      DupeHandling:=GetDupeHandling(Arg)
    { differenzierte Werte }
    End Else If Command='FILEDESC' Then Begin
      CreateDesc:=descNone;

      While Length(Arg)>0 Do Begin
        i:=Pos(',', Arg);
        If i=0 Then i:=Length(Arg)+1;

        If      Copy(Arg,1,i-1)='BBS'   Then CreateDesc:=CreateDesc Or descBBS
        Else If Copy(Arg,1,i-1)='4DOS'  Then CreateDesc:=CreateDesc Or desc4DOS
        Else Begin
          Error:=TxtCommand+L2+' ('+Copy(Arg,1,i-1)+')';
          Arg:='';
        End;
        Delete(Arg,1,i);
        CompressStr(Arg);
      End;
    End Else If Command='LOGLEVEL' Then Begin
      LogLevel:=logNone;

      While Length(Arg)>0 Do Begin
        i:=Pos(',', Arg);
        If i=0 Then i:=Length(Arg)+1;

        If      Copy(Arg,1,i-1)='EXTRACT'       Then LogLevel:=LogLevel Or logExtract
        Else If Copy(Arg,1,i-1)='FILEDESC'      Then LogLevel:=LogLevel Or logFileDesc
        Else If Copy(Arg,1,i-1)='ERRORS'        Then LogLevel:=LogLevel Or logErrors
        Else If Copy(Arg,1,i-1)='DELETE'        Then LogLevel:=LogLevel Or logDelete
        Else If Copy(Arg,1,i-1)='RENAME'        Then LogLevel:=LogLevel Or logRename
        Else If Copy(Arg,1,i-1)='SKIP'          Then LogLevel:=LogLevel Or logSkip
        Else If Copy(Arg,1,i-1)='OVERWRITE'     Then LogLevel:=LogLevel Or logOverWrite
        Else If Copy(Arg,1,i-1)='STATISTICDATA' Then LogLevel:=LogLevel Or logSummaryData
        Else If Copy(Arg,1,i-1)='STATISTICEVER' Then LogLevel:=LogLevel Or logSummaryEver
        Else If Copy(Arg,1,i-1)='ALL'           Then LogLevel:=LogLevel Or logAll
        Else Begin
          Error:=TxtCommand+L2+' ('+Copy(Arg,1,i-1)+')';
          Arg:='';
        End;
        Delete(Arg,1,i);
        CompressStr(Arg);
      End;
    End Else Error:=TxtCommand+L2;
   End;
  END;

  PROCEDURE DoLineDecodeArea;
  {-*assembler*}
  VAR p, p2: pDecodeArea;
  BEGIN
    If ((Line[1]='+') Or (Line[1]='-')) And (Length(Line)>1) Then Begin
      If DecodeAreaCount<DecodeAreaCountMax Then Begin
        Inc(DecodeAreaCount);

        p:=DecodeAreaP;
        If p=NIL Then Begin
          New(p);
          DecodeAreaP:=p;
        End Else Begin
          While p^.Next<>NIL Do
            p:=p^.Next;

          New(p2);
          p^.Next:=p2;
          p:=p2;
        End;

        p^.Next:=NIL;
        p^.Positive:=(Line[1]='+');
        p^.Area:=Copy(Line,2,255);
      End Else Error:=TxtMaxArea1+ST(DecodeAreaCountMax,1)+TxtMaxArea2;
    End Else Error:=TxtLine+Line;
  END;

  PROCEDURE DoLineModifyArea;
  {*assembler*,no/shorten/delete/maydelete,pkt+text+zconnect}
  VAR p, p2        : pModifyArea;
      Area         : String;
      Mode, Typ, i : Byte;
      LineErr      : Boolean;
  BEGIN
    LineErr:=False;

    i:=1;
    While (i<=Length(Line)) And (Line[i]<>',') Do Inc(i);
    Area:=Copy(Line,1,i-1);

    Delete(Line,1,i);
    i:=1;
    While (i<=Length(Line)) And (Line[i]<>',') Do Inc(i);
    If      Copy(Line,1,i-1)='NO'        Then Mode:=mmNo
    Else If Copy(Line,1,i-1)='SHORTEN'   Then Mode:=mmShorten
    Else If Copy(Line,1,i-1)='DELETE'    Then Mode:=mmDelete
    Else If Copy(Line,1,i-1)='MAYDELETE' Then Mode:=mmMayDelete
    Else LineErr:=True;

    Typ:=0;
    Delete(Line,1,i);
    Repeat
      i:=Pos('+', Line);
      If i=0 Then i:=Length(Line)+1;

      If      Copy(Line,1,i-1)='PKT'      Then Typ:=Typ Or ptPKT
      Else If Copy(Line,1,i-1)='MSG'      Then Typ:=Typ Or ptMSG
      Else If Copy(Line,1,i-1)='ZCONNECT' Then Typ:=Typ Or ptZConnect
      Else If Copy(Line,1,i-1)='TEXT'     Then Typ:=Typ Or ptUnknown
      Else LineErr:=True;

      Delete(Line,1,i);
    Until Length(Line)=0;

    If (Not LineErr) Then Begin
      If (ModifyAreaCount<ModifyAreaCountMax) Then Begin
        Inc(ModifyAreaCount);

        p:=ModifyAreaP;
        If p=NIL Then Begin
          New(p);
          ModifyAreaP:=p;
        End Else Begin
          While p^.Next<>NIL Do
              p:=p^.Next;

          New(p2);
          p^.Next:=p2;
          p:=p2;
        End;

        p^.Next:=NIL;
        p^.Area:=Area;
        p^.Mode:=Mode;
        p^.Typ :=Typ;
      End Else Error:=TxtMaxArea1+ST(ModifyAreaCountMax,1)+TxtMaxArea2;
    End Else Error:=TxtLine+L2;
  END;

  PROCEDURE DoLineExtractPath;
  { D:\PKTXCODE\ASM,skip,ASSEMBLER.GER,"JPG" }
  VAR EP, EP2          : pExtractPath;
      i                : Byte;
      LineErr          : Boolean;
  BEGIN
    If ExtractPathCount<ExtractPathCountMax Then Begin
      Inc(ExtractPathCount);
      LineErr:=False;

      EP:=ExtractPathP;
      If EP=NIL Then Begin
        New(EP);
        ExtractPathP:=EP;
      End Else Begin
        While EP^.Next<>NIL Do
          EP:=EP^.Next;

        New(EP2);
        EP^.Next:=EP2;
        EP:=EP2;
      End;
      EP^.Next:=NIL;

      i:=1;
      While (i<=Length(Line)) And (Line[i]<>',') Do Inc(i);
      EP^.Path:=fnFull(Copy(L2,1,i-1));
      If Not dbExistCreatePath(EP^.Path) Then Error:=EP^.Path+notexist;

      Delete(Line,1,i);
      i:=1;
      While (i<=Length(Line)) And (Line[i]<>',') Do Inc(i);
      If i>1
        Then EP^.DupeHandling:=GetDupeHandling(Copy(Line,1,i-1))
        Else EP^.DupeHandling:=DupeHandling;

      Delete(Line,1,i);
      i:=1;
      If Copy(Line,1,1)=',' Then EP^.AreaUse:=False
      Else Begin
        EP^.AreaUse:=True;
        EP^.Area:=Copy(Line,1,255);
        i:=Pos(',', EP^.Area);
        If i=0 Then LineErr:=True;

        EP^.Area[0]:=Chr(i-1);
      End;

      Delete(Line,1,i);
      If Length(Line)=0 Then EP^.ExtUse:=False
      Else Begin
        If Copy(Line,1,1)<>'"' Then LineErr:=True;

        EP^.ExtUse:=True;
        EP^.Ext:=Copy(Line,2,3);

        i:=Pos('"', EP^.Ext);
        If i<>0 Then EP^.Ext[0]:=Chr(i-1);
      End;

      If LineErr Then Error:=TxtLine+L2
      Else If Not lfnExistCreatePath(EP^.Path) Then Error:=EP^.Path+notexist;
    End Else Error:=TxtmaxArea1+ST(ExtractPathCountMax,1)+TxtMaxArea2;
  END;

  PROCEDURE doLineNetmailFilter;
  VAR i: Byte;
      p: pFilterNM;
  BEGIN
    If FilterNMP=NIL Then Begin
      New(FilterNMP);
      p:=FilterNMP;
    End Else Begin
      p:=FilterNMP;
      While p^.Next<>NIL Do
        p:=p^.Next;
      New(p^.Next);
      p:=p^.Next;
    End;

    If Copy(Line,1,1)='+' Then p^.Positive:=True
    Else Begin
      p^.Positive:=False;
      If Copy(Line,1,1)<>'-' Then Error:=TxtCommand+Line;
    End;
    Delete(Line, 1, 1);

    i:=Pos('@',Line);
    If i=0 Then p^.Addr.Name:=''
    Else Begin
      p^.Addr.Name:=UpcaseStr(Copy(Line,1,i-1));
      Delete(Line,1,i);
    End;

    If Not GetFidoAddr(Line, p^.Addr.Addr) Then Error:=TxtAddr+L2;

    p^.AnyZone :=p^.Addr.Addr.Zone =TmpAny;
    p^.AnyNet  :=p^.Addr.Addr.Net  =TmpAny;
    p^.AnyNode :=p^.Addr.Addr.Node =TmpAny;
    p^.AnyPoint:=p^.Addr.Addr.Point=TmpAny;

    p^.Next:=NIL;

    {$IFDEF Debug_BNK}
    If Error='' Then Begin
      if p^.positive then
        BnkLog('Netmailfilter: +'+p^.Addr.Name+'@'
         +WriteFidoaddr(p^.Addr.Addr))
      else
        BnkLog('Netmailfilter: -'+p^.Addr.Name+'@'
         +WriteFidoaddr(p^.Addr.Addr));

    End;
    {$ENDIF}
  END;

  PROCEDURE DoLineFilter;
  VAR Command : String;
      Arg     : String;
      L3      : String;
      i       : Byte;

    PROCEDURE doDomain;
    VAR nZone         : integer;
        strDomainname : String;
    BEGIN
      Error:=TxtCommand+L2;

      i:=Pos(',', Arg);
      If i>0 Then Begin
        nZone:=Value(Copy(Arg,1,i-1));
        Delete(Arg,1,i);

        i:=Pos(',', Arg);
        If i>0 Then Begin
          strDomainname:=Copy(Arg,1,i-1);
          Delete(Arg,1,i);

          Error:='';
          {$IFDEF Binkley}
          BOUT_ConfigureDomain(nZone, strDomainname, arg);
          If BOUT_Result<>BOUT_NOERROR Then Error:=TxtBout;
          {$ENDIF}
        End;
      End;
    END;

    PROCEDURE doAka;
    VAR p, p2 : pAka;
        Addr  : tFidoAddr2;
    BEGIN
      If GetFidoAddr(Arg, Addr) Then Begin
        New(p);
        p^.Addr:=Addr;
        p^.Next:=NIL;

        If AkaList=NIL Then Begin
          AkaList:=p;
          {$IFDEF Binkley}
          BOUT_ConfigureHomeZone(AkaList^.Addr.Zone);
          If BOUT_Result<>BOUT_NOERROR Then Error:=TxtBout;
          {$ENDIF}
        End Else Begin
          p2:=AkaList;
          While p2^.Next<>NIL Do
            p2:=p2^.Next;

          p2^.Next:=p;
        End;
      End Else Error:=TxtAddr+L2;
    END;

    PROCEDURE doOutBoundPath;
    BEGIN
      OutBoundPath:=fnFull(Arg);
    END;

    PROCEDURE doFilePath;
    BEGIN
      BnkFilePath:=fnFull(Arg);
    END;

    PROCEDURE doSend(Var Send: tSendTyp);
    {SENDMSG=MSG,,ATTACH,257,913}
    VAR i: Byte;
    BEGIN
      If Copy(L3,1,3)='MSG' Then Send.Typ:=ptMSG
      Else Begin
        Send.Typ:=ptPKT;
        If Copy(L3,1,3)<>'PKT' Then Error:=TxtCommand+L2;
      End;

      If Error='' Then Begin
        Delete(L3,1,4);
        Delete(Arg,1,4);
        If Copy(L3,1,1)=',' Then Begin
          Send.Path:='';
          Delete(L3,1,1);
        End Else Begin
          i:=Pos(',', L3);
          Send.Path:=fnFull(Copy(Arg,1,i-1));
          Delete(L3,1,i);

          If Not lfnExistPath(Send.Path) Then Error:=Send.Path+notexist;
        End;

        If Error='' Then Begin
          If Copy(L3,1,7)='BINKLEY' Then Begin
            Send.Mode:=smBinkley;
            Delete(L3,1,8);
          End Else Begin
            Send.Mode:=smAttach;
            If Copy(L3,1,6)<>'ATTACH' Then Error:=TxtCommand+L2;
            Delete(L3,1,7);
          End;

          i:=Pos(',',L3);
          If i=0 Then Begin
            Send.Attr1:=Value(L3);
            If Send.Mode=smAttach Then Error:=TxtCommand+L2;
          End Else Begin
            Send.Attr1:=Value(Copy(L3,1,i-1));
            Send.Attr2:=Value(Copy(L3,i+1,255));
          End;
        End;
      End;
    END;

    FUNCTION YesNo: Boolean;
    BEGIN
      If L3='YES' Then YesNo:=True
      Else If L3='NO' Then YesNo:=False
      Else Error:=TxtCommand+L2; { Funktionswert egal }
    END;

  BEGIN
    Command:=Line;
    i:=Pos('=', Command);
    If i<>0 Then Command[0]:=Chr(i-1);

    Arg:=Copy(L2, i+1, 255);
    L3:=UpCaseStr(Arg);

    If Command='DOMAIN' Then doDomain
    Else If Command='AKA' Then doAka
    Else If Command='OUTBOUNDPATH' Then doOutBoundPath
    Else If Command='FILEPATH' Then doFilePath
    Else If Command='MINSIZE' Then BnkMinCodeSize:=Value(Arg)
    Else If Command='HOLDDAYS' Then BnkHoldDays:=Value(Arg)
    Else If Command='ATTACHMESSAGE' Then AttachMessage:=YesNo
    Else If Command='ATTACHPATH' Then AttachPath:=YesNo
    Else If Command='SENDMSG' Then DoSend(SendMsg)
    Else If Command='SENDPKT' Then DoSend(SendPkt)
    Else Error:=TxtCommand+L2;
  END;

  PROCEDURE DoLineShortText;
  VAR p: pText;
  BEGIN
    If ShortText=NIL Then Begin
      New(ShortText);
      p:=ShortText;
    End Else Begin
      p:=ShortText;
      While p^.Next<>NIL Do
        p:=p^.Next;
      New(p^.Next);
      p:=p^.Next;
    End;

    p^.Line:=L2;
    p^.Next:=NIL;
  END;

  PROCEDURE DoLineSendText;
  VAR p: pText;
  BEGIN
    If SendText=NIL Then Begin
      New(SendText);
      p:=SendText;
    End Else Begin
      p:=SendText;
      While p^.Next<>NIL Do
        p:=p^.Next;
      New(p^.Next);
      p:=p^.Next;
    End;

    p^.Line:=L2;
    p^.Next:=NIL;
  END;

BEGIN
  LCount:=0;
  OutBoundPath:='';

  FileMode:=roFileMode;
  Assign(F, fnDir(ParamStr(0))+IniName);
  Reset(F);
  If IOResult<>0 Then Error:=TxtReadErr
  Else Begin
    GetMem(Buffer, 8192);
    SetTextBuf(F, Buffer^, 8192);

    Error:='';
    Mode:=mNone;
    While (Not EOF(F)) And (Error[0]=#0) Do Begin
      Readln(F, L2);
      Inc(LCount);
      CompressStr(L2);
      If (Copy(L2,1,1)<>';') And
       ((Length(L2)>0) Or (Mode=mTextShort) Or (Mode=mTextSend)) Then Begin
        Line:=UpcaseStr(L2);

        If Mode=mNone Then Begin
          If Line='[GENERAL]' Then Mode:=mGeneral
          Else If Line='[DECODEAREA]' Then Mode:=mDArea
          Else If Line='[MODIFYAREA]' Then Mode:=mMArea
          Else If Line='[EXTRACTPATH]' Then Mode:=mEPath
          Else If Line='[NETMAILFILTER]' Then Mode:=mNMfilter
          Else If Line='[FILTERSETTINGS]' Then Mode:=mFilter
          Else If Line='[SHORTTEXT]' Then Mode:=mTextShort
          Else If Line='[SENDTEXT]' Then Mode:=mTextSend;
        End Else If Line='[END]' Then Mode:=mNone
        Else If Mode=mGeneral Then DoLineGeneral
        Else If Mode=mDArea Then DoLineDecodeArea
        Else If Mode=mMArea Then DoLineModifyArea
        Else If Mode=mEPath Then DoLineExtractPath
        Else If Mode=mNMFilter Then DoLineNetmailFilter
        Else If Mode=mFilter Then DoLineFilter
        Else If Mode=mTextShort Then DoLineShortText
        Else If Mode=mTextSend Then DoLineSendText
      End;
    End;
    Close(F);
    FreeMem(Buffer, 8192);
  End;

  If Error='' Then Begin
    If DBPath='' Then Error:=TxtDBErr
    Else If ExtPath='' Then Error:=TxtExtErr
    Else If ExtBadPath='' Then Error:=TxtExtBErr
    Else If FilterNMP<>NIL Then Begin { using NetMailfiler... }
      {$IFDEF Binkley}
      { jetzt erst initalisieren }
      If Not dbExistCreatePath(BnkFilePath) Then Error:=BnkFilePath+notexist;
      If (SendPKT.Mode=smBinkley) Or (SendMSG.Mode=smBinkley)
        Then
          If Not lfnExistPath(OutBoundPath) Then Error:=TxtPath
          Else Begin
            BOUT_ConfigureBasepath (OutBoundPath);
            If BOUT_Result<>BOUT_NOERROR Then Error:=TxtBout;
          End;

      If AkaList=NIL Then Error:=TxtAka
      Else If BnkFilePath='' Then BnkFilePath:=ExtPath
      Else If ShortText=NIL Then Error:=TxtSTxt
      Else If (SendText=NIL) Or (SendText^.Next=NIL) Then Error:=TxtSTxt;
      {$ENDIF}
    End;
  End;
  If Error<>'' Then Begin
    If LCount>0 Then Begin
      Writeln(TxtError1, LCount,TxtError2);
      Writeln(TxtReason+Error);
    End Else WriteLn(Error);

    ErrorAbort:=eaHalt;
  End;

  { Version feststellen }
{  If ErrorAbort=eaOK Then WriteHeader;}
  {$IFDEF Binkley}
  If BinkleyFilter Then BnkInitMailBuffer;
  {$ENDIF}
END;

PROCEDURE ReleaseMemory;
VAR EP : pExtractPath;
    MP : pModifyArea;
    AP : pDecodeArea;
BEGIN
  While ExtractPathP<>NIL Do Begin
    EP:=ExtractPathP;
    ExtractPathP:=EP^.Next;
    Dispose(EP);
  End;
  ExtractPathCount:=0;

  While ModifyAreaP<>NIL Do Begin
    MP:=ModifyAreaP;
    ModifyAreaP:=MP^.Next;
    Dispose(MP);
  End;
  ModifyAreaCount:=0;

  While DecodeAreaP<>NIL Do Begin
    AP:=DecodeAreaP;
    DecodeAreaP:=AP^.Next;
    Dispose(AP);
  End;
  DecodeAreaCount:=0;
END;

{***************************************************************************}
{ diese Area in Liste? }
{***************************************************************************}

  FUNCTION AreaNameFits(Area, Vergleich: String): Boolean;
  { Area - Name der Area, die geprft werden soll
    Vergleich - Listeneintrag
  { ist "Area" mit diesem Listeneintrag betroffen? }
  VAR i, j      : Byte;
  BEGIN
    { Anfang prfen }
    If Vergleich[1]<>'*' Then Begin
      i:=1;
      While (Vergleich[i]=Area[i]) And (Vergleich[i]<>'*')
        And (i<=Length(Vergleich)) And (i<=Length(Area)) Do
          Inc(i);

      Delete(Vergleich,1,i-1);
      Delete(Area,1,i-1);
    End;

    { Mittelteil suchen }
    While Copy(Vergleich,1,1)='*' Do Begin
      Delete(Vergleich,1,1);

      j:=Pos('*', Vergleich);
      If j=0 Then j:=Length(Vergleich)
      Else Dec(j);

      i:=Pos(Copy(Vergleich,1,j), Area);
      If i<>0 Then Begin
        Delete(Area,1,i+j);
        Delete(Vergleich, 1, j);
      End;
    End;

    AreaNameFits:=(Vergleich='');
  END;

{***************************************************************************}

FUNCTION ShallDecodeArea(Area: String): Boolean;
{ soll Area dekodiert werden? Sieht in Liste "DecodeArea" nach }
VAR p      : pDecodeArea;
    Result : Boolean;
BEGIN
  Result:=True;
  Area:=UpcaseStr(Area);

  p:=DecodeAreaP;
  While p<>NIL Do Begin
    If AreaNameFits(Area, p^.Area) Then Result:=p^.Positive;
    p:=p^.Next;
  End;

  ShallDecodeArea:=Result;
END;

{***************************************************************************}

FUNCTION ShallModifyArea(Area: String; Typ: Byte): Byte;
{ soll Area modifiziert werden? Sieht in Liste "ModifyArea" nach }
{ wenn Area='', dann suche nur nach Typ (durchsuche alle Areas) }
VAR p      : pModifyArea;
    Result : Byte;
BEGIN
  Result:=mmNo;

  Area:=UpcaseStr(Area);

  p:=ModifyAreaP;
  While p<>NIL Do Begin
    If (Typ And p^.Typ<>0)
    Then
      If (Area='')
      Then
        If (p^.Mode<>mmNo)
        Then Result:=p^.Mode
        Else
      Else
        If AreaNameFits(Area, p^.Area)
        Then Result:=p^.Mode;

      p:=p^.Next;
    End;

  If (Typ=ptunknown) And ((Result=mmDelete) Or (Result=mmMayDelete))
    Then Result:=mmShorten;

  ShallModifyArea:=Result;
END;

{***************************************************************************}

PROCEDURE GetExtractPath(Area: String; FName: tFNStr; Var Path: PathStr;
            Var DH: Byte);
VAR p      : PExtractPath;
    Ext    : String[3];
    Done   : Boolean;
BEGIN
  Path:=ExtPath;
  DH:=DupeHandling;

  Area:=UpcaseStr(Area);
  Ext:=UpcaseStr(fnExt(FName));
  p:=ExtractPathP;

  Done:=False;
  While (Not Done) And (p<>NIL) Do Begin
    If ((Not p^.AreaUse) Or AreaNameFits(Area, p^.Area)) And
       ((Not p^.ExtUse)  Or (Ext=p^.Ext)) Then Begin
      Path:=p^.Path;
      DH:=p^.DupeHandling;
      Done:=True;
    End;
    p:=p^.Next;
  End;
END;

{***************************************************************************}

END.

