{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)

}

Unit PKTX_IO;

{$I SETTINGS.INI}

{ 25.10.96 Fehler in Checkname bei mehreren "." behoben
  03.11.96 Existfile auf Reset-Fkt zurckgefhrt
  28.12.96 Existpath gendert
  08.01.97 IsAvailableHPFS mittels OS/2 Fkt.
           neu: IsDupeAny bei CompareAll vergleicht mit allen Dateien

mem: filternmp
}

INTERFACE

{$IFDEF OS2}
Uses CRT_OS2, OS2DEF, OS2BASE,
{$ELSE}
Uses CRT,
{$ENDIF}
                                        DOS, PKTX_KEY, PKTX_SCR, PKTX_LFN;

CONST verStr   = '1.24';
      verDay   = '06';
      verMonth = '11';
      verYear  = '98';

      verName  = 'PktXCode'{$IFDEF OS2} +'/2' {$ENDIF}
                  +' '+verStr {$IFDEF German} +'g' {$ELSE} +'e' {$ENDIF};


CONST
{$IFDEF OS2}
      BlockSizeK          =    32; { 32kb }

      DecodeAreaCountMax  = 65535;
      ModifyAreaCountMax  = 65535;
      ExtractPathCountMax = 65535;
      FilterNMCountMax    = 65535;
{$ELSE}
      BlockSizeK          =    16; { 32kb }

      DecodeAreaCountMax  = 100;
      ModifyAreaCountMax  = 100;
      ExtractPathCountMax = 100;
      FilterNMCountMax    = 100;
{$ENDIF}

      BlockSize           = BlockSizeK*1024;
      InPreload           =   260; { x zeichen vor ende angekommen -> nachladen }
      OutPreload          =   191; { max. OutZeichen bei 255 Inzeichen}
      FieldSize           = BlockSize+4096; { Platz fr zweimal dekodieren! }

      ptunknown           =     1; { PKTType, "0" gibt Probleme bei OR }
      ptPKT               =     2;
      ptMSG               =     4;
      ptZCONNECT          =     8;

      opNone              =     0; { Outopen }
      opUU                =     1;
      opXX                =     2;
      opBase64            =     4;
      opBinHex            =     8;
      opUUorXX            =  opUU Or opXX;

      ifNone              =     0;
      ifFBegin            =     1; { Dateibegin - Markierung }
      ifFEnd              =     2; { Dateiende - Markierung }
      ifVStart            =     4; { erste Nachricht im Verbund }
      ifVEnd              =     8; { letzte Nachricht im Verbund }
      ifVComplete         =    16; { erste Nachricht eines vollst. Verb. }
      ifVLinked           =    32; { Nachricht ist Nachfolger einer anderen }
      ifErase             =    64; { Eintrag lschen }

      ilUnlinked          =     0;
      isUnassigned        = $FFFE;

      rmNotInitialized    =     0;
      rmLite              =     1;
      rmShareware         =     2;
      rmLicence           =     3;

      descNone            =     0;
      descBBS             =     1;
      desc4DOS            =     2;

      dupSkip             =     0;
      dupOverwrite        =     1;
      dupRenameFile       =     2;
      dupRenameExt        =     3;
      dupCompare          =     4;
      dupCompareAll       =     5;
      dupKeep             =     6;

      b64No               =     0;
      b64Yes              =     1;
      b64Auto             =     2;

      mmNo                =     0;
      mmShorten           =     1;
      mmDelete            =     2;
      mmMayDelete         =     3;

      logNone             =     0;
      logExtract          =     1;
      logFileDesc         =     2;
      logErrors           =     4;
      logDelete           =     8;
      logRename           =    16;
      logSkip             =    32;
      logOverwrite        =    64;
      logSummaryData      =   128;
      logSummaryEver      =   256;
      logAll              = logExtract   + logFileDesc    + logErrors +
                            logDelete    + logRename      + logSkip   +
                            logOverwrite + logSummaryData;

      jobNothing          =        0;
      jobLoadINIFile      = 1 shl  0;
      jobPrereadDir       = 1 shl  1;
      jobCheckDir         = 1 shl  2;
      jobUnpackFiles      = 1 shl  3;
      jobXMemInit         = 1 shl  4;
      jobOpenDataBase     = 1 shl  5;
      jobVerifyDataBase   = 1 shl  6;
      jobTestINIFile      = 1 shl  7;
      jobListDataBase     = 1 shl  8;
      jobDecodeFiles      = 1 shl  9;
      jobBuildDatabase    = 1 shl 10;
      jobExtractDatabase  = 1 shl 11;
      jobExtractManual    = 1 shl 12;
      jobDecodeStatistic  = 1 shl 13;
      jobDisplayHelp      = 1 shl 14;
      jobTerminate        = 1 shl 15;

      noFileTime          = 0;

      bnkNo               =      0; { keine Binkley-Datei }
      bnkDecode           =      1; { wurde als Binkley-Datei dekodiert }
      bnkExtract          =      2; { wurde in Datei geschrieben }
      bnkMessage          =      3; { wurde in Binkley eingetragen }
      bnkWait             =      4; { warten, bis gelscht werden soll }

      smAttach            =      0;
      smBinkley           =      1;

CONST TmpAny = $FFFE;

TYPE  TField              = Array[0..FieldSize-1] Of Byte;
      PField              = ^TField;
      tFLHeader           = Object
                              FromPath  : String;
                              Counter   : Word;
                            End;
CONST MaxList = ( 65520 - SizeOf(tFLHeader) ) Div SizeOf(fnStr);
TYPE  tFileList           = Object(tFLHeader)
                              Name      : Array[1..MaxList] Of fnStr;
                            End;
      pFileList           = ^tFileList;

TYPE
  TPktHdr = RECORD  { thanks to Jan Egner! }
    orig_node  : WORD;      (* originating node               *)
    dest_node  : WORD;      (* destination node               *)
    year       : WORD;      (* 0..99  when packet was created *)
    month      : WORD;      (* 1..12  when packet was created *)
    day        : WORD;      (* 1..31  when packet was created *)
    hour       : WORD;      (* 0..23  when packet was created *)
    minute     : WORD;      (* 0..59  when packet was created *)
    second     : WORD;      (* 0..59  when packet was created *)
    rate       : WORD;      (* destination's baud rate        *)
    ver        : WORD;      (* packet version                 *)
    orig_net   : WORD;      (* originating network number     *)
    dest_net   : WORD;      (* destination network number     *)
    product    : BYTE;      (* product type (low byte)        *)
    rev        : BYTE;      (* revision (major byte)          *)
    password   : Array[1..8] OF Char; (* pickup password                *)
    q_orig_zone: WORD;      (* originating zone number (QMail)*)
    q_dest_zone: WORD;      (* destination zone number (QMail)*)
    pktjunk2   : WORD;      (* 2 more bytes of debris         *)
    cwcopy     : WORD;      (* Capability Word Valid Copy     *)
    producthi  : BYTE;      (* product code (high byte)       *)
    revmin     : BYTE;      (* revision (minor byte)          *)
    cw         : WORD;      (* Capability Word                *)
    t_orig_zone: WORD;      (* originating zone number (FroDo)*)
    t_dest_zone: WORD;      (* destination zone number (FroDo)*)
    t_orig_pnt : WORD;      (* originating point nmbr. (FroDo)*)
    t_dest_pnt : WORD;      (* destination point nmbr. (FroDo)*)
    pktjunk3   : LongInt;   (* and another 4 bytes...         *)
  END;

  TPktMsgHdr = RECORD { thanks to Jan Egner! }
    ver, { 0002 }
    orignode,
    destnode,
    orignet,
    destnet,
    attr,
    cost : WORD; { toUserName, fromUserName, subject, text }
  END;

  tMsgHead  = Record
    fromUsername : Array[0..35] Of Char;
    toUserName   : Array[0..35] Of Char;
    Subject      : Array[0..71] Of Char;
    DateTime     : Array[0..19] Of Char;
    TimesRead    : Word;
    destNode     : Word;
    origNode     : Word;
    cost         : Word;
    origNet      : Word;
    destNet      : Word;
    destZone     : Word;
    origZone     : Word;
    destPoint    : Word;
    origPoint    : Word;
    replyTo      : Word;
    Attribute    : Word;
    nextReply    : Word;
  End;



  tFidoAddr2     = Record
                     Zone, Net, Node, Point : Word;
                     IsPoint                : Boolean;
                   End;

  tFidoAddr      = Record
                     Addr                   : tFidoAddr2;
                     Name                   : String[36];
                   End;

  tVerInfo       = Array[0..9] Of Char;

  TIDXHeader     = Record
                     verInfo        : tVerInfo;
                     IDXCounter     : LongInt;
                     DatFileSize    : LongInt;
                     DatKeepSize    : LongInt;
                     stDate         : tDate;
                     stAllFNumber,
                     stAllFSize,
                     stAllFMsg,
                     stAllFMsgCheck,
                     stAllFMsgData,
                     stAllFMsgShortened,
                     stAllFMsgDeleted,
                     stAllFDecode,
                     stDecodeCount,
                     stDecodeSize,
                     stProcessTime  : LongInt;
                   End;

  tIDXEntry      = Record
                     SubjStr   : String[80];
                     AreaStr   : String[80];

                     PartStr   : String[80];
                     SplitStr  : String[35]; { Kennzeichnung der Fido-Splt }
                     rFileName : tFNStr;  { 81b } { real }
                     cSplit    : Word;
                     cSplitOf  : Word;
                     cPart     : Word;
                     cPartOf   : Word;
                     Date      : TDate;   { 4b}
                     Typ       : Byte;    { 1b }
                     Link      : LongInt; { 4b}
                     Flag      : Byte;
                     dStart    : LongInt; { 4b}
                     dSize     : LongInt; { 4b}
                     OldIDXPos : LongInt;
                     FileTime  : LongInt;

                     BnkMode   : Byte;
                     PktType   : Byte; { MSG oder PKT }
                     FidoAddr  : tFidoAddr;
                     Inbound   : String[68];
                   End;

CONST
  IDXCacheSize   = BlockSize Div SizeOf(tIDXEntry);

TYPE
  TIDXCache      = Array[0..IDXCacheSize-1] Of tIDXEntry;
  PIDXCache      = ^TIDXCache;

  TDecodeArea    = Record
                     Positive  : Boolean;
                     Area      : String[80];
                     Next      : Pointer;
                   End;
  PDecodeArea    = ^TDecodeArea;

  TModifyArea    = Record
                     Area      : String[80];
                     Mode      : Byte;
                     Typ       : Byte;
                     Next      : Pointer;
                   End;
  PModifyArea    = ^TModifyArea;

  TExtractPath   = Record
                     Path         : String;
                     DupeHandling : Byte;
                     Area         : String[80];
                     AreaUse      : Boolean;
                     Ext          : String[3];
                     ExtUse       : Boolean;
                     Next         : Pointer;
                   End;
  PExtractPath   = ^TExtractPath;

  pFilterNM      = ^tFilterNM;
  tFilterNM      = Record
                     Addr                   : tFidoAddr; {mit UName}
                     AnyZone, AnyNet,
                     AnyNode, AnyPoint      : Boolean;
                     Positive               : Boolean;
                     Next                   : pFilterNM;
                   End;

  tSendTyp       = Record
                     Typ       : Byte;
                     Path      : String;
                     Mode      : Byte;
                     Attr1     : Word;
                     Attr2     : Word;
                   End;

  pText          = ^tText;
  tText          = Record
                     Line                   : String[127];
                     Next                   : pText;
                   End;

  pAka           = ^tAka;
  tAka           = Record
                     Addr                   : tFidoAddr2;
                     Next                   : pAka;
                   End;


TYPE tWinCreateMsg                = Record
                                      Name: String[60];
                                      Proc: String[60];
                                    End;

CONST DatName          =              'PKTXCODE.DAT';
      IdxName          =              'PKTXCODE.IDX';
      DatName2         =              'PKTXCODE.DA_';
      IdxName2         =              'PKTXCODE.ID_';
      BnkDBName        =              'PKTXBINK.DAT';
      BnkDBName2       =              'PKTXBINK.DA_';
      IniName          =              'PKTXCODE.INI';
      BnkName          =              'PKTXBINK.INI';
      PreDirName       =              'PKTXCODE.DIR';
      LogName          =              'PKTXCODE.LOG';
      LogSName         =              'PKTXCODE.SUM';
      LogXPName        =              'PKTXCODE.ZER';
      BatchName        =              'PKTXREN.CMD';
      dbVerInfo        =              'PktXIdx120';
      bnkVerInfo       =              'PktXBnk120';

CONST cMonth : Array[1..12] Of String[3] =
                ('Jan','Feb','Mar','Apr','May','Jun',
                 'Jul','Aug','Sep','Oct','Nov','Dec');

      JobExec          : Word       = jobNothing;
      CmdFile          : String     = '';

      DecodeAreaP      : Pointer    = NIL;
      DecodeAreaCount  : Word       = 0;
      ModifyAreaP      : Pointer    = NIL;
      ModifyAreaCount  : Word       = 0;
      ExtractPathP     : Pointer    = NIL;
      ExtractPathCount : Word       = 0;

      DBPath           : String     = '';
      ExtPath          : String     = '';
      ExtBadPath       : String     = '';
      DelDays          : Integer    =    5;

      CreateDesc       : Byte       = descNone;
      CreateDescStyle  : String     = '$SUBJECT ($AREA)';
      AutoFileExtension: Boolean    = True;
      ForceFileJoining : Boolean    = False;
      ZipMagic95Comp   : Boolean    = False;
      { true, wenn EINE Datei in mehrere Dateien aufgeteilt ist, d.h. es
        gibt innerhalb einer MSGverbundes mehrere Start-End-Markierungen }
      UseBase64Header  : Byte       = b64Auto;
      dupeHandling     : Byte       = dupCompare;
      LogLevel         : Word       = logAll;
      LogPath          : String     = '';
      LogSumPath       : String     = '';
      CriticalSubjLen  : Byte       = 255;
      Textmark         : String[60] = 'Subject:';
      SplitText        : String[60] = 'x:[ ]';
      LogMailArea      : String[80] = '';

      LogFileOpen      : Boolean    = False;
      LogMailFileOpen  : Boolean    = False;
      LogMailFileName  : String     = ''; {ein einziges ZConnect-PKT erk.}


      BnkThisMail      : Boolean    = False;
      BnkMinCodeSize   : LongInt    = 2048;
      BnkFilePath      : String     = ''; {Pfad, wohin Dateien extr werden }
      BnkHoldDays      : Integer    =   14; { solange im Outbound lassen }
      FilterNMP        : pFilterNM  = NIL;
      FilterNMCount    : Word       = 0;
      AkaList          : pAka       = NIL;
      ShortText        : pText      = NIL;
      SendText         : pText      = NIL;
      Attachmessage    : Boolean    = False;
      AttachPath       : Boolean    = False;
      SendMSG          : tSendTyp   =
                         ( Typ  : ptMSG;
                           Path : '';
                           Mode : smAttach;
                           Attr1: 385;   { sendmail }
                           Attr2: 913 ); { sendfile }
      SendPKT          : tSendTyp   =
                         ( Typ  : ptPKT;
                           Path : '';
                           Mode : smAttach;
                           Attr1: 385;
                           Attr2: 913 );

      stFileName       : String[24] = '';
      stAllFNumber     : LongInt    = 0;
      stFileNumber     : LongInt    = 0;{ Anzahl der einzulesenen Dateien }
      stAllFMsg        : LongInt    = 0;
      stFileMsg        : LongInt    = 0;{ Anzahl der Nachrichten }
      stAllFMsgCheck   : LongInt    = 0;
      stFileMsgCheck   : LongInt    = 0;{ Anzahl der geprften Nachrichten }
      stAllFMsgData    : LongInt    = 0;
      stFileMsgData    : LongInt    = 0;{ Anzahl der Nachrichten mit Daten }
      stAllFMsgShortened: LongInt    = 0;{ Anzahl der gekrzten Nachrichten }
      stAllFMsgDeleted : LongInt    = 0;{ Anzahl der gelschten Nachrichten }
      stAllFPrcd       : LongInt    = 0;
      stFilePrcd       : LongInt    = 0;{ Menge der eingelesen Dateien }
      stAllFDecode     : LongInt    = 0;
      stFileDecode     : LongInt    = 0;{ Menge der dekodierten Dateien }
      stAllFSize       : LongInt    = 0;
      stFileSize       : LongInt    = 0;{ Gesamtmenge der einzulesenen Dateien }
      stDecodeCount    : LongInt    = 0;{ Anzahl der dekodierten Dateien }
      stDecodeSize     : LongInt    = 0;{ Menge der vollstndigen Dateien }
      stProcessTime    : LongInt    = 0;{ bentigte Zeit }

VAR Infield            : PField;   { Quelldatei }
    InFileEnd          : Byte;
    FSource            : File;

    Insize, Inpos      : Word;     { mssen wg. ASM global sein! }
    InfieldReadall     : Boolean;

    Outfield           : PField;
    OutPos             : Word;     { Zeiger in Outfield }

    Destfield          : PField;   { Feld fr modifiziertes Paket }
    DestPos            : Word;
    ThisMsgData        : Boolean;  { Nachricht wurde dekodiert }
    ThisMsgModify      : Byte;     { Bearbeitungsmodus fr Nachricht }
    ThisMsgIsModified  : Boolean;  { Nachricht wurde verndert ? }
    ThisMsgHeadStart   : LongInt;  { Startadresse des Nachrichtenkopfes }
    ThisMsgBodyStart   : LongInt;  { Startadresse des Nachrichtentextes }
    FDest              : File;     { Datei, in die Destfield geschrieben wird }
    FDestName          : tFNStr;   { Name von FDest }
    FDestOpen          : Boolean;  { Datei FDest wurde geffnet }
    FDestError         : Boolean;  { es ist irgendein Fehler aufgetr. }
    FDestFilePos       : LongInt;  { entspricht FilePos(FDest) }
    FDestMemPos        : LongInt;  { Startadresse der aktuellen Zeile }

    DecodeList         : pFileList;{ Liste der zu dekodierenden Dateien }
    PKTType            : Byte;     { Dateityp der aktuell dekodierten Datei }

    OutString          : String;   { enthlt aktuelle Zeile }
    OutIDX             : tIDXEntry;{ Datenbankeintrag der aktuellen Nachricht }

    IDXCounter         : LongInt;  { Anzahl der Eintrge in Datenbank }
    DatFile            : File;
    DatFileSize        : LongInt;  { Dateigre }
    DatKeepSize        : LongInt;  { Gre der Daten darin }


{$IFDEF German}
CONST notexist      = ' existiert nicht';
      databaseempty = 'es befinden sich keine Daten in der Datenbank';
{$ELSE}
CONST notexist      = ' doesn'+#39+'t exist';
      databaseempty = 'there are no data in database';
{$ENDIF}

FUNCTION ErrorText: String;
{ wandelt ErrorAbort in Text um }
PROCEDURE GetNextName(Var Name: tFNStr; Mode: Byte);
{ liefert den "nchsten" Namen zu "Name" }
FUNCTION IsDupe(Var Name1: tFNStr; Name2: tFNStr; Path: String): Boolean;
{ prft, ob diese Dateien identisch sind }
FUNCTION IsDupeAny(Name1: tFNStr; Path: String; FSize: LongInt;
                   Var Name3: tFNStr): Boolean;
{ prft, ob Datei unter beliebigen Namen bereits vorhanden ist }
FUNCTION GetDateTimeStr: String;
{ liefert aktuelles Datum/Uhrzeit als String }
FUNCTION GetDateTimeXP: String; {'19960531121300W'}
{ ... im ZConnect-Header-Format }

PROCEDURE OpenDecodeScreen;
PROCEDURE UpdateDecodeScreen;
{ Fenster beim dekodieren von Dateien }

PROCEDURE OpenWaitWindow(Txt: S80);
PROCEDURE UpdateWaitWindow(Now, Max: LongInt);
{ Fenster mit Prozentbalken zum Warten, Txt ist optional }

PROCEDURE OpenFileCreateWindow;
PROCEDURE UpdateFileCreateWindowLine;
PROCEDURE UpdateFileCreateWindow(Msg1, Msg2: S80);
PROCEDURE UpdateFileCreateWindowBar(Now, Max: LongInt);
PROCEDURE WaitKeyFileCreateWindow;
PROCEDURE CloseFileCreateWindow;
{ Fenster beim erstellen von Dateien }

PROCEDURE OpenExtractManualWindow;
PROCEDURE UpdateExtractManualWindow(This, All, IDXPos: LongInt);
PROCEDURE OpenEMLinkWindow(This, All, IDXPos: LongInt);
PROCEDURE UpdateEMLinkWindow(This, All, IDXPos: LongInt);
PROCEDURE CloseEMLinkWindow;
{ Fenster zum manuellen Erstellen von Dateien }

PROCEDURE OpenListDatabaseWindow;
PROCEDURE UpdateListDatabaseWindow(Line: Byte; Txt: S80);
{ Fenster mit Liste von Datenbankinhalt }

PROCEDURE OpenCacheFlushWindow;
FUNCTION SecurityWindow: Boolean;
{ Sicherheitsabfrage (J/N) }

FUNCTION CodeName(Typ: Byte): S10;

FUNCTION ioGetParamStr(i: Word): String;
FUNCTION ioGetParamCount: Word;

FUNCTION WriteFidoAddr(Addr: tFidoAddr2): String;
FUNCTION GetFidoAddr(Str: String; Var Addr: tFidoAddr2): Boolean;


IMPLEMENTATION

Uses PKTX_DB;

{***************************************************************************}

FUNCTION ErrorText: String;
{ wandelt ErrorAbort in Text um }
{$IFDEF German}
CONST eaTUserBreak      = 'Abbruch durch Benutzer';
      eatError          = 'Es trat ein kritischer Fehler auf: ';
      eatIDXWrite       = 'Indexdatei-Schreibfehler';
      eatIDXRead        = 'Indexdatei-Lesefehler';
      eatDatCompress    = 'Datenbank konnte nicht komprimiert werden';
      eatDatFileRead    = 'Datei-Lesefehler';
      eatDatFileWrite   = 'Datei-Schreibfehler';
      eatDiskFull       = 'Festplatte ist voll';
      eatIDXCache       = 'berlauf im Datenbank-Cache';
      eatIDXError       = 'Fehler in Datenbank';
      eatXMS            = 'XMS Zugriffsfehler';
      eatInternalError  = 'ungltige Speicheroperation';
      eatWrongCode      = 'unerlaubter Fehlercode';
{$ELSE}
CONST eaTUserBreak      = 'aborted by user';
      eatError          = 'a critical error occurred: ';
      eatIDXWrite       = 'index file write error';
      eatIDXRead        = 'index file read error';
      eatDatCompress    = 'database could not be compressed';
      eatDatFileRead    = 'file read error';
      eatDatFileWrite   = 'file write error';
      eatDiskFull       = 'disk full';
      eatIDXCache       = 'overflow in database cache';
      eatIDXError       = 'error in database';
      eatXMS            = 'XMS access error';
      eatInternalError  = 'invalid memory access';
      eatWrongCode      = 'invalid error code';
{$ENDIF}
VAR i: String;
BEGIN
  If ErrorAbort=eaUserBreak Then ErrorText:=eatUserBreak
  Else Begin
    i:=eatError;
    Case ErrorAbort Of
      eaIDXWrite         : i:=i+eatIDXWrite;
      eaIDXRead          : i:=i+eatIDXRead;
      eaDatCompress      : i:=i+eatDatCompress;
      eaDatFileRead      : i:=i+eatDatFileRead;
      eaDatFileWrite     : i:=i+eatDatFileWrite;
      eaDiskFull         : i:=i+eatDiskFull;
      eaIDXCache         : i:=i+eatIDXCache;
      eaIDXError         : i:=i+eatIDXError;
      eaXMS              : i:=i+eatXMS;
      eaInternalError    : i:=i+eatInternalError;
      eaHalt             : i:='';
      Else i:=eatWrongCode;
    End;
    ErrorText:=i;
  End;
END;

{***************************************************************************}

PROCEDURE GetNextName(Var Name: tFNStr; Mode: Byte);
{ liefert Namen+Zahl, wobei Zahl - falls vorhanden - inkrementiert wird }
{ Mode: dupRenameExt -> Dateierweiterung umbenennen, sonst Dateiname }

  PROCEDURE CountUp(Var S: String; MaxLen: Byte);
  VAR i          : Byte;
      Counter    : LongInt;
      CounterStr : String;
  BEGIN
    i:=Length(S);
    While (i>0) And (S[i] In ['0'..'9']) Do
      Dec(i);

    If i=Length(S) Then CounterStr:='0'
    Else Begin
      CounterStr:=Copy(S,i+1,255);
      Counter:=Value(CounterStr)+1;
      CounterStr:=LeadingZero(Counter, Length(CounterStr));
      S[0]:=Chr(i);
    End;

    If Length(CounterStr)>MaxLen Then CounterStr:='';

    If Length(S)+Length(CounterStr)>MaxLen Then
      S[0]:=Chr(MaxLen-Length(CounterStr));
    S:=S+CounterStr;
  END;

VAR i       : Byte;
    Erw     : String;
BEGIN
  i:=Length(Name.Name);
  While (i>0) And (Name.Name[i]<>'.') Do Dec(i);

  If i=0 Then Begin
    i:=Length(Name.Name);
    Erw:='';
  End Else Begin
    If Name.Long Then Erw:=Copy(Name.Name,i+1,255) { ohne '.' }
    Else Erw:=Copy(Name.Name,i+1,3);

    Name.Name[0]:=Chr(i-1);
  End;

  If Mode=dupRenameExt
    Then CountUp(Erw,3)
    Else
      If Name.Long
        Then CountUp(Name.Name, 80)
        Else CountUp(Name.Name, 8);

  If Erw<>'' Then Name.Name:=Name.Name+'.'+Erw;
END;

{***************************************************************************}

FUNCTION FilesEqual(FName1, FName2: String): Boolean;
{ fr IsDupe* }
VAR F1, F2     : File;
    Out        : Boolean;
    L          : LongInt;
    R          : Word;
    Buf1, Buf2 : Pointer;

  FUNCTION AreFieldsEqual(Buf1, Buf2 : Pointer; Size1: Word): Boolean; Assembler;
  Asm
{$IFDEF OS2}
        push esi
        push edi

        mov  esi, buf1 { ds:si }
        mov  edi, buf2 { es:di }
        movzx ecx, Size1

        cld
        repe cmpsb            { Vergleich }
        jnz  @notequal

        mov  eax, 1
        jmp  @exit

      @notequal:
        xor  eax, eax

      @exit:
        pop edi
        pop esi
{$ELSE}
        push ds
        lds  si, buf1 { ds:si }
        les  di, buf2 { es:di }
        mov  cx, Size1

        cld
        repe cmpsb            { Vergleich }
        jnz  @notequal

        mov  ax, 1
        jmp  @exit

      @notequal:
        xor  ax, ax

      @exit:
        pop ds
{$ENDIF}
  END;

BEGIN
  Out:=False;

  lfnOpenFile(F1, FName1, ofRead);

  If Result=0 Then Begin
    lfnOpenFile(F2, FName2, ofRead);

    If Result=0 Then Begin
      L:=FileSize(F1);
      If L=FileSize(F2) Then Begin
        GetMem(Buf1, BlockSize);
        GetMem(Buf2, BlockSize);

        Out:=True;
        While (L>0) And (Out) Do Begin
          If L>BlockSize Then R:=BlockSize
          Else R:=L;
          Dec(L, R);

          BlockRead(F1, Buf1^, R);
          If IOResult<>0 Then Out:=False;
          BlockRead(F2, Buf2^, R);
          If IOResult<>0 Then Out:=False;

          If Out Then Out:=AreFieldsEqual(Buf1, Buf2, R);
        End;

        FreeMem(Buf2, BlockSize);
        FreeMem(Buf1, BlockSize);
      End;
      lfnCloseFile(F2);
    End;

    lfnCloseFile(F1);
    GetError;
  End;

  FilesEqual:=Out;
END;

{***************************************************************************}

FUNCTION IsDupe(Var Name1: tFNStr; Name2: tFNStr; Path: String): Boolean;
{ prft, ob Name2 schon als Name1 oder folgenden Files vorhanden ist}
VAR Is      : Boolean;
BEGIN
  Is:=False;
  While (Not Is) And (UpcaseStr(Name1.Name)<>UpcaseStr(Name2.Name)) Do Begin
  {upcasestr, da bei langen dateinamen unterschiede nicht in casesensity
   ignoriert werden}
    Is:=FilesEqual(Path+Name1.Name, Path+Name2.Name);
    If Not Is Then GetNextName(Name1, dupRenameFile);
  End;

  IsDupe:=Is;
END;

{***************************************************************************}

FUNCTION IsDupeAny(Name1: tFNStr; Path: String; FSize: LongInt;
                   Var Name3: tFNStr): Boolean;
{ prft, ob Name1 mit Gre FSize schon unter einem anderen Namen exist. }
VAR Is    : Boolean;
    SR    : lfnSearchRec;
BEGIN
  Is:=False;
  Name1.Name:=UpcaseStr(Name1.Name);

  lfnFindFirst(Path+'*.*', AnyFile, SR);

  While (DosError=0) And (Not Is) Do Begin
    If (SR.Attr And (Directory Or VolumeID)=0) And (SR.Size=FSize) And
     (UpcaseStr(SR.Name.Name)<>Name1.Name) Then
      Is:=FilesEqual(Path+Name1.Name, Path+SR.Name.Name);

    If Not Is Then lfnFindNext(SR)
    Else Name3:=SR.Name;
  End;

  lfnFindClose(SR);

  IsDupeAny:=Is;
END;

{***************************************************************************}

FUNCTION GetDateTimeStr: String;
{ liefert aktuelles Datum/Uhrzeit als String }
{$IFDEF OS2}
VAR Hour, Minute, Second, Sec100 : LongInt;
{$ELSE}
VAR Hour, Minute, Second, Sec100 : Word;
{$ENDIF}
    Date                         : tDate;
    dow                          : Byte;
    Str                          : String;
BEGIN
  GetDateDT(Date);
  GetTime(Hour, Minute, Second, Sec100);

{$IFDEF German}
  GetDateTimeStr:=LeadingZero(Date.Year,4)+'-'
                 +LeadingZero(Date.Month,2)+'-'
                 +LeadingZero(Date.Day,2)+' '
                 +LeadingZero(Hour,2)+':'
                 +LeadingZero(Minute,2);
{$ELSE}
  dow:=Hour Mod 12;
  If dow=0 Then dow:=12;

  Str:=LeadingZero(Date.Month,2)+'-'
      +LeadingZero(Date.Day,2)+'-'
      +LeadingZero(Date.Year,4)+' '
      +LeadingZero(dow,2)+':'
      +LeadingZero(Minute,2);

  If Hour>=12 Then Str:=Str+'p'
  Else Str:=Str+'a';
  GetDateTimeStr:=Str;
{$ENDIF}
END;

{***************************************************************************}

FUNCTION GetDateTimeXP: String; {'19960531121300W'}
{ ... im ZConnect-Header-Format }
{$IFDEF OS2}
VAR y, m, d, dow                 : LongInt;
    Hour, Minute, Second, Sec100 : LongInt;
{$ELSE}
VAR y, m, d, dow                 : Word;
    Hour, Minute, Second, Sec100 : Word;
{$ENDIF}
    Str                          : String;
BEGIN
  GetDate(y,m,d,dow);
  GetTime(Hour, Minute, Second, Sec100);

  GetDateTimeXP:=LeadingZero(y,4)+LeadingZero(m,2)+LeadingZero(d,2)
   +LeadingZero(Hour,2)+LeadingZero(Minute,2)+LeadingZero(Second,2)+'W';
END;

{***************************************************************************}
{ Fenster beim dekodieren von Dateien }
{***************************************************************************}

VAR dsLastTime : LongInt; { Zeit der letzten Aktualisierung der Durchsatz-
                            rate, hchstens alle 0.3 Sekunden ! }

PROCEDURE OpenDecodeScreen;
{$IFDEF German}
CONST Txt01 = '  aktuelle Datei:              alle Dateien:';
      Txt02 = '                                   0 von    ';
      Txt04 = 'bearbeitet:            kb                   kb';
      Txt05 = 'gesamt:                kb                   kb';
      Txt03 = 'Nachrichten:                               ';
      Txt06 = 'dekodiert:             kb                   kb';
      Txt07 = 'Gesamt: ';
      Txt08 = 'bentigte Zeit:     .0s (    0 kb/s)';
{$ELSE}
CONST Txt01 = '  current file:                all files:   ';
      Txt02 = '                                   0 of     ';
      Txt04 = 'processed:             kb                   kb';
      Txt05 = 'all:                   kb                   kb';
      Txt03 = 'messages:                                  ';
      Txt06 = 'decoded:               kb                   kb';
      Txt07 = 'total:  ';
      Txt08 = 'needed time:        .0s (    0 kb/s)';
{$ENDIF}
BEGIN
  OpenWindow(54,15, fBlack+bLightGray, wWindow1);
  WriteXY(27-(((Length(verName)+2) Div 2)), 0,fBlack+bLightGray,' '+verName+' ');
  WriteXY( 3, 2,fBlack+bLightGray,Txt01);
  WriteXY( 3, 3,fBlack+bLightGray,Txt02);
  WriteXY( 3, 5,fBlack+bLightGray,Txt04);
  WriteXY( 3, 6,fBlack+bLightGray,Txt05);
  WriteXY( 3, 7,fBlack+bLightGray,Txt03);
  WriteXY( 3, 8,fBlack+bLightGray,Txt06);
  WriteXY( 3,10,fBlack+bLightGray,Txt07+SOf('', 40));
  WriteXY( 3,12,fBlack+bLightGray,Txt08);

  dsLastTime:=GetTimeReal;
END;

{***************************************************************************}

PROCEDURE UpdateDecodeScreen;
VAR Time : LongInt;
BEGIN
  WriteXY( 7, 3,fBlack+bLightGray,stFileName);
  WriteXY(36, 3,fBlack+bLightGray,ST(stFileNumber,3));
  WriteXY(44, 3,fBlack+bLightGray,ST(stAllFNumber,3));
  WriteXY(18, 5,fBlack+bLightGray,ST(stFilePrcd Div 1024,7));
  WriteXY(40, 5,fBlack+bLightGray,ST(stAllFPrcd Div 1024,7));
  WriteXY(18, 6,fBlack+bLightGray,ST(stFileSize Div 1024,7));
  WriteXY(40, 6,fBlack+bLightGray,ST(stAllFSize Div 1024,7));
  WriteXY(18, 7,fBlack+bLightGray,ST(stFileMsg,7));
  WriteXY(40, 7,fBlack+bLightGray,ST(stAllFMsg,7));
  WriteXY(18, 8,fBlack+bLightGray,ST(stFileDecode Div 1024,7));
  WriteXY(40, 8,fBlack+bLightGray,ST(stAllFDecode Div 1024,7));

  If stAllFSize<>0 Then Begin
    If stAllFPrcd>stAllFSize Then stAllFSize:=stAllFPrcd;
    WriteXY(11,10,fYellow+bLightGray,SOf('',Trunc(stAllFPrcd/stAllFSize*40)));
  End;

  Time:=Trunc(GetTimeReal-stProcessTime);
  WriteXY(19,12,fBlack+bLightGray,ST(Time Div 10,4));
  WriteXY(24,12,fBlack+bLightGray,ST(Time Mod 10,1));

  If (GetTimeReal>=dsLastTime+3) And (Time>0) Then Begin
    WriteXY(28,12,fBlack+bLightGray,ST(stAllFPrcd Div (Time*1024),4)+'0');
    dsLastTime:=GetTimeReal;
  End;
END;

{***************************************************************************}
{ Fenster mit Prozentbalken zum Warten, Txt ist optional }
{***************************************************************************}

PROCEDURE OpenWaitWindow(Txt: S80);
BEGIN
{$IFDEF German}
  If Txt='' Then Txt:='Einen Augenblick bitte';
{$ELSE}
  If Txt='' Then Txt:='one moment please';
{$ENDIF}

  Txt:=Txt+'...';
  OpenWindow(44,7, fBlack+bLightGray, wWindow1);
  WriteXY(21-(Length(Txt) Div 2), 2,fBlack+bLightGray, Txt);
  WriteXY( 2, 4,fBlack+bLightGray,SOf('', 40));
END;

{***************************************************************************}

PROCEDURE UpdateWaitWindow(Now, Max: LongInt);
BEGIN
  If Max=0 Then Exit;
  If Now>Max Then Now:=Max;
  WriteXY(2, 4,fYellow+bLightGray,SOf('',Trunc(Now/Max*40)));
END;

{***************************************************************************}
{ Fenster beim erstellen von Dateien }
{***************************************************************************}

CONST WinSize = 12;
TYPE tWinLine = String[70];
     tWinBuf  = Array[1..WinSize] Of tWinLine;
VAR cwWinBuf  : ^tWinBuf;
    cwCounter : Byte;

PROCEDURE OpenFileCreateWindow;
VAR i: Byte;
BEGIN
  OpenWindow(74,16, fBlack+bLightGray, wWindow1);
{$IFDEF German}
  WriteXY(27, 0,fBlack+bLightGray,' Dateierstellung ');
{$ELSE}
  WriteXY(28, 0,fBlack+bLightGray,' File Creation ');
{$ENDIF}

  WriteXY( 0,13,fBlack+bLightGray,''+SOf('',72)+'');
{$IFDEF German}
  WriteXY( 5,14,fBlack+bLightGray,'Fortschritt: '+SOf('', 50));
{$ELSE}
  WriteXY( 5,14,fBlack+bLightGray,'Progress:    '+SOf('', 50));
{$ENDIF}

  New(cwWinBuf);
  For cwCounter:=1 To WinSize Do
    cwWinBuf^[cwCounter]:='';
  cwCounter:=0;
END;

{***************************************************************************}

PROCEDURE UpdateFileCreateWindowLine;
VAR i: Byte;
BEGIN
  If cwCounter=WinSize Then Begin
    For i:=1 To WinSize-1 Do Begin
      cwWinBuf^[i]:=cwWinBuf^[i+1];
      WriteXY(2,i,fBlack+bLightGray, cwWinBuf^[i]);
    End;
    WriteXY(2,WinSize,fBlack+bLightGray, S(70));
  End Else Inc(cwCounter);
END;

{***************************************************************************}

PROCEDURE UpdateFileCreateWindow(Msg1, Msg2: S80);
BEGIN
  If Length(Msg1)>67-Length(Msg2) Then Msg1[0]:=Chr(67-Length(Msg2));
  cwWinBuf^[cwCounter]:=Msg1+S(70-Length(Msg1)-Length(Msg2))+Msg2;

  WriteXY(2,cwCounter,fBlack+bLightGray, cwWinBuf^[cwCounter]);
END;

{***************************************************************************}

PROCEDURE UpdateFileCreateWindowBar(Now, Max: LongInt);
BEGIN
  If Max=0 Then Exit;
  If Now>Max Then Now:=Max;
  WriteXY(18,14,fYellow+bLightGray,SOf('',Trunc(Now/Max*50)));
END;

{***************************************************************************}

PROCEDURE WaitKeyFileCreateWindow;
VAR Key: tKey;
BEGIN
  WriteXY( 5,14,fBlack+bLightGray,SOf(' ', 63));
{$IFDEF German}
  WriteXY(15,14,fBlack+bLightGray,'Zum Fortfahren eine beliebige Taste drcken.');
{$ELSE}
  WriteXY(24,14,fBlack+bLightGray,'Press any key to continue.');
{$ENDIF}
  GetKey(Key);
END;

{***************************************************************************}

PROCEDURE CloseFileCreateWindow;
BEGIN
  Dispose(cwWinBuf);
  CloseWindow;
END;

{***************************************************************************}
{ Fenster zum manuellen Erstellen von Dateien }
{***************************************************************************}

CONST co1 = fWhite  +bBlue;
      co2 = fYellow +bBlue;
      co3 = fBlack  +bLightGray;

PROCEDURE WriteIDXContent(This, All, IDXPos: LongInt; y,co: Byte);
TYPE S4   = String[4];
{$IFDEF German}
CONST Txt00 = 'Eintrag      von';
      Txt01 = 'Dateiname:';
      Txt02 = 'Area:';
      Txt03 = 'Betreff:';
      Txt04 = 'T-Kennung:';
      Txt05 = 'S-Kennung:';
      Txt06 = 'Kodiertyp:         , Gre:';
      Txt07 = 'Start bei Teil:    , Splitteil:     , Markierung:';
      Txt08 = 'Ende bei  Teil:    , Splitteil:     , Markierung:';
      Txt09 = 'Zahl der angehngten Eintrge:';
      Txt10 = ', Gesamtgre:';
{$ELSE}
CONST Txt00 = 'entry        of';
      Txt01 = 'filename: ';
      Txt02 = 'area:';
      Txt03 = 'subject:';
      Txt04 = 'P-mark:';
      Txt05 = 'S-mark:';
      Txt06 = 'code type:         , size: ';
      Txt07 = 'begin at part:     , split part:    , mark:';
      Txt08 = 'end at   part:     , split part:    , mark:';
      Txt09 = 'number of linked entrys:';
      Txt10 = ', total size:';
{$ENDIF}
VAR FSize, FCounter : LongInt;
    j               : LongInt;
    IDX             : tIDXEntry;
    i               : Byte;

  FUNCTION cWord2Txt(i: Word): s4;
  BEGIN
    If i=isUnassigned Then cWord2Txt:='   -'
    Else cWord2Txt:=St(i,4);
  END;

  FUNCTION Marker(Flag: Byte): S10;
  BEGIN
    Case Flag And (ifFBegin or ifFEnd) Of
{$IFDEF German}
      ifFBegin or ifFEnd : Marker:='Start/Ende';
      ifFBegin           : Marker:='Start     ';
                  ifFEnd : Marker:='      Ende';
{$ELSE}
      ifFBegin or ifFEnd : Marker:='begin/end';
      ifFBegin           : Marker:='begin    ';
                  ifFEnd : Marker:='      end';
{$ENDIF}
      ifNone             : Marker:='-';
    End;
  END;

BEGIN
  For i:=0 To 9 Do
    WriteXY(1, y+i,co1, S(78));

  WriteXY( 2,y   ,co1,Txt00);
  WriteXY( 2,y+1 ,co1,Txt01);
  WriteXY( 2,y+2 ,co1,Txt02);
  WriteXY( 2,y+3 ,co1,Txt03);
  WriteXY( 2,y+4 ,co1,Txt04);
  WriteXY( 2,y+5 ,co1,Txt05);
  WriteXY( 2,y+6 ,co1,Txt06);
  WriteXY( 2,y+7 ,co1,Txt07);
  WriteXY( 2,y+9 ,co1,Txt09);

  ReadIDX(IDXPos, IDX);

  WriteXY(10,y   ,co,ST(This,4));
  WriteXY(19,y   ,co,ST(All ,4));
  WriteXY(13,y+1 ,co,Copy(IDX.rFileName.Name,1,66));
  WriteXY(13,y+2 ,co,Copy(IDX.AreaStr       ,1,66));
  WriteXY(13,y+3 ,co,Copy(IDX.SubjStr       ,1,66));
  WriteXY(13,y+4 ,co,Copy(IDX.PartStr       ,1,66));
  WriteXY(13,y+5 ,co,Copy(IDX.SplitStr      ,1,66));
  WriteXY(13,y+6 ,co,CodeName(IDX.Typ));
  WriteXY(29,y+6 ,co,ST(IDX.dSize,7));

  WriteXY(17,y+7 ,co,cWord2Txt(IDX.cPart));
  WriteXY(34,y+7 ,co,cWord2Txt(IDX.cSplit));
  WriteXY(52,y+7 ,co,Marker(IDX.Flag));

  OpenWaitWindow('');
  FSize:=IDX.dSize;
  FCounter:=0;

  While (IDX.Link<>ilUnlinked) And (ErrorAbort=eaOK) Do Begin
    IDXPos:=IDX.Link;

    ReadIDX(IDXPos, IDX);
    Inc(FSize, IDX.dSize);
    Inc(FCounter);
  End;

  CloseWindow;

  WriteXY(32,y+9, co,ST(FCounter,4));

  If FCounter>0 Then Begin
    WriteXY( 2,y+8 ,co1,Txt08);
    WriteXY(36,y+9 ,co1,Txt10);

    WriteXY(17,y+8 ,co,cWord2Txt(IDX.cPart));
    WriteXY(34,y+8 ,co,cWord2Txt(IDX.cSplit));
    WriteXY(52,y+8 ,co,Marker(IDX.Flag));
    WriteXY(50,y+9, co,ST(FSize,7));
  End;
END;

{***************************************************************************}

PROCEDURE OpenExtractManualWindow;
{$IFDEF German}
CONST Header = ' - Manuelle Dateierstellung ';
      Txt02  = 'Tastenbelegung:   Cursortasten zum Whlen  (ESC) zum Beenden';
      Txt03  = '(E)xtrahieren            alles e(X)trahieren';
      Txt04  = '(L)schen                (A)lles lschen';
      Txt05  = 'Eintrge verbi(N)den     Verbund aufl(S)en';
{$ELSE}
CONST Header = ' - Manual File Creation ';
      Txt02  = 'key commands:     cursor keys to select    (ESC) to quit';
      Txt03  = '(E)xtract                e(X)tract all';
      Txt04  = 'de(L)ete                 delete (A)ll';
      Txt05  = 'li(N)k entrys            di(S)solve link';
{$ENDIF}
BEGIN
  OpenWindow(80,25,co1, wWindow1);
  WriteXY(38-((Length(verName)+Length(Header)+1) Div 2), 0, co1,
    ' '+VerName+Header);

  WriteXY( 0,19, co1,''+SOf('',78)+'');
  WriteXY( 6,20, co1, Txt02);
  WriteXY(24,21, co1, Txt03);
  WriteXY(24,22, co1, Txt04);
  WriteXY(24,23, co1, Txt05);
END;

{***************************************************************************}

PROCEDURE UpdateExtractManualWindow(This, All, IDXPos: LongInt);
BEGIN
  WriteIDXContent(This, All, IDXPos, 1, co2);
END;

{***************************************************************************}

PROCEDURE OpenEMLinkWindow(This, All, IDXPos: LongInt);
{$IFDEF German}
CONST Txt01 = ' Eintrag whlen, der an obigen angehangen werden soll: ';
      Txt02 = 'Cursortasten zum Whlen, (RETURN) zum Besttigen, (ESC) zum Beenden';
      x1 = 13;
      x2 =  6;
{$ELSE}
CONST Txt01 = ' select entry you want to link to above one: ';
      Txt02 = 'cursor keys to select, (RETURN) to confirm, (ESC) to quit';
      x1 = 18;
      x2 = 12;
{$ENDIF}
VAR i : Byte;
BEGIN
  WriteIDXContent(This, All, IDXPos, 1, co1);

  For i:=20 To 23 Do
    WriteXY(1,i,co2,S(78));

  WriteXY( 0,19, co1,'');
  WriteXY(79,19, co1,'');
  WriteXY( 0,11, co1,''+SOf('',78)+'');
  WriteXY(x1,11, co1, Txt01);
  WriteXY( 0,22, co1,''+SOf('',78)+'');
  WriteXY(x2,23, co1, Txt02);
END;

{***************************************************************************}

PROCEDURE UpdateEMLinkWindow(This, All, IDXPos: LongInt);
BEGIN
  WriteIDXContent(This, All, IDXPos, 12, co2);
END;

{***************************************************************************}

PROCEDURE CloseEMLinkWindow;
BEGIN
  CloseWindow;
  OpenExtractManualWindow;
END;

{***************************************************************************}
{ Fenster mit Liste von Datenbankinhalt }
{***************************************************************************}

PROCEDURE OpenListDatabaseWindow;
{$IFDEF German}
CONST Header = ' - Datenbankbersicht ';
      Txt01  = 'Name         Datum    T   S   C M Betreff/Area';
      Txt02  = 'mit Cursortasten steuern, (ESC) fr Ende';
{$ELSE}
CONST Header = ' - Database Contents ';
      Txt01  = 'Name         Date     T   S   C M Subject/Area';
      Txt02  = 'control with cursor keys, (ESC) to quit';
{$ENDIF}
BEGIN
  OpenWindow(80,25,fBlack+bLightGray, wWindow1);
  WriteXY(38-((Length(verName)+Length(Header)+1) Div 2), 0, fBlack+bLightGray,
    ' '+verName+Header);
  WriteXY( 1, 1,fBlack+bLightGray,Txt01);
  WriteXY(20,23,fBlack+bLightGray,Txt02);
END;

{***************************************************************************}

PROCEDURE UpdateListDatabaseWindow(Line: Byte; Txt: S80);
CONST Color = fRed+bLightGray;
BEGIN
  If Length(Txt)>78 Then Txt[0]:=#78
  Else Txt:=Txt+S(78-Length(Txt));
  WriteXY( 1, Line+1, Color, Txt);
END;

{***************************************************************************}

{***************************************************************************}

PROCEDURE OpenCacheFlushWindow;
CONST BoxC  = fWhite+bBlack;
      Color = fWhite+bBlue;
BEGIN
{$IFDEF German}
  OpenWindow(26,3,Color,wWindow2);
  WriteXY(2,1,Color,'Leere Schreibpuffer...');
{$ELSE}
  OpenWindow(26,3,Color,wWindow2);
  WriteXY(2,1,Color,'flushing disk cache...');
{$ENDIF}
END;

{***************************************************************************}
{ Sicherheitsabfrage (J/N) }
{***************************************************************************}

FUNCTION SecurityWindow: Boolean;
VAR c: Char;
BEGIN
{$IFDEF German}
  OpenWindow(18,3,fWhite+bRed, wWindow2);
  WriteXY(2,1,fWhite+bRed,'Sicher (J/N) ?');
{$ELSE}
  OpenWindow(16,3,fWhite+bRed, wWindow2);
  WriteXY(2,1,fWhite+bRed,'Sure (Y/N) ?');
{$ENDIF}

  Repeat
    c:=Upcase(readkey);
  Until (C='J') Or (C='Y') Or (C='N') Or (C=#27);
  CloseWindow;
  SecurityWindow:=(C='J') Or (C='Y');
END;

{***************************************************************************}

  FUNCTION CodeName(Typ: Byte): S10;
  BEGIN
    Case Typ Of
      opUU     : CodeName:='UUENCODE';
      opXX     : CodeName:='XXENCODE';
      opBase64 : CodeName:='BASE64';
      opBinhex : CodeName:='BinHex';
      opUUorXX : CodeName:='UU/XX';
      Else CodeName:='?';
    End;
  END;

{***************************************************************************}

FUNCTION ioGetParamStr(i: Word): String;
{ liefert ParamStr Nummer i, setzt ParamStr mit '"' zusammen ! }
VAR j, f    : Byte;
    n       : Word;
    r, p    : String;
BEGIN
  If i=0 Then Begin
    ioGetParamStr:=ParamStr(0);
    Exit;
  End;

  n:=1;
  While (i>0) Do Begin
    { Ergebnis }
    r:='';
    f:=0;

    If n<=ParamCount Then
    Repeat
    { Anzahl der '"' ermitteln -> f }
      p:=ParamStr(n);
      For j:=1 To Length(p) Do
        If p[j]='"' Then Inc(f);

      While Pos('"', p)<>0 Do
        Delete(p, Pos('"', p), 1);
      If r<>'' Then r:=r+' ';
      r:=r+p;

      Inc(n);
    Until (f Mod 2=0) Or (n>ParamCount);

    Dec(i);
  End;

  ioGetParamStr:=r;
END;

{***************************************************************************}

FUNCTION ioGetParamCount: Word;
VAR i: Word;
BEGIN
  i:=0;
  While ioGetParamStr(i+1)<>'' Do
    Inc(i);

  ioGetParamCount:=i;
END;

{***************************************************************************}

FUNCTION WriteFidoAddr(Addr: tFidoAddr2): String;
VAR Out : String;
BEGIN
  If Addr.Zone=isUnassigned Then Out:=''
  Else Out:= ST(Addr.Zone,1)+':';

  Out:=Out+ST(Addr.net,1)+'/'
          +ST(Addr.node,1);

  If Addr.IsPoint Then Out:=Out+'.'+ST(Addr.Point,1);
  WriteFidoAddr:=Out;
END;

{***************************************************************************}

FUNCTION GetFidoAddr(Str: String; Var Addr: tFidoAddr2): Boolean;
{ Suche nach '*' fr Exclude-Funktion, setzt ggf. TmpAny }
VAR out : tFidoAddr2;
    i   : Byte;
    res : Boolean;
BEGIN
  res:=False;

  i:=Pos(':', Str);
  If i<>0 Then Begin
    If Copy(Str,1,i-1)='*' Then out.Zone:=TmpAny
    Else out.Zone:=Value(Copy(Str,1,i-1));
    Delete(Str,1,i);

    i:=Pos('/', Str);
    If i<>0 Then Begin
      If Copy(Str,1,i-1)='*' Then out.Net:=TmpAny
      Else out.Net:=Value(Copy(Str,1,i-1));
      Delete(Str,1,i);

      i:=Pos('.', Str);
      If i=0 Then Begin
        If Str='*' Then out.Node:=TmpAny
        Else out.Node:=Value(Str);
        out.Point:=0;
        out.IsPoint:=False;
      End Else Begin
        If Copy(Str,1,i-1)='*' Then out.Node:=TmpAny
        Else out.Node:=Value(Copy(Str,1,i-1));
        Delete(Str,1,i);
        out.Point:=Value(Copy(Str,1,255));
        out.IsPoint:=True;
      End;

      Addr:=Out;
      Res:=True;
    End;
  End;

  GetFidoAddr:=Res;
END;

{***************************************************************************}

END.
