{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)

}

Unit PKTX_KEY;

{$I SETTINGS.INI}

INTERFACE

{$IFDEF OS2}
Uses OS2Base;
{$ELSE}
Uses DOS;
{$ENDIF}

TYPE tKey = Record
              Char   : Char;
              UpChar : Char;
              Scan   : Word;
            End;

CONST { Extended key codes }
  kbEsc       = $011B;  kbAltSpace  = $0200;  kbCtrlIns   = $0400;
  kbShiftIns  = $0500;  kbCtrlDel   = $0600;  kbShiftDel  = $0700;
  kbBack      = $0E08;  kbCtrlBack  = $0E7F;  kbShiftTab  = $0F00;
  kbTab       = $0F09;  kbAltQ      = $1000;  kbAltW      = $1100;
  kbAltE      = $1200;  kbAltR      = $1300;  kbAltT      = $1400;
  kbAltY      = $1500;  kbAltU      = $1600;  kbAltI      = $1700;
  kbAltO      = $1800;  kbAltP      = $1900;  kbCtrlEnter = $1C0A;
  kbEnter     = $1C0D;  kbAltA      = $1E00;  kbAltS      = $1F00;
  kbAltD      = $2000;  kbAltF      = $2100;  kbAltG      = $2200;
  kbAltH      = $2300;  kbAltJ      = $2400;  kbAltK      = $2500;
  kbAltL      = $2600;  kbAltZ      = $2C00;  kbAltX      = $2D00;
  kbAltC      = $2E00;  kbAltV      = $2F00;  kbAltB      = $3000;
  kbAltN      = $3100;  kbAltM      = $3200;  kbF1        = $3B00;
  kbF2        = $3C00;  kbF3        = $3D00;  kbF4        = $3E00;
  kbF5        = $3F00;  kbF6        = $4000;  kbF7        = $4100;
  kbF8        = $4200;  kbF9        = $4300;  kbF10       = $4400;
  kbF11       = $8500;  kbF12       = $8600;  kbHome      = $4700;
  kbUp        = $4800;  kbPgUp      = $4900;  kbGrayMinus = $4A2D;
  kbLeft      = $4B00;  kbRight     = $4D00;  kbGrayPlus  = $4E2B;
  kbEnd       = $4F00;  kbDown      = $5000;  kbPgDn      = $5100;
  kbIns       = $5200;  kbDel       = $5300;  kbShiftF1   = $5400;
  kbShiftF2   = $5500;  kbShiftF3   = $5600;  kbShiftF4   = $5700;
  kbShiftF5   = $5800;  kbShiftF6   = $5900;  kbShiftF7   = $5A00;
  kbShiftF8   = $5B00;  kbShiftF9   = $5C00;  kbShiftF10  = $5D00;
  kbShiftF11  = $8700;  kbShiftF12  = $8800;  kbCtrlF1    = $5E00;
  kbCtrlF2    = $5F00;  kbCtrlF3    = $6000;  kbCtrlF4    = $6100;
  kbCtrlF5    = $6200;  kbCtrlF6    = $6300;  kbCtrlF7    = $6400;
  kbCtrlF8    = $6500;  kbCtrlF9    = $6600;  kbCtrlF10   = $6700;
  kbCtrlF11   = $8900;  kbCtrlF12   = $8A00;  kbAltF1     = $6800;
  kbAltF2     = $6900;  kbAltF3     = $6A00;  kbAltF4     = $6B00;
  kbAltF5     = $6C00;  kbAltF6     = $6D00;  kbAltF7     = $6E00;
  kbAltF8     = $6F00;  kbAltF9     = $7000;  kbAltF10    = $7100;
  kbAltF11    = $8B00;  kbAltF12    = $8C00;  kbCtrlPrtSc = $7200;
  kbCtrlLeft  = $7300;  kbCtrlRight = $7400;  kbCtrlEnd   = $7500;
  kbCtrlPgDn  = $7600;  kbCtrlHome  = $7700;  kbAlt1      = $7800;
  kbAlt2      = $7900;  kbAlt3      = $7A00;  kbAlt4      = $7B00;
  kbAlt5      = $7C00;  kbAlt6      = $7D00;  kbAlt7      = $7E00;
  kbAlt8      = $7F00;  kbAlt9      = $8000;  kbAlt0      = $8100;
  kbCtrlPgUp  = $8400;  kbNoKey     = $0000;  kbAltRel    = $FFFF;

{ Keyboard state and shift masks }

  kbRightShift  = $0001;
  kbLeftShift   = $0002;
  kbCtrlShift   = $0004;
  kbAltShift    = $0008;
  kbScrollState = $0010;
  kbNumState    = $0020;
  kbCapsState   = $0040;
  kbInsState    = $0080;


PROCEDURE GetKey(Var Key: tKey);
{$IFDEF Debug}
PROCEDURE DebugInfo(S: String);
{$ENDIF}

IMPLEMENTATION

{$IFDEF OS2}

PROCEDURE GetKey(Var Key: tKey);
VAR KeyInfo: KbdKeyInfo;
BEGIN
  KbdCharIn(KeyInfo, io_Wait, 0);
  Key.Char:=KeyInfo.chChar;
  Key.UpChar:=Upcase(Key.Char);
  Key.Scan:=(KeyInfo.chScan Shl 8) Or (Ord(Key.Char));
  If (Lo(Key.Scan)=$E0) And (Hi(Key.Scan)<>0) Then Key.Scan:=Key.Scan And $FF00;
END;

{$ELSE}

PROCEDURE GetKey(Var Key: tKey);
VAR tmp: Word;
BEGIN
  Asm
   @warte_auf_zeichen:
    mov ah, 01
    int $16
    jnz @zeichen_da
    int $28 {rechenzeitfreigabe}
    jmp @warte_auf_zeichen

   @zeichen_da:
    xor ah, ah
    int $16
    mov tmp, ax
  End;
  Key.Char:=Chr(Lo(tmp));
  Key.UpChar:=Upcase(Key.Char);
  Key.Scan:=tmp;
  If (Lo(Key.Scan)=$E0) And (Hi(Key.Scan)<>0) Then Key.Scan:=Key.Scan And $FF00;
END;

{$ENDIF}

{$IFDEF Debug}
PROCEDURE DebugInfo(S: String);
VAR tmp : Text;
BEGIN
  assign(tmp, 'C:\PKTXCODE.DBG');
  append(tmp);
  if ioresult<>0 then rewrite(tmp);
  if ioresult<>0 then exit;

  writeln(tmp, s);
  close(tmp);
END;
{$ENDIF}

END.
