{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)

}

Unit PKTX_LNK;

{$I SETTINGS.INI}

{    29.10.96 Erstellt.
     17.11.96 Bearbeitung nur noch, wenn neue Daten
     04.01.97 Bug in ForceFileJoining behoben
     12.03.97 Bug beim Linken Nachrichten mit UU-/FCS-Splitmarkierung beh.
     10.07.97 bei gelinkten Nachrichten wird bei allen neuestes Datum gesetz
}

INTERFACE

{$IFDEF OS2}
Uses CRT_OS2, DOS, PKTX_IO, PKTX_KEY, PKTX_SCR, PKTX_DB, PKTX_MEM;
{$ELSE}
Uses CRT,     DOS, PKTX_IO, PKTX_KEY, PKTX_SCR, PKTX_DB, PKTX_MEM;
{$ENDIF}

PROCEDURE BuildDatabase;

IMPLEMENTATION

{**************************************************************************}

PROCEDURE BuildDatabase;
{ Vorgehensplan:
  solange Nachricht noch nicht verbunden ist:
  1. prfen, ob jeweils nchste Nachricht Split-Nachfolger ist
     ( lst Problem von mehreren gleichnamigen Nachrichten )
  2. Datenbank nach fehlenden Split-Teilen durchsuchen
  3. prfen, ob jeweils nchste Nachricht Part-Nachfolger ist
     ( lst Problem von mehreren gleichnamigen Nachrichten )
  4. Datenbank nach fehlenden Part-Teilen durchsuchen

}

{$IFDEF German}
CONST WaitTxt    = 'suche zusammengehrige Nachrichten';
{$ELSE}
CONST WaitTxt    = 'analysing database';
{$ENDIF}

VAR IDX1, IDX2   : tIDXEntry;
    i, j,
    p, q, Done   : LongInt;

  PROCEDURE Percent;
  BEGIN
    Inc(Done, p);
    p:=0;
    UpdateWaitWindow(Done, IDXCounter*5);
  END;

  FUNCTION NextI: LongInt;
  BEGIN
    If i<IDXCounter Then NextI:=i+1
    Else NextI:=1;
  END;

  FUNCTION SameFile: Boolean;
  BEGIN
    SameFile:= (Copy(IDX1.PartStr,1,Length(IDX2.PartStr))=
                Copy(IDX2.PartStr,1,Length(IDX1.PartStr)))
               And (IDX1.AreaStr=IDX2.AreaStr)
               And (IDX1.Typ=IDX2.Typ)
               And ( (IDX2.Flag And ifFBegin=0) Or ForceFileJoining )
               And ( IDX2.Flag And ifVLinked=0);
  END;

  PROCEDURE VerbindeNachrichten_FidoSplit;
  BEGIN
    i:=1;
    While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
      ReadIDX(i, IDX1);
      If (IDX1.Link=ilUnlinked) And (IDX1.Flag And ifVEnd=0)
       And (IDX1.cSplit<IDX1.cSplitOf) And ( (IDX1.Flag And ifFEnd=0)
       Or (ForceFileJoining) ) And (IDX1.SplitStr<>'') Then Begin
        j:=i;
        Repeat
          Inc(j);
          If j>IDXCounter Then j:=1;
          ReadIDX(j, IDX2);

          If       (IDX1.AreaStr=IDX2.AreaStr)
               And (IDX1.Typ=IDX2.Typ)
               And ( (IDX2.Flag And ifFBegin=0) Or ForceFileJoining )
               And ( IDX2.Flag And ifVLinked=0)
               And (IDX1.cSplit+1=IDX2.cSplit)
               And (IDX1.SplitStr=IDX2.SplitStr)
           Then Begin
            IDX1.Link:=j;
            WriteIDX(i, IDX1);
            IDX2.Flag:=IDX2.Flag Or ifVLinked;
            WriteIDX(j, IDX2);
            j:=i;
          End;
        Until (j=i);
      End;

      Inc(i);
      Inc(p);
      If p=q Then Percent;
    End;
  END;

  PROCEDURE VerbindeAufeinanderfolgendeNachrichten_Split;
  BEGIN
    i:=1;
    While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
      ReadIDX(i, IDX1);
      If (IDX1.Link=ilUnlinked) And (IDX1.Flag And ifVEnd=0) Then Begin
        If (IDX1.Flag And ifFEnd<>0) And (Not ForceFileJoining) Then Begin
          IDX1.Flag:=IDX1.Flag Or ifVEnd;
          WriteIDX(i, IDX1);
        End Else If IDX1.cSplit<IDX1.cSplitOf Then Begin
                                    { Or cSplitOf=isUnassigned }
          ReadIDX(NextI, IDX2);

          If SameFile And (IDX1.cSplit+1=IDX2.cSplit)
           And ( (IDX1.cPart=IDX2.cPart) Or (IDX1.cPart=isUnassigned)
           Or (IDX2.cPart=isUnassigned) ) Then Begin
            IDX1.Link:=NextI;
            WriteIDX(i, IDX1);
            IDX2.Flag:=IDX2.Flag Or ifVLinked;
            WriteIDX(NextI, IDX2);
          End;
        End;
      End;

      Inc(i);
      Inc(p);
      If p=q Then Percent;
    End;
  END;

  PROCEDURE VerbindeVerstreuteNachrichten_Split;
  BEGIN
    i:=1;
    While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
      ReadIDX(i, IDX1);
      If (IDX1.Link=ilUnlinked) And (IDX1.Flag And ifVEnd=0)
       And (IDX1.cSplit<IDX1.cSplitOf) And ( (IDX1.Flag And ifFEnd=0)
       Or (ForceFileJoining) ) Then Begin
        j:=i;
        Repeat
          Inc(j);
          If j>IDXCounter Then j:=1;
          ReadIDX(j, IDX2);

          If SameFile And (IDX1.cSplit+1=IDX2.cSplit)
           And (IDX1.cPart=IDX2.cPart) Then Begin
            IDX1.Link:=j;
            WriteIDX(i, IDX1);
            IDX2.Flag:=IDX2.Flag Or ifVLinked;
            WriteIDX(j, IDX2);
            j:=i;
          End;
        Until (j=i);
      End;

      Inc(i);
      Inc(p);
      If p=q Then Percent;
    End;
  END;

  CONST vnFolgend   = 0;
        vnVerstreut = 1;

  PROCEDURE VerbindeNachrichten_Part(Mode: Byte);
  { Bei Nachrichten, die UU-Split- oder FCS-Splitmarkierung haben,
    haben nicht alle Split-Teile denselben PartStr !
    Bsp: S1: P: UU-Spli
         S2: P: lalala
         S3: P: lalala
    -> beginn aller unvollst. verbnde nehmen, ans ende springen
       und dann erst fortsetzung mit 1.Partstr suchen }
  VAR IDX3  : tIDXEntry;
      k     : LongInt;
      oPart : Word;
      Found : Boolean;
  BEGIN
    i:=1;
    While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
      ReadIDX(i, IDX1);

      Found:=False;
      If (IDX1.Flag And (ifVLinked Or ifVEnd)=0)
       And ( (IDX1.Flag And ifFEnd=0) Or (ForceFileJoining) )
       And (IDX1.cPart<IDX1.cPartOf) Then Begin
        j:=i;
        oPart:=IDX1.cPart;
        IDX3:=IDX1;
        While IDX3.Link<>ilUnlinked Do Begin
          j:=IDX3.Link;
          ReadIDX(j, IDX3);
          If IDX3.cPart<>isUnassigned Then oPart:=IDX3.cPart;
        End;

        k:=j;
        Repeat
          Inc(k);
          If k>IDXCounter Then k:=1;
          ReadIDX(k, IDX2);

          If SameFile And (IDX2.cSplit=1)
           And (oPart+1=IDX2.cPart) Then Begin
            IDX3.Link:=k;
            WriteIDX(j, IDX3);
            IDX2.Flag:=IDX2.Flag Or ifVLinked;
            WriteIDX(k, IDX2);
            Found:=True;
            k:=j;
          End;
        Until (k=j) Or (Mode=vnFolgend);
      End;

      If (Not Found) Then Begin { wenn angehangen, dann erneut prfen }
        Inc(i);
        Inc(p);
        If p=q Then Percent;
      End;
    End;
  END;

  PROCEDURE SucheKompletteVerbuende;
  { Base64Header - Auto: entspricht Split=1 und Part=1/unbenutzt }
  VAR maxDate, tmpDate : LongInt;
      DateData         : tDate;
  BEGIN
    i:=1;
    While (i<=IDXCounter) And (ErrorAbort=eaOK) Do Begin
      ReadIDX(i, IDX1);

      If (IDX1.Flag And (ifVComplete Or ifVLinked)=0)
       And ( (IDX1.Flag And ifFBegin<>0) Or
             ( (IDX1.Typ=opBase64) And ( (UseBase64Header=b64No) Or
               ((UseBase64Header=b64Auto) And (IDX1.cSplit=1) And
                ((IDX1.cPart=1) Or (IDX1.cPartOf=isUnassigned)) ) ) ) ) Then Begin
        IDX2:=IDX1;

        maxDate:=GetDateCounter(IDX1.Date);

        j:=i;
        If ForceFileJoining Then Begin
          While (IDX2.Link<>ilUnlinked) Do Begin
            j:=IDX2.Link;
            ReadIDX(j, IDX2);

            tmpDate:=GetDateCounter(IDX2.Date);
            If tmpDate>maxDate Then Begin
              maxDate:=tmpDate;
              DateData:=IDX2.Date;
            End;
          End;

          If (IDX2.Flag And ifFEnd<>0) Or ( (IDX1.Typ=opBase64)
           And (UseBase64Header=b64No) )Then Begin
            IDX1.Flag:=IDX1.Flag Or ifVStart Or ifVComplete;
            WriteIDX(i, IDX1);
          End;
        End Else Begin
          While (IDX2.Link<>ilUnlinked) And (IDX2.Flag And ifVEnd=0) Do Begin
            j:=IDX2.Link;
            ReadIDX(j, IDX2);

            tmpDate:=GetDateCounter(IDX2.Date);
            If tmpDate>maxDate Then Begin
              maxDate:=tmpDate;
              DateData:=IDX2.Date;
            End;
          End;

          If (IDX2.Flag And ifVEnd<>0) Or ( (IDX1.Typ=opBase64)
           And (UseBase64Header=b64No) ) Then Begin
            IDX1.Flag:=IDX1.Flag Or ifVStart Or ifVComplete;
            WriteIDX(i, IDX1);
          End;
        End;

        If maxDate<>GetDateCounter(IDX1.Date) Then Begin
          j:=i;
          Repeat
            ReadIDX(j, IDX2);
            IDX2.Date:=DateData;
            j:=IDX2.Link;
          Until (j=ilUnlinked) Or (IDX2.Flag And ifVEnd=0);
        End;
      End;

      Inc(i);
      Inc(p);
      If p=q Then Percent;
    End;
  END;

BEGIN
  If (IDXCounter=0) Or
    ((jobExec And jobExtractManual=0) And (stAllFMsgData=0)) Then Exit;
  OpenWaitWindow(WaitTxt);

  Done:=0;
  q:=(IDXCounter*6) Div 100;
  p:=0;
  VerbindeNachrichten_FidoSplit;
  VerbindeAufeinanderfolgendeNachrichten_Split;
  VerbindeVerstreuteNachrichten_Split;

  VerbindeNachrichten_Part(vnFolgend);
  VerbindeNachrichten_Part(vnVerstreut);
  SucheKompletteVerbuende;

  CloseWindow;
END;

END.


