{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)

}

Unit PKTX_SCR; { Unit fr Bildschirmausgabe und Uhrzeit/Datumfunktionen }

{$I SETTINGS.INI}

{ zum Testen Initbreak deaktivieren }

{    26.10.96 Bug in GetTimeReal behoben
     20.11.96 Bug in Value() behoben
     08.02.97 Durchsatzrate wird hchstens alle 0.3 Sekunden aktualisiert
     09.02.97 GetTimeReal kommt mit Programmlauf ber Tagesgrenze klar
     13.03.98 Fehler in Value() behoben
}

INTERFACE

{$IFDEF OS2}
Uses DOS;
{$ELSE}
Uses DOS;
{$ENDIF}

TYPE S80                  = String[80];
TYPE S10                  = String[10];
TYPE TDate                = Record
                              Day   : Byte;
                              Month : Byte;
                              Year  : Word;
                            End;

CONST fBlack         = 0;   { Farben }
      fBlue          = 1;
      fGreen         = 2;
      fCyan          = 3;
      fRed           = 4;
      fMagenta       = 5;
      fBrown         = 6;
      fLightGray     = 7;
      fDarkGray      = 8;
      fLightBlue     = 9;
      fLightGreen    = 10;
      fLightCyan     = 11;
      fLightRed      = 12;
      fLightMagenta  = 13;
      fYellow        = 14;
      fWhite         = 15;
      bBlack         = 0;
      bBlue          = 16;
      bGreen         = 32;
      bCyan          = 48;
      bRed           = 64;
      bMagenta       = 80;
      bBrown         = 96;
      bLightGray     = 112;
      sBlink         = 128;
      cDark          = fDarkGray+bBlack;

CONST wWindow0 = 2; { Anzahl der Rahmenlinien }
      wWindow1 = 0;
      wWindow2 = 1;

CONST eaOK                          =   0;
      eaVoidXMem                    =   1;
      eaIDXRead                     = 100;
      eaIDXWrite                    = 101;
      eaIDXCache                    = 102;
      eaIDXError                    = 103;
      eaDatCompress                 = 104;
      eaDatFileRead                 = 105;
      eaDatFileWrite                = 106;
      eaDiskFull                    = 107;
      eaXMS                         = 108;
      eaInternalError               = 109;
      eaInstReady                   = 200;
      eaInstFileCopy                = 201;
      eaInstWriteINIFile            = 202;
      eaInstEditXP                  = 203;
      eaHalt                        = 254;
      eaUserBreak                   = 255;

CONST ErrorAbort       : Byte       = eaOK;

CONST UpCaseField: Array[0..$FF] Of Char=  {umrechnungstabelle}
       (#000,#001,#002,#003,#004,#005,#006,#007,#008,#009,#010,#011,#012,
        #013,#014,#015,#016,#017,#018,#019,#020,#021,#022,#023,#024,#025,
        #026,#027,#028,#029,#030,#031,' ' ,'!' ,'"' ,'#' ,'$' ,'%' ,'&' ,
        #039,'(' ,')' ,'*' ,'+' ,',' ,'-' ,'.' ,'/' ,'0' ,'1' ,'2' ,'3' ,
        '4' ,'5' ,'6' ,'7' ,'8' ,'9' ,':' ,';' ,'<' ,'=' ,'>' ,'?' ,'@' ,
        'A' ,'B' ,'C' ,'D' ,'E' ,'F' ,'G' ,'H' ,'I' ,'J' ,'K' ,'L' ,'M' ,
        'N' ,'O' ,'P' ,'Q' ,'R' ,'S' ,'T' ,'U' ,'V' ,'W' ,'X' ,'Y' ,'Z' ,
        '[' ,'\' ,']' ,'^' ,'_' ,'`' ,'A' ,'B' ,'C' ,'D' ,'E' ,'F' ,'G' ,
        'H' ,'I' ,'J' ,'K' ,'L' ,'M' ,'N' ,'O' ,'P' ,'Q' ,'R' ,'S' ,'T' ,
        'U' ,'V' ,'W' ,'X' ,'Y' ,'Z' ,'{' ,'|' ,'}' ,'~' ,'' ,'' ,'' ,
        '' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,
        '' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,
        '' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,'' ,#166,#167,#168,
        #169,#170,#171,#172,#173,#174,#175,#176,#177,#178,#179,#180,#181,
        #182,#183,#184,#185,#186,#187,#188,#189,#190,#191,#192,#193,#194,
        #195,#196,#197,#198,#199,#200,#201,#202,#203,#204,#205,#206,#207,
        #208,#209,#210,#211,#212,#213,#214,#215,#216,#217,#218,#219,#220,
        #221,#222,#223,#224,#225,#226,#227,#228,#229,#230,#231,#232,#233,
        #234,#235,#236,#237,#238,#239,#240,#241,#242,#243,#244,#245,#246,
        #247,#248,#249,#250,#251,#252,#253,#254,#255);

{$IFNDEF OS2}
PROCEDURE InitWriteXY;
{$ENDIF}

PROCEDURE WriteXY(Spalte, Zeile, Farbe: Byte; StrOut: S80);
PROCEDURE WriteXYabs(Spalte, Zeile, Farbe: Byte; StrOut: S80);
PROCEDURE SetCursorPos(x,y: Byte);
PROCEDURE GetCursorPos(Var x,y: Byte);
PROCEDURE HideCursor;
PROCEDURE ShowCursor;
PROCEDURE ClearC(x1,y1,x2,y2,c: Byte);

PROCEDURE CloseWindow;
PROCEDURE ClearScreenBuf;
PROCEDURE OpenWindow(Wid, Len, Color, Typ: Byte);

FUNCTION Value(S: String): LongInt;
FUNCTION UpCase2(C: Char): Char;
FUNCTION UpCaseStr(S: String): String;
FUNCTION ST(I: LongInt; B: Byte): String;
FUNCTION S(B: Byte): String;
FUNCTION SOf(C: Char; B: Byte): String;
FUNCTION Hex(B: Byte): String;
FUNCTION Hex2Byte(S: S10): Byte;
FUNCTION LeadingZero(W: LongInt; Anz: Byte): S80;
PROCEDURE CompressStr(Var S: String);

FUNCTION GetTimeReal: LongInt;
FUNCTION GetDateCounter(DT: tDate): LONGINT;
FUNCTION GetDateDifference(DT1, DT2: TDate): LongInt;
PROCEDURE GetDateDT(Var DT: TDate);

{***************************************************************************}
{***************************************************************************}
{***************************************************************************}

IMPLEMENTATION

{$IFDEF OS2}
Uses Os2Base;
{$ENDIF}

TYPE PScreenWindow = ^TScreenWindow;
     TScreenWindow = Record
                       Next                 : PScreenWindow;
                       x, y, Wid, Len       : Byte;
                       Buf                  : Pointer;
                     End;
     PWBuf         = ^TWBuf;
     TWBuf         = Array[0..16383] Of Word;

{$IFNDEF OS2}
CONST VSeg         : Word = $B800;
{$ENDIF}

VAR ScreenBuf                  : TScreenWindow;
    CurWindow                  : PScreenWindow;

{*** Interruptfunktionen ***************************************************}

{$IFNDEF OS2}
VAR OldCC, OldCB, OldExitCNB   : Pointer;

{$F+}
PROCEDURE BlockInterrupt; Interrupt;
BEGIN
  ErrorAbort:=eaUserBreak;
END;

PROCEDURE ClearCNB;
BEGIN
  SetIntVec($23, OldCC);
  SetIntVec($1B, OldCB);

  ExitProc:=OldExitCNB;
END;
{$F-}

PROCEDURE InitBreak;
BEGIN
  GetIntVec($23, OldCC);
  GetIntVec($1B, OldCB);
  SetIntVec($23, @BlockInterrupt);
  SetIntVec($1B, @BlockInterrupt);

  OldExitCNB:=ExitProc;
  ExitProc:=@ClearCNB;
END;
{$ENDIF}

{***************************************************************************}
{*** Video *****************************************************************}
{***************************************************************************}

{$IFNDEF OS2}

PROCEDURE InitWriteXY;
VAR CRTC_PORT : Word absolute $0040:$0063;
BEGIN
  If CRTC_PORT=$3B4 Then VSeg:=$B000
  Else VSeg:=$B800;

  InitBreak;
END;

PROCEDURE WriteXY(Spalte, Zeile, Farbe: Byte; StrOut: S80);
VAR PAGE_OFS        : Word absolute $0040:$004E;
    Offset, Color   : Word;
    n               : Byte;
BEGIN
  If (Spalte>=80) Or (Zeile>=25) Then Exit;
  If Spalte+Length(StrOut)>80 Then StrOut[0]:=Chr(80-Spalte);
{  If (Spalte>=CurWindow^.Wid+2) Or (Zeile>=CurWindow^.Len+1) Then Exit;}

  Offset:=(Zeile+CurWindow^.Y)*160 + (Spalte+CurWindow^.X)*2 + PAGE_OFS;
  Color:=Farbe shl 8;
  For n:=1 To Length(StrOut) Do Begin
    MemW[VSeg:Offset]:=Color Or Ord(StrOut[n]);
    Offset:=Offset+2;
  End;
END;

PROCEDURE WriteXYabs(Spalte, Zeile, Farbe: Byte; StrOut: S80);
VAR PAGE_OFS        : Word absolute $0040:$004E;
    Offset, Color   : Word;
    n               : Byte;
BEGIN
  Offset:=(Zeile)*160 + (Spalte)*2 + PAGE_OFS;
  Color:=Farbe shl 8;
  For n:=1 To Length(StrOut) Do Begin
    MemW[VSeg:Offset]:=Color Or Ord(StrOut[n]);
    Offset:=Offset+2;
  End;
END;

PROCEDURE ClearC(x1,y1,x2,y2,c: Byte);
BEGIN
  Asm
    mov ah,06h
    mov al,0
    mov ch,y1
    mov cl,x1
    mov dh,y2
    mov dl,x2
    mov bh,c
    int $10
  End;
END;

{***************************************************************************}
{*** Cursor ****************************************************************}
{***************************************************************************}

PROCEDURE SetCursorPos(x,y: Byte);
BEGIN
  Inc(x, CurWindow^.x);
  Inc(y, CurWindow^.y);
  ASM
    mov ah, $02
    mov bh, 0
    mov dh, y
    mov dl, x
    int $10
  End;
END;

PROCEDURE GetCursorPos(Var x,y: Byte);
VAR x0, y0: Byte;
BEGIN
  ASM
    mov ah, $03
    mov bh, 0
    int $10
    mov ax, dx
    mov y0, dh
    mov x0, dl
  End;
  x:=x0-CurWindow^.x;
  y:=y0-CurWindow^.y;
END;

VAR OldCursor   : Word;
    CurExitProc : Pointer;

PROCEDURE HideCursor; Assembler;
ASM mov ah, $01
    mov cx, $2000 {FFFE}
    int $10
END;

PROCEDURE ShowCursor; Assembler;
ASM mov ah, $01
    mov cx, oldcursor
    int $10
END;

{$F+}
PROCEDURE RestoreCursor;
BEGIN
  ShowCursor;
  ExitProc:=CurExitProc;
END;
{$F-}

PROCEDURE InitCursor;
BEGIN
  ASM
    mov ah,3
    mov bh,0
    int $10
    mov oldcursor,cx
  END;

  HideCursor;
  CurExitProc:=ExitProc;
  ExitProc:=@RestoreCursor;
END;

{***************************************************************************}
{*** FensterTechnik ********************************************************}
{***************************************************************************}

PROCEDURE SaveScreen(x,y,Wid,Len: Byte);
VAR PAGE_OFS             : Word absolute $0040:$004E;
    Offset, Size         : Word;
    y1, x1               : Byte;
    P                    : PScreenWindow;
    Buf                  : PWBuf;
BEGIN
  P:=@ScreenBuf;
  While P^.Next<>NIL Do
    P:=P^.Next;

  New(P^.Next);
  P:=P^.Next;
  P^.Next:=NIL;
  CurWindow:=P;

  P^.x:=x;
  P^.y:=y;
  P^.Wid:=Wid;
  P^.Len:=Len;

  GetMem(P^.Buf, Word(Wid)*Len*2);
  Buf:=P^.Buf;

  Size:=0;
  For y1:=y To y+Len-1 Do Begin
    Offset:=y1*160+x*2 + PAGE_OFS;
    For x1:=1 To Wid Do Begin
      Buf^[Size]:=MemW[VSeg:Offset];
      Inc(OffSet,2);
      Inc(Size);
    End;
  End;
END;

PROCEDURE CloseWindow;
VAR PAGE_OFS             : Word absolute $0040:$004E;
    Offset, Color, Size  : Word;
    x1,y1                : Byte;
    P                    : PScreenWindow;
    Buf                  : PWBuf;
BEGIN
  If CurWindow=@ScreenBuf Then Exit;

  P:=@ScreenBuf;
  While P^.Next<>NIL Do
    P:=P^.Next;

  CurWindow:=@ScreenBuf;
  While CurWindow^.Next<>P Do
    CurWindow:=CurWindow^.Next;

  Buf:=P^.Buf;
  Size:=0;
  For y1:=P^.y To P^.y+P^.Len-1 Do Begin
    Offset:=y1*160+P^.x*2 + PAGE_OFS;
    For x1:=1 To P^.Wid Do Begin
      MemW[VSeg:Offset]:=Buf^[Size];
      Inc(OffSet,2);
      Inc(Size);
    End;
  End;

  Size:=P^.Len*P^.Wid;
  FreeMem(P^.Buf, Size*2);
  Dispose(P);
  CurWindow^.Next:=NIL;
END;

{***************************************************************************}
{*** Video *****************************************************************}
{***************************************************************************}

{$ELSE}

PROCEDURE WriteXY(Spalte, Zeile, Farbe: Byte; StrOut: S80);
BEGIN
  If (Spalte>=80) Or (Zeile>=25) Then Exit;
  If Spalte+Length(StrOut)>80 Then StrOut[0]:=Chr(80-Spalte);
{  If (Spalte>=CurWindow^.Wid+2) Or (Zeile>=CurWindow^.Len+1) Then Exit;}

  VioWrtCharStrAtt(@StrOut[1],Length(StrOut),Zeile+CurWindow^.Y,
   Spalte+CurWindow^.X,Farbe,0);
END;

PROCEDURE WriteXYabs(Spalte, Zeile, Farbe: Byte; StrOut: S80);
BEGIN
  VioWrtCharStrAtt(@StrOut[1],Length(StrOut),Zeile,Spalte,Farbe,0);
END;

PROCEDURE ClearC(x1,y1,x2,y2,c: Byte);
VAR y: Byte;
BEGIN
  For y:=y1 To y2 Do
    WriteXY(x1, y, c, S(x2-x1+1));
END;

{***************************************************************************}
{*** Cursor ****************************************************************}
{***************************************************************************}

PROCEDURE SetCursorPos(x,y: Byte);
BEGIN
  Inc(x, CurWindow^.x);
  Inc(y, CurWindow^.y);
  VioSetCurPos(Y,X,0);
END;

PROCEDURE GetCursorPos(Var x,y: Byte);
VAR X0,Y0: Word;
BEGIN
  VioGetCurPos(Y0,X0,0);
  x:=x0-CurWindow^.x;
  y:=y0-CurWindow^.y;
END;

VAR OldCursor   : VioCursorInfo;
    CurExitProc : Pointer;

PROCEDURE HideCursor;
VAR NewCursor: VioCursorInfo;
BEGIN
  NewCursor:=OldCursor;
  NewCursor.Attr:=65535{-1};
  VioSetCurType(NewCursor, 0);
END;

PROCEDURE ShowCursor;
BEGIN
  VioSetCurType(OldCursor, 0);
END;

{$F+}
PROCEDURE RestoreCursor;
BEGIN
  ShowCursor;
  ExitProc:=CurExitProc;
END;
{$F-}

PROCEDURE InitCursor;
BEGIN
  VioGetCurType(OldCursor, 0);
  HideCursor;

  CurExitProc:=ExitProc;
  ExitProc:=@RestoreCursor;
END;

{***************************************************************************}
{*** FensterTechnik ********************************************************}
{***************************************************************************}

PROCEDURE SaveScreen(x,y,Wid,Len: Byte);
VAR Size, BufLen    : Word;
    y1              : Byte;
    P               : PScreenWindow;
    Buf             : PWBuf;
BEGIN
  P:=@ScreenBuf;
  While P^.Next<>NIL Do
    P:=P^.Next;

  New(P^.Next);
  P:=P^.Next;
  P^.Next:=NIL;
  CurWindow:=P;

  P^.x:=x;
  P^.y:=y;
  P^.Wid:=Wid;
  P^.Len:=Len;

  Size:=Wid*Len;
  GetMem(P^.Buf, Size*2);
  Buf:=P^.Buf;

  Size:=0;
  BufLen:=P^.Wid*2;
  For y1:=y To y+Len-1 Do Begin
    VioReadCellStr(Buf^[Size], BufLen, y1, P^.x,0);
    Inc(Size, P^.Wid);
  End;
END;

PROCEDURE CloseWindow;
VAR Size                 : Word;
    y1                   : Byte;
    P                    : PScreenWindow;
    Buf                  : PWBuf;
BEGIN
  If CurWindow=@ScreenBuf Then Exit;

  P:=@ScreenBuf;
  While P^.Next<>NIL Do
    P:=P^.Next;

  CurWindow:=@ScreenBuf;
  While CurWindow^.Next<>P Do
    CurWindow:=CurWindow^.Next;

  Buf:=P^.Buf;
  Size:=0;
  For y1:=P^.y To P^.y+P^.Len-1 Do Begin
    VioWrtCellStr(@Buf^[Size], P^.Wid*2, y1, P^.x, 0);
    Inc(Size, P^.Wid);
  End;

  Size:=P^.Len*P^.Wid;
  FreeMem(P^.Buf, Size*2);
  Dispose(P);
  CurWindow^.Next:=NIL;
END;

{$ENDIF}

{***************************************************************************}
{ abstrakte Funktionen }
{***************************************************************************}

PROCEDURE ClearScreenBuf;
BEGIN
  While CurWindow<>@ScreenBuf Do
    CloseWindow;
END;

PROCEDURE DrawBoxBorder(x, y, Wid, Len: Byte);
VAR i : Byte;
BEGIN
  For i:=y+1 To y+Len-1 Do
    WriteXY(x+Wid,i,7,#177#177);
  WriteXY(x+2, y+Len, 7, SOf(#177, Wid));
END;

PROCEDURE DrawBox(x, y, Wid, Len, Color, Typ: Byte);
CONST CharSet : Array[0..2, 0..5] Of Char
              = ( 'ڿٳ', 'ɻȼ', '      ' );
VAR n    : Byte;
    Line : S80;
BEGIN
  Line:=SOf(CharSet[Typ, 0], Wid);

  Line[1]  :=CharSet[Typ, 1];
  Line[Wid]:=CharSet[Typ, 2];
  WriteXY(x,y,Color,Line);

  Line[1]  :=CharSet[Typ, 3];
  Line[Wid]:=CharSet[Typ, 4];
  WriteXY(x,y+Len-1,Color,Line);

  Line:=S(Wid);
  Line[1]  :=CharSet[Typ, 5];
  Line[Wid]:=CharSet[Typ, 5];

  For n:=y+1 To y+Len-2 Do
    WriteXY(x,n,Color, Line);
END;

PROCEDURE OpenWindow(Wid, Len, Color, Typ: Byte);
VAR x, y : Byte;
BEGIN
  x:=40-(Wid Div 2);
  y:=12-(Len Div 2);
  SaveScreen(x, y, Wid+2, Len+1);
  DrawBox(0, 0, Wid, Len, Color, Typ);
  DrawBoxBorder(0, 0, Wid, Len);
END;

{***************************************************************************}
{ StringIO: allgemeinntzige Funktionen }
{***************************************************************************}

FUNCTION Value(S: String): LongInt;
VAR V      : LongInt;
   {$IFDEF VIRTUALPASCAL}
   Code    : LongInt;
   {$ELSE}
   Code    : Integer;
   {$ENDIF}
BEGIN
  If Length(S)>9 Then Delete(S, 1, Length(S)-9);

  Repeat
    Val(S,V,Code);
    If Code<>0 Then
      If (Length(S)>1) And (Code<Length(S)) Then Delete(S,Code,1)
      Else Begin
        V:=0;
        Code:=0;
      End;
  Until (Code=0) Or (Length(S)=0);

  Value:=V;
END;

FUNCTION UpCase2(C: Char): Char;
BEGIN
  UpCase2:=UpcaseField[Ord(C)];
END;


{$IFDEF OS2}
FUNCTION UpCaseStr(S: String): String;
VAR i: Integer;
BEGIN
  For i:=1 To Length(S) Do
    S[i]:=UpcaseField[Ord(S[i])];

  UpCaseStr:=S;
END;
{$ELSE}
VAR upResult: String;
FUNCTION UpCaseStr(S: String): String;

    Procedure TXlat5(var Source; var Table);assembler;
    asm
        mov  dx, ds       { save ds }
        lds  bx,Table     { load ds:bx with Table address }
        les  di,Source    { load es:di with Source address }
        seges             { override ds segment}
        mov  al,[di]      { load al with length of source }
        xor  ah, ah       { set ah to zero, we need a word for cx }
        mov  cx,ax         { assign length of source to counter }
        jcxz @end         { if cx = 0 exit}
        inc  di           { increment di & skip length byte on 1st pass }
      @filter:
        mov  al,[di]      { load byte in ax from es:di }
        xlat              { tan-xlat-e... }
        mov  [di],al      { send byte to es:di }
        inc  di           { increment di }
        dec  cx
        jnz  @filter      { decrement cx and loop back if cx > 0 }
      @end: mov  ds, dx   { restore ds }
    end;


BEGIN
  upResult:=S;
  txlat5(upResult,upcasefield);
  UpcaseStr:=upResult;
END;
{$ENDIF}

FUNCTION ST(I: LongInt; B: Byte): String;
VAR S: String;
BEGIN
  Str(I:B, S);
  ST:=S;
END;

FUNCTION S(B: Byte): String;
VAR Internal: String;
BEGIN
  Internal[0]:=Char(B);
  FillChar(Internal[1], B, #32);
  S:=Internal;
END;

FUNCTION SOf(C: Char; B: Byte): String;
VAR Internal: String;
BEGIN
  Internal[0]:=Char(B);
  FillChar(Internal[1], B, C);
  SOf:=Internal;
END;

CONST HexChars : Array [0..$F] of Char
               = '0123456789ABCDEF';

FUNCTION Hex(B: Byte): String;
BEGIN
  Hex:=(HexChars[B Shr 4]+HexChars[B And $F])
END;

FUNCTION Hex2Byte(s: S10): Byte;
VAR r, i: Byte;
BEGIN
  If Length(S)<>2 Then Hex2Byte:=0
  Else Begin
    i:=0;
    While (S[1]<>HexChars[i]) And (i<$f) do
      inc(i);

    r:=i shl 4;
    i:=0;
    While (S[2]<>HexChars[i]) And (i<$f) do
      inc(i);

    Hex2Byte:=(r or i);
  End;
END;

FUNCTION LeadingZero(W: LongInt; Anz: Byte): S80;
VAR S : S80;
    n : Byte;
BEGIN
  Str(W:Anz,S);

    n:=1;
    While (S[n]=#32) And (n<=Length(S)) Do Begin
      S[n]:='0';
      Inc(n);
    End;

  LeadingZero:=S;
END;

PROCEDURE CompressStr(Var S: String);
BEGIN
  While Copy(S,1,1)=' ' Do Delete(S,1,1);
  While S[Length(S)]=' ' Do Dec(S[0]);
END;

{***************************************************************************}
{ Datumfunktionen }
{***************************************************************************}

FUNCTION Schaltjahr(jahr:INTEGER):BOOLEAN;
VAR schalt:BOOLEAN;
BEGIN
  IF jahr MOD 4=0 THEN schalt:=TRUE ELSE schalt:=FALSE;
  IF jahr MOD 100=0 THEN schalt:=FALSE;
  IF jahr MOD 400=0 THEN schalt:=TRUE;
  Schaltjahr:=Schalt;
END;

FUNCTION GetDateCounter(DT: tDate): LONGINT;
CONST Monate : Array[1..12] of Byte = (31,28,31,30,31,30,31,31,30,31,30,31);
VAR Count    : WORD;
    AnzTage  : LONGINT;
BEGIN
  AnzTage:=0;

  If (DT.Year>0) And (DT.Month>0) Or (DT.Day>0) Then Begin
    For Count:=1980 To DT.Year-1 Do
     If Schaltjahr(Count) Then Inc(AnzTage,366)
     Else Inc(AnzTage,365);

    For Count:=1 To DT.Month-1 Do
      If Count=2 Then If Schaltjahr(DT.Year) Then Inc(Anztage,29)
                                             Else Inc(anztage,28)
      Else Inc(anztage,Monate[count]);

    Inc(AnzTage,DT.Day);
  End;

  GetDateCounter:=AnzTage;
END;

FUNCTION GetDateDifference(DT1, DT2: TDate): LongInt;
VAR Tage1,Tage2: LongInt;
BEGIN
  Tage1:=GetDateCounter(DT1);
  Tage2:=GetDateCounter(DT2);
  GetDateDifference:=Abs(Tage2-Tage1);
END;

PROCEDURE GetDateDT(Var DT: TDate);
{$IFDEF OS2}
VAR y, m, d, dow : LongInt;
{$ELSE}
VAR y, m, d, dow : Word;
{$ENDIF}
BEGIN
  GetDate(y,m,d,dow);
  DT.Day:=d;
  DT.Month:=m;
  DT.Year:=y;
END;

{***************************************************************************}
{ Uhrzeitfunktionen }
{***************************************************************************}

VAR gtrStartDate : tDate; { zur Erkennung, ob Programm ber 0.00 Uhr-Grenze
                            gelaufen ist. Notwendig, da Zeitdifferenz sonst
                            negative Werte erhalten kann }

FUNCTION GetTimeReal: LongInt;
{$IFDEF OS2}
VAR TH, TM, TS, TS1 : LongInt;
{$ELSE}
VAR TH, TM, TS, TS1 : Word;
{$ENDIF}
    CurrentDate     : tDate;
    DateDifference  : LongInt;
BEGIN
  GetDateDT(CurrentDate);
  If CurrentDate.Day<>gtrStartDate.Day Then
    DateDifference:=LongInt(24) * 36000
  Else
    DateDifference:=0;

  GetTime(TH, TM, TS, TS1);
  GetTimeReal:= (LongInt(TH) * 36000) + (TM * 600) + (TS * 10) + (TS1 Div 10)
                +DateDifference;
END;

{***************************************************************************}
{ und tsch }
{***************************************************************************}

BEGIN
  With ScreenBuf Do Begin
    Next:=NIL;
    x:=0;
    y:=0;
    Wid:=80;
    Len:=25;
    Buf:=NIL;
  End;
  CurWindow:=@ScreenBuf;

  InitCursor;

  GetDateDT(gtrStartDate);
END.
